/*!-----------------------------------------------------------
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Version: 0.44.0-dev-20230919(94c055bcbdd49f04a0fa15515e848542a79fb948)
 * Released under the MIT license
 * https://github.com/microsoft/vscode/blob/main/LICENSE.txt
 *-----------------------------------------------------------*/(function(){var X=["require","exports","vs/editor/common/core/range","vs/editor/common/core/offsetRange","vs/editor/common/core/position","vs/base/common/errors","vs/base/common/strings","vs/base/common/arrays","vs/editor/common/diff/defaultLinesDiffComputer/algorithms/diffAlgorithm","vs/base/common/event","vs/editor/common/core/lineRange","vs/base/common/arraysFind","vs/base/common/assert","vs/base/common/lifecycle","vs/base/common/objects","vs/editor/common/diff/defaultLinesDiffComputer/utils","vs/editor/common/diff/rangeMapping","vs/base/common/platform","vs/base/common/uri","vs/nls","vs/base/common/functional","vs/base/common/iterator","vs/base/common/linkedList","vs/base/common/stopwatch","vs/base/common/diff/diff","vs/base/common/types","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/diff/defaultLinesDiffComputer/algorithms/myersDiffAlgorithm","vs/editor/common/diff/defaultLinesDiffComputer/linesSliceCharSequence","vs/editor/common/diff/linesDiffComputer","vs/base/common/cache","vs/base/common/collections","vs/base/common/color","vs/base/common/diff/diffChange","vs/base/common/keyCodes","vs/base/common/lazy","vs/base/common/cancellation","vs/base/common/hash","vs/base/common/codicons","vs/editor/common/core/selection","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/diff/defaultLinesDiffComputer/heuristicSequenceOptimizations","vs/editor/common/diff/defaultLinesDiffComputer/lineSequence","vs/editor/common/diff/defaultLinesDiffComputer/algorithms/dynamicProgrammingDiffing","vs/editor/common/diff/defaultLinesDiffComputer/computeMovedLines","vs/editor/common/diff/defaultLinesDiffComputer/defaultLinesDiffComputer","vs/editor/common/diff/legacyLinesDiffComputer","vs/editor/common/diff/linesDiffComputers","vs/editor/common/languages/defaultDocumentColorsComputer","vs/editor/common/languages/linkComputer","vs/editor/common/languages/supports/inplaceReplaceSupport","vs/editor/common/model","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/services/unicodeTextModelHighlighter","vs/editor/common/standalone/standaloneEnums","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/platform","vs/nls!vs/base/common/worker/simpleWorker","vs/base/common/process","vs/base/common/path","vs/nls!vs/editor/common/languages","vs/editor/common/languages","vs/editor/common/services/editorBaseApi","vs/base/common/worker/simpleWorker","vs/editor/common/services/editorSimpleWorker"],J=function(T){for(var n=[],M=0,A=T.length;M<A;M++)n[M]=X[T[M]];return n};const Ee=this,Re=typeof global=="object"?global:{};var oe;(function(T){T.global=Ee;class n{get isWindows(){return this._detect(),this._isWindows}get isNode(){return this._detect(),this._isNode}get isElectronRenderer(){return this._detect(),this._isElectronRenderer}get isWebWorker(){return this._detect(),this._isWebWorker}get isElectronNodeIntegrationWebWorker(){return this._detect(),this._isElectronNodeIntegrationWebWorker}constructor(){this._detected=!1,this._isWindows=!1,this._isNode=!1,this._isElectronRenderer=!1,this._isWebWorker=!1,this._isElectronNodeIntegrationWebWorker=!1}_detect(){this._detected||(this._detected=!0,this._isWindows=n._isWindows(),this._isNode=typeof module<"u"&&!!module.exports,this._isElectronRenderer=typeof process<"u"&&typeof process.versions<"u"&&typeof process.versions.electron<"u"&&process.type==="renderer",this._isWebWorker=typeof T.global.importScripts=="function",this._isElectronNodeIntegrationWebWorker=this._isWebWorker&&typeof process<"u"&&typeof process.versions<"u"&&typeof process.versions.electron<"u"&&process.type==="worker")}static _isWindows(){return typeof navigator<"u"&&navigator.userAgent&&navigator.userAgent.indexOf("Windows")>=0?!0:typeof process<"u"?process.platform==="win32":!1}}T.Environment=n})(oe||(oe={}));var oe;(function(T){class n{constructor(c,f,_){this.type=c,this.detail=f,this.timestamp=_}}T.LoaderEvent=n;class M{constructor(c){this._events=[new n(1,"",c)]}record(c,f){this._events.push(new n(c,f,T.Utilities.getHighPerformanceTimestamp()))}getEvents(){return this._events}}T.LoaderEventRecorder=M;class A{record(c,f){}getEvents(){return[]}}A.INSTANCE=new A,T.NullLoaderEventRecorder=A})(oe||(oe={}));var oe;(function(T){class n{static fileUriToFilePath(A,i){if(i=decodeURI(i).replace(/%23/g,"#"),A){if(/^file:\/\/\//.test(i))return i.substr(8);if(/^file:\/\//.test(i))return i.substr(5)}else if(/^file:\/\//.test(i))return i.substr(7);return i}static startsWith(A,i){return A.length>=i.length&&A.substr(0,i.length)===i}static endsWith(A,i){return A.length>=i.length&&A.substr(A.length-i.length)===i}static containsQueryString(A){return/^[^\#]*\?/gi.test(A)}static isAbsolutePath(A){return/^((http:\/\/)|(https:\/\/)|(file:\/\/)|(\/))/.test(A)}static forEachProperty(A,i){if(A){let c;for(c in A)A.hasOwnProperty(c)&&i(c,A[c])}}static isEmpty(A){let i=!0;return n.forEachProperty(A,()=>{i=!1}),i}static recursiveClone(A){if(!A||typeof A!="object"||A instanceof RegExp||!Array.isArray(A)&&Object.getPrototypeOf(A)!==Object.prototype)return A;let i=Array.isArray(A)?[]:{};return n.forEachProperty(A,(c,f)=>{f&&typeof f=="object"?i[c]=n.recursiveClone(f):i[c]=f}),i}static generateAnonymousModule(){return"===anonymous"+n.NEXT_ANONYMOUS_ID+++"==="}static isAnonymousModule(A){return n.startsWith(A,"===anonymous")}static getHighPerformanceTimestamp(){return this.PERFORMANCE_NOW_PROBED||(this.PERFORMANCE_NOW_PROBED=!0,this.HAS_PERFORMANCE_NOW=T.global.performance&&typeof T.global.performance.now=="function"),this.HAS_PERFORMANCE_NOW?T.global.performance.now():Date.now()}}n.NEXT_ANONYMOUS_ID=1,n.PERFORMANCE_NOW_PROBED=!1,n.HAS_PERFORMANCE_NOW=!1,T.Utilities=n})(oe||(oe={}));var oe;(function(T){function n(i){if(i instanceof Error)return i;const c=new Error(i.message||String(i)||"Unknown Error");return i.stack&&(c.stack=i.stack),c}T.ensureError=n;class M{static validateConfigurationOptions(c){function f(_){if(_.phase==="loading"){console.error('Loading "'+_.moduleId+'" failed'),console.error(_),console.error("Here are the modules that depend on it:"),console.error(_.neededBy);return}if(_.phase==="factory"){console.error('The factory function of "'+_.moduleId+'" has thrown an exception'),console.error(_),console.error("Here are the modules that depend on it:"),console.error(_.neededBy);return}}if(c=c||{},typeof c.baseUrl!="string"&&(c.baseUrl=""),typeof c.isBuild!="boolean"&&(c.isBuild=!1),typeof c.paths!="object"&&(c.paths={}),typeof c.config!="object"&&(c.config={}),typeof c.catchError>"u"&&(c.catchError=!1),typeof c.recordStats>"u"&&(c.recordStats=!1),typeof c.urlArgs!="string"&&(c.urlArgs=""),typeof c.onError!="function"&&(c.onError=f),Array.isArray(c.ignoreDuplicateModules)||(c.ignoreDuplicateModules=[]),c.baseUrl.length>0&&(T.Utilities.endsWith(c.baseUrl,"/")||(c.baseUrl+="/")),typeof c.cspNonce!="string"&&(c.cspNonce=""),typeof c.preferScriptTags>"u"&&(c.preferScriptTags=!1),c.nodeCachedData&&typeof c.nodeCachedData=="object"&&(typeof c.nodeCachedData.seed!="string"&&(c.nodeCachedData.seed="seed"),(typeof c.nodeCachedData.writeDelay!="number"||c.nodeCachedData.writeDelay<0)&&(c.nodeCachedData.writeDelay=1e3*7),!c.nodeCachedData.path||typeof c.nodeCachedData.path!="string")){const _=n(new Error("INVALID cached data configuration, 'path' MUST be set"));_.phase="configuration",c.onError(_),c.nodeCachedData=void 0}return c}static mergeConfigurationOptions(c=null,f=null){let _=T.Utilities.recursiveClone(f||{});return T.Utilities.forEachProperty(c,(l,o)=>{l==="ignoreDuplicateModules"&&typeof _.ignoreDuplicateModules<"u"?_.ignoreDuplicateModules=_.ignoreDuplicateModules.concat(o):l==="paths"&&typeof _.paths<"u"?T.Utilities.forEachProperty(o,(C,e)=>_.paths[C]=e):l==="config"&&typeof _.config<"u"?T.Utilities.forEachProperty(o,(C,e)=>_.config[C]=e):_[l]=T.Utilities.recursiveClone(o)}),M.validateConfigurationOptions(_)}}T.ConfigurationOptionsUtil=M;class A{constructor(c,f){if(this._env=c,this.options=M.mergeConfigurationOptions(f),this._createIgnoreDuplicateModulesMap(),this._createSortedPathsRules(),this.options.baseUrl===""&&this.options.nodeRequire&&this.options.nodeRequire.main&&this.options.nodeRequire.main.filename&&this._env.isNode){let _=this.options.nodeRequire.main.filename,l=Math.max(_.lastIndexOf("/"),_.lastIndexOf("\\"));this.options.baseUrl=_.substring(0,l+1)}}_createIgnoreDuplicateModulesMap(){this.ignoreDuplicateModulesMap={};for(let c=0;c<this.options.ignoreDuplicateModules.length;c++)this.ignoreDuplicateModulesMap[this.options.ignoreDuplicateModules[c]]=!0}_createSortedPathsRules(){this.sortedPathsRules=[],T.Utilities.forEachProperty(this.options.paths,(c,f)=>{Array.isArray(f)?this.sortedPathsRules.push({from:c,to:f}):this.sortedPathsRules.push({from:c,to:[f]})}),this.sortedPathsRules.sort((c,f)=>f.from.length-c.from.length)}cloneAndMerge(c){return new A(this._env,M.mergeConfigurationOptions(c,this.options))}getOptionsLiteral(){return this.options}_applyPaths(c){let f;for(let _=0,l=this.sortedPathsRules.length;_<l;_++)if(f=this.sortedPathsRules[_],T.Utilities.startsWith(c,f.from)){let o=[];for(let C=0,e=f.to.length;C<e;C++)o.push(f.to[C]+c.substr(f.from.length));return o}return[c]}_addUrlArgsToUrl(c){return T.Utilities.containsQueryString(c)?c+"&"+this.options.urlArgs:c+"?"+this.options.urlArgs}_addUrlArgsIfNecessaryToUrl(c){return this.options.urlArgs?this._addUrlArgsToUrl(c):c}_addUrlArgsIfNecessaryToUrls(c){if(this.options.urlArgs)for(let f=0,_=c.length;f<_;f++)c[f]=this._addUrlArgsToUrl(c[f]);return c}moduleIdToPaths(c){if(this._env.isNode&&this.options.amdModulesPattern instanceof RegExp&&!this.options.amdModulesPattern.test(c))return this.isBuild()?["empty:"]:["node|"+c];let f=c,_;if(!T.Utilities.endsWith(f,".js")&&!T.Utilities.isAbsolutePath(f)){_=this._applyPaths(f);for(let l=0,o=_.length;l<o;l++)this.isBuild()&&_[l]==="empty:"||(T.Utilities.isAbsolutePath(_[l])||(_[l]=this.options.baseUrl+_[l]),!T.Utilities.endsWith(_[l],".js")&&!T.Utilities.containsQueryString(_[l])&&(_[l]=_[l]+".js"))}else!T.Utilities.endsWith(f,".js")&&!T.Utilities.containsQueryString(f)&&(f=f+".js"),_=[f];return this._addUrlArgsIfNecessaryToUrls(_)}requireToUrl(c){let f=c;return T.Utilities.isAbsolutePath(f)||(f=this._applyPaths(f)[0],T.Utilities.isAbsolutePath(f)||(f=this.options.baseUrl+f)),this._addUrlArgsIfNecessaryToUrl(f)}isBuild(){return this.options.isBuild}shouldInvokeFactory(c){return!!(!this.options.isBuild||T.Utilities.isAnonymousModule(c)||this.options.buildForceInvokeFactory&&this.options.buildForceInvokeFactory[c])}isDuplicateMessageIgnoredFor(c){return this.ignoreDuplicateModulesMap.hasOwnProperty(c)}getConfigForModule(c){if(this.options.config)return this.options.config[c]}shouldCatchError(){return this.options.catchError}shouldRecordStats(){return this.options.recordStats}onError(c){this.options.onError(c)}}T.Configuration=A})(oe||(oe={}));var oe;(function(T){class n{constructor(o){this._env=o,this._scriptLoader=null,this._callbackMap={}}load(o,C,e,m){if(!this._scriptLoader)if(this._env.isWebWorker)this._scriptLoader=new i;else if(this._env.isElectronRenderer){const{preferScriptTags:u}=o.getConfig().getOptionsLiteral();u?this._scriptLoader=new M:this._scriptLoader=new c(this._env)}else this._env.isNode?this._scriptLoader=new c(this._env):this._scriptLoader=new M;let g={callback:e,errorback:m};if(this._callbackMap.hasOwnProperty(C)){this._callbackMap[C].push(g);return}this._callbackMap[C]=[g],this._scriptLoader.load(o,C,()=>this.triggerCallback(C),u=>this.triggerErrorback(C,u))}triggerCallback(o){let C=this._callbackMap[o];delete this._callbackMap[o];for(let e=0;e<C.length;e++)C[e].callback()}triggerErrorback(o,C){let e=this._callbackMap[o];delete this._callbackMap[o];for(let m=0;m<e.length;m++)e[m].errorback(C)}}class M{attachListeners(o,C,e){let m=()=>{o.removeEventListener("load",g),o.removeEventListener("error",u)},g=b=>{m(),C()},u=b=>{m(),e(b)};o.addEventListener("load",g),o.addEventListener("error",u)}load(o,C,e,m){if(/^node\|/.test(C)){let g=o.getConfig().getOptionsLiteral(),u=f(o.getRecorder(),g.nodeRequire||T.global.nodeRequire),b=C.split("|"),h=null;try{h=u(b[1])}catch(S){m(S);return}o.enqueueDefineAnonymousModule([],()=>h),e()}else{let g=document.createElement("script");g.setAttribute("async","async"),g.setAttribute("type","text/javascript"),this.attachListeners(g,e,m);const{trustedTypesPolicy:u}=o.getConfig().getOptionsLiteral();u&&(C=u.createScriptURL(C)),g.setAttribute("src",C);const{cspNonce:b}=o.getConfig().getOptionsLiteral();b&&g.setAttribute("nonce",b),document.getElementsByTagName("head")[0].appendChild(g)}}}function A(l){const{trustedTypesPolicy:o}=l.getConfig().getOptionsLiteral();try{return(o?self.eval(o.createScript("","true")):new Function("true")).call(self),!0}catch{return!1}}class i{constructor(){this._cachedCanUseEval=null}_canUseEval(o){return this._cachedCanUseEval===null&&(this._cachedCanUseEval=A(o)),this._cachedCanUseEval}load(o,C,e,m){if(/^node\|/.test(C)){const g=o.getConfig().getOptionsLiteral(),u=f(o.getRecorder(),g.nodeRequire||T.global.nodeRequire),b=C.split("|");let h=null;try{h=u(b[1])}catch(S){m(S);return}o.enqueueDefineAnonymousModule([],function(){return h}),e()}else{const{trustedTypesPolicy:g}=o.getConfig().getOptionsLiteral();if(!(/^((http:)|(https:)|(file:))/.test(C)&&C.substring(0,self.origin.length)!==self.origin)&&this._canUseEval(o)){fetch(C).then(b=>{if(b.status!==200)throw new Error(b.statusText);return b.text()}).then(b=>{b=`${b}
//# sourceURL=${C}`,(g?self.eval(g.createScript("",b)):new Function(b)).call(self),e()}).then(void 0,m);return}try{g&&(C=g.createScriptURL(C)),importScripts(C),e()}catch(b){m(b)}}}}class c{constructor(o){this._env=o,this._didInitialize=!1,this._didPatchNodeRequire=!1}_init(o){this._didInitialize||(this._didInitialize=!0,this._fs=o("fs"),this._vm=o("vm"),this._path=o("path"),this._crypto=o("crypto"))}_initNodeRequire(o,C){const{nodeCachedData:e}=C.getConfig().getOptionsLiteral();if(!e||this._didPatchNodeRequire)return;this._didPatchNodeRequire=!0;const m=this,g=o("module");function u(b){const h=b.constructor;let S=function(N){try{return b.require(N)}finally{}};return S.resolve=function(N,y){return h._resolveFilename(N,b,!1,y)},S.resolve.paths=function(N){return h._resolveLookupPaths(N,b)},S.main=process.mainModule,S.extensions=h._extensions,S.cache=h._cache,S}g.prototype._compile=function(b,h){const S=g.wrap(b.replace(/^#!.*/,"")),v=C.getRecorder(),N=m._getCachedDataPath(e,h),y={filename:h};let L;try{const E=m._fs.readFileSync(N);L=E.slice(0,16),y.cachedData=E.slice(16),v.record(60,N)}catch{v.record(61,N)}const r=new m._vm.Script(S,y),s=r.runInThisContext(y),a=m._path.dirname(h),p=u(this),d=[this.exports,p,this,h,a,process,Re,Buffer],w=s.apply(this.exports,d);return m._handleCachedData(r,S,N,!y.cachedData,C),m._verifyCachedData(r,S,N,L,C),w}}load(o,C,e,m){const g=o.getConfig().getOptionsLiteral(),u=f(o.getRecorder(),g.nodeRequire||T.global.nodeRequire),b=g.nodeInstrumenter||function(S){return S};this._init(u),this._initNodeRequire(u,o);let h=o.getRecorder();if(/^node\|/.test(C)){let S=C.split("|"),v=null;try{v=u(S[1])}catch(N){m(N);return}o.enqueueDefineAnonymousModule([],()=>v),e()}else{C=T.Utilities.fileUriToFilePath(this._env.isWindows,C);const S=this._path.normalize(C),v=this._getElectronRendererScriptPathOrUri(S),N=!!g.nodeCachedData,y=N?this._getCachedDataPath(g.nodeCachedData,C):void 0;this._readSourceAndCachedData(S,y,h,(L,r,s,a)=>{if(L){m(L);return}let p;r.charCodeAt(0)===c._BOM?p=c._PREFIX+r.substring(1)+c._SUFFIX:p=c._PREFIX+r+c._SUFFIX,p=b(p,S);const d={filename:v,cachedData:s},w=this._createAndEvalScript(o,p,d,e,m);this._handleCachedData(w,p,y,N&&!s,o),this._verifyCachedData(w,p,y,a,o)})}}_createAndEvalScript(o,C,e,m,g){const u=o.getRecorder();u.record(31,e.filename);const b=new this._vm.Script(C,e),h=b.runInThisContext(e),S=o.getGlobalAMDDefineFunc();let v=!1;const N=function(){return v=!0,S.apply(null,arguments)};return N.amd=S.amd,h.call(T.global,o.getGlobalAMDRequireFunc(),N,e.filename,this._path.dirname(e.filename)),u.record(32,e.filename),v?m():g(new Error(`Didn't receive define call in ${e.filename}!`)),b}_getElectronRendererScriptPathOrUri(o){if(!this._env.isElectronRenderer)return o;let C=o.match(/^([a-z])\:(.*)/i);return C?`file:///${(C[1].toUpperCase()+":"+C[2]).replace(/\\/g,"/")}`:`file://${o}`}_getCachedDataPath(o,C){const e=this._crypto.createHash("md5").update(C,"utf8").update(o.seed,"utf8").update(process.arch,"").digest("hex"),m=this._path.basename(C).replace(/\.js$/,"");return this._path.join(o.path,`${m}-${e}.code`)}_handleCachedData(o,C,e,m,g){o.cachedDataRejected?this._fs.unlink(e,u=>{g.getRecorder().record(62,e),this._createAndWriteCachedData(o,C,e,g),u&&g.getConfig().onError(u)}):m&&this._createAndWriteCachedData(o,C,e,g)}_createAndWriteCachedData(o,C,e,m){let g=Math.ceil(m.getConfig().getOptionsLiteral().nodeCachedData.writeDelay*(1+Math.random())),u=-1,b=0,h;const S=()=>{setTimeout(()=>{h||(h=this._crypto.createHash("md5").update(C,"utf8").digest());const v=o.createCachedData();if(!(v.length===0||v.length===u||b>=5)){if(v.length<u){S();return}u=v.length,this._fs.writeFile(e,Buffer.concat([h,v]),N=>{N&&m.getConfig().onError(N),m.getRecorder().record(63,e),S()})}},g*Math.pow(4,b++))};S()}_readSourceAndCachedData(o,C,e,m){if(!C)this._fs.readFile(o,{encoding:"utf8"},m);else{let g,u,b,h=2;const S=v=>{v?m(v):--h===0&&m(void 0,g,u,b)};this._fs.readFile(o,{encoding:"utf8"},(v,N)=>{g=N,S(v)}),this._fs.readFile(C,(v,N)=>{!v&&N&&N.length>0?(b=N.slice(0,16),u=N.slice(16),e.record(60,C)):e.record(61,C),S()})}}_verifyCachedData(o,C,e,m,g){m&&(o.cachedDataRejected||setTimeout(()=>{const u=this._crypto.createHash("md5").update(C,"utf8").digest();m.equals(u)||(g.getConfig().onError(new Error(`FAILED TO VERIFY CACHED DATA, deleting stale '${e}' now, but a RESTART IS REQUIRED`)),this._fs.unlink(e,b=>{b&&g.getConfig().onError(b)}))},Math.ceil(5e3*(1+Math.random()))))}}c._BOM=65279,c._PREFIX="(function (require, define, __filename, __dirname) { ",c._SUFFIX=`
});`;function f(l,o){if(o.__$__isRecorded)return o;const C=function(m){l.record(33,m);try{return o(m)}finally{l.record(34,m)}};return C.__$__isRecorded=!0,C}T.ensureRecordedNodeRequire=f;function _(l){return new n(l)}T.createScriptLoader=_})(oe||(oe={}));var oe;(function(T){class n{constructor(l){let o=l.lastIndexOf("/");o!==-1?this.fromModulePath=l.substr(0,o+1):this.fromModulePath=""}static _normalizeModuleId(l){let o=l,C;for(C=/\/\.\//;C.test(o);)o=o.replace(C,"/");for(o=o.replace(/^\.\//g,""),C=/\/(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//;C.test(o);)o=o.replace(C,"/");return o=o.replace(/^(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//,""),o}resolveModule(l){let o=l;return T.Utilities.isAbsolutePath(o)||(T.Utilities.startsWith(o,"./")||T.Utilities.startsWith(o,"../"))&&(o=n._normalizeModuleId(this.fromModulePath+o)),o}}n.ROOT=new n(""),T.ModuleIdResolver=n;class M{constructor(l,o,C,e,m,g){this.id=l,this.strId=o,this.dependencies=C,this._callback=e,this._errorback=m,this.moduleIdResolver=g,this.exports={},this.error=null,this.exportsPassedIn=!1,this.unresolvedDependenciesCount=this.dependencies.length,this._isComplete=!1}static _safeInvokeFunction(l,o){try{return{returnedValue:l.apply(T.global,o),producedError:null}}catch(C){return{returnedValue:null,producedError:C}}}static _invokeFactory(l,o,C,e){return l.shouldInvokeFactory(o)?l.shouldCatchError()?this._safeInvokeFunction(C,e):{returnedValue:C.apply(T.global,e),producedError:null}:{returnedValue:null,producedError:null}}complete(l,o,C,e){this._isComplete=!0;let m=null;if(this._callback)if(typeof this._callback=="function"){l.record(21,this.strId);let g=M._invokeFactory(o,this.strId,this._callback,C);m=g.producedError,l.record(22,this.strId),!m&&typeof g.returnedValue<"u"&&(!this.exportsPassedIn||T.Utilities.isEmpty(this.exports))&&(this.exports=g.returnedValue)}else this.exports=this._callback;if(m){let g=T.ensureError(m);g.phase="factory",g.moduleId=this.strId,g.neededBy=e(this.id),this.error=g,o.onError(g)}this.dependencies=null,this._callback=null,this._errorback=null,this.moduleIdResolver=null}onDependencyError(l){return this._isComplete=!0,this.error=l,this._errorback?(this._errorback(l),!0):!1}isComplete(){return this._isComplete}}T.Module=M;class A{constructor(){this._nextId=0,this._strModuleIdToIntModuleId=new Map,this._intModuleIdToStrModuleId=[],this.getModuleId("exports"),this.getModuleId("module"),this.getModuleId("require")}getMaxModuleId(){return this._nextId}getModuleId(l){let o=this._strModuleIdToIntModuleId.get(l);return typeof o>"u"&&(o=this._nextId++,this._strModuleIdToIntModuleId.set(l,o),this._intModuleIdToStrModuleId[o]=l),o}getStrModuleId(l){return this._intModuleIdToStrModuleId[l]}}class i{constructor(l){this.id=l}}i.EXPORTS=new i(0),i.MODULE=new i(1),i.REQUIRE=new i(2),T.RegularDependency=i;class c{constructor(l,o,C){this.id=l,this.pluginId=o,this.pluginParam=C}}T.PluginDependency=c;class f{constructor(l,o,C,e,m=0){this._env=l,this._scriptLoader=o,this._loaderAvailableTimestamp=m,this._defineFunc=C,this._requireFunc=e,this._moduleIdProvider=new A,this._config=new T.Configuration(this._env),this._hasDependencyCycle=!1,this._modules2=[],this._knownModules2=[],this._inverseDependencies2=[],this._inversePluginDependencies2=new Map,this._currentAnonymousDefineCall=null,this._recorder=null,this._buildInfoPath=[],this._buildInfoDefineStack=[],this._buildInfoDependencies=[],this._requireFunc.moduleManager=this}reset(){return new f(this._env,this._scriptLoader,this._defineFunc,this._requireFunc,this._loaderAvailableTimestamp)}getGlobalAMDDefineFunc(){return this._defineFunc}getGlobalAMDRequireFunc(){return this._requireFunc}static _findRelevantLocationInStack(l,o){let C=g=>g.replace(/\\/g,"/"),e=C(l),m=o.split(/\n/);for(let g=0;g<m.length;g++){let u=m[g].match(/(.*):(\d+):(\d+)\)?$/);if(u){let b=u[1],h=u[2],S=u[3],v=Math.max(b.lastIndexOf(" ")+1,b.lastIndexOf("(")+1);if(b=b.substr(v),b=C(b),b===e){let N={line:parseInt(h,10),col:parseInt(S,10)};return N.line===1&&(N.col-=53),N}}}throw new Error("Could not correlate define call site for needle "+l)}getBuildInfo(){if(!this._config.isBuild())return null;let l=[],o=0;for(let C=0,e=this._modules2.length;C<e;C++){let m=this._modules2[C];if(!m)continue;let g=this._buildInfoPath[m.id]||null,u=this._buildInfoDefineStack[m.id]||null,b=this._buildInfoDependencies[m.id];l[o++]={id:m.strId,path:g,defineLocation:g&&u?f._findRelevantLocationInStack(g,u):null,dependencies:b,shim:null,exports:m.exports}}return l}getRecorder(){return this._recorder||(this._config.shouldRecordStats()?this._recorder=new T.LoaderEventRecorder(this._loaderAvailableTimestamp):this._recorder=T.NullLoaderEventRecorder.INSTANCE),this._recorder}getLoaderEvents(){return this.getRecorder().getEvents()}enqueueDefineAnonymousModule(l,o){if(this._currentAnonymousDefineCall!==null)throw new Error("Can only have one anonymous define call per script file");let C=null;this._config.isBuild()&&(C=new Error("StackLocation").stack||null),this._currentAnonymousDefineCall={stack:C,dependencies:l,callback:o}}defineModule(l,o,C,e,m,g=new n(l)){let u=this._moduleIdProvider.getModuleId(l);if(this._modules2[u]){this._config.isDuplicateMessageIgnoredFor(l)||console.warn("Duplicate definition of module '"+l+"'");return}let b=new M(u,l,this._normalizeDependencies(o,g),C,e,g);this._modules2[u]=b,this._config.isBuild()&&(this._buildInfoDefineStack[u]=m,this._buildInfoDependencies[u]=(b.dependencies||[]).map(h=>this._moduleIdProvider.getStrModuleId(h.id))),this._resolve(b)}_normalizeDependency(l,o){if(l==="exports")return i.EXPORTS;if(l==="module")return i.MODULE;if(l==="require")return i.REQUIRE;let C=l.indexOf("!");if(C>=0){let e=o.resolveModule(l.substr(0,C)),m=o.resolveModule(l.substr(C+1)),g=this._moduleIdProvider.getModuleId(e+"!"+m),u=this._moduleIdProvider.getModuleId(e);return new c(g,u,m)}return new i(this._moduleIdProvider.getModuleId(o.resolveModule(l)))}_normalizeDependencies(l,o){let C=[],e=0;for(let m=0,g=l.length;m<g;m++)C[e++]=this._normalizeDependency(l[m],o);return C}_relativeRequire(l,o,C,e){if(typeof o=="string")return this.synchronousRequire(o,l);this.defineModule(T.Utilities.generateAnonymousModule(),o,C,e,null,l)}synchronousRequire(l,o=new n(l)){let C=this._normalizeDependency(l,o),e=this._modules2[C.id];if(!e)throw new Error("Check dependency list! Synchronous require cannot resolve module '"+l+"'. This is the first mention of this module!");if(!e.isComplete())throw new Error("Check dependency list! Synchronous require cannot resolve module '"+l+"'. This module has not been resolved completely yet.");if(e.error)throw e.error;return e.exports}configure(l,o){let C=this._config.shouldRecordStats();o?this._config=new T.Configuration(this._env,l):this._config=this._config.cloneAndMerge(l),this._config.shouldRecordStats()&&!C&&(this._recorder=null)}getConfig(){return this._config}_onLoad(l){if(this._currentAnonymousDefineCall!==null){let o=this._currentAnonymousDefineCall;this._currentAnonymousDefineCall=null,this.defineModule(this._moduleIdProvider.getStrModuleId(l),o.dependencies,o.callback,null,o.stack)}}_createLoadError(l,o){let C=this._moduleIdProvider.getStrModuleId(l),e=(this._inverseDependencies2[l]||[]).map(g=>this._moduleIdProvider.getStrModuleId(g));const m=T.ensureError(o);return m.phase="loading",m.moduleId=C,m.neededBy=e,m}_onLoadError(l,o){const C=this._createLoadError(l,o);this._modules2[l]||(this._modules2[l]=new M(l,this._moduleIdProvider.getStrModuleId(l),[],()=>{},null,null));let e=[];for(let u=0,b=this._moduleIdProvider.getMaxModuleId();u<b;u++)e[u]=!1;let m=!1,g=[];for(g.push(l),e[l]=!0;g.length>0;){let u=g.shift(),b=this._modules2[u];b&&(m=b.onDependencyError(C)||m);let h=this._inverseDependencies2[u];if(h)for(let S=0,v=h.length;S<v;S++){let N=h[S];e[N]||(g.push(N),e[N]=!0)}}m||this._config.onError(C)}_hasDependencyPath(l,o){let C=this._modules2[l];if(!C)return!1;let e=[];for(let g=0,u=this._moduleIdProvider.getMaxModuleId();g<u;g++)e[g]=!1;let m=[];for(m.push(C),e[l]=!0;m.length>0;){let u=m.shift().dependencies;if(u)for(let b=0,h=u.length;b<h;b++){let S=u[b];if(S.id===o)return!0;let v=this._modules2[S.id];v&&!e[S.id]&&(e[S.id]=!0,m.push(v))}}return!1}_findCyclePath(l,o,C){if(l===o||C===50)return[l];let e=this._modules2[l];if(!e)return null;let m=e.dependencies;if(m)for(let g=0,u=m.length;g<u;g++){let b=this._findCyclePath(m[g].id,o,C+1);if(b!==null)return b.push(l),b}return null}_createRequire(l){let o=(C,e,m)=>this._relativeRequire(l,C,e,m);return o.toUrl=C=>this._config.requireToUrl(l.resolveModule(C)),o.getStats=()=>this.getLoaderEvents(),o.hasDependencyCycle=()=>this._hasDependencyCycle,o.config=(C,e=!1)=>{this.configure(C,e)},o.__$__nodeRequire=T.global.nodeRequire,o}_loadModule(l){if(this._modules2[l]||this._knownModules2[l])return;this._knownModules2[l]=!0;let o=this._moduleIdProvider.getStrModuleId(l),C=this._config.moduleIdToPaths(o),e=/^@[^\/]+\/[^\/]+$/;this._env.isNode&&(o.indexOf("/")===-1||e.test(o))&&C.push("node|"+o);let m=-1,g=u=>{if(m++,m>=C.length)this._onLoadError(l,u);else{let b=C[m],h=this.getRecorder();if(this._config.isBuild()&&b==="empty:"){this._buildInfoPath[l]=b,this.defineModule(this._moduleIdProvider.getStrModuleId(l),[],null,null,null),this._onLoad(l);return}h.record(10,b),this._scriptLoader.load(this,b,()=>{this._config.isBuild()&&(this._buildInfoPath[l]=b),h.record(11,b),this._onLoad(l)},S=>{h.record(12,b),g(S)})}};g(null)}_loadPluginDependency(l,o){if(this._modules2[o.id]||this._knownModules2[o.id])return;this._knownModules2[o.id]=!0;let C=e=>{this.defineModule(this._moduleIdProvider.getStrModuleId(o.id),[],e,null,null)};C.error=e=>{this._config.onError(this._createLoadError(o.id,e))},l.load(o.pluginParam,this._createRequire(n.ROOT),C,this._config.getOptionsLiteral())}_resolve(l){let o=l.dependencies;if(o)for(let C=0,e=o.length;C<e;C++){let m=o[C];if(m===i.EXPORTS){l.exportsPassedIn=!0,l.unresolvedDependenciesCount--;continue}if(m===i.MODULE){l.unresolvedDependenciesCount--;continue}if(m===i.REQUIRE){l.unresolvedDependenciesCount--;continue}let g=this._modules2[m.id];if(g&&g.isComplete()){if(g.error){l.onDependencyError(g.error);return}l.unresolvedDependenciesCount--;continue}if(this._hasDependencyPath(m.id,l.id)){this._hasDependencyCycle=!0,console.warn("There is a dependency cycle between '"+this._moduleIdProvider.getStrModuleId(m.id)+"' and '"+this._moduleIdProvider.getStrModuleId(l.id)+"'. The cyclic path follows:");let u=this._findCyclePath(m.id,l.id,0)||[];u.reverse(),u.push(m.id),console.warn(u.map(b=>this._moduleIdProvider.getStrModuleId(b)).join(` => 
`)),l.unresolvedDependenciesCount--;continue}if(this._inverseDependencies2[m.id]=this._inverseDependencies2[m.id]||[],this._inverseDependencies2[m.id].push(l.id),m instanceof c){let u=this._modules2[m.pluginId];if(u&&u.isComplete()){this._loadPluginDependency(u.exports,m);continue}let b=this._inversePluginDependencies2.get(m.pluginId);b||(b=[],this._inversePluginDependencies2.set(m.pluginId,b)),b.push(m),this._loadModule(m.pluginId);continue}this._loadModule(m.id)}l.unresolvedDependenciesCount===0&&this._onModuleComplete(l)}_onModuleComplete(l){let o=this.getRecorder();if(l.isComplete())return;let C=l.dependencies,e=[];if(C)for(let b=0,h=C.length;b<h;b++){let S=C[b];if(S===i.EXPORTS){e[b]=l.exports;continue}if(S===i.MODULE){e[b]={id:l.strId,config:()=>this._config.getConfigForModule(l.strId)};continue}if(S===i.REQUIRE){e[b]=this._createRequire(l.moduleIdResolver);continue}let v=this._modules2[S.id];if(v){e[b]=v.exports;continue}e[b]=null}const m=b=>(this._inverseDependencies2[b]||[]).map(h=>this._moduleIdProvider.getStrModuleId(h));l.complete(o,this._config,e,m);let g=this._inverseDependencies2[l.id];if(this._inverseDependencies2[l.id]=null,g)for(let b=0,h=g.length;b<h;b++){let S=g[b],v=this._modules2[S];v.unresolvedDependenciesCount--,v.unresolvedDependenciesCount===0&&this._onModuleComplete(v)}let u=this._inversePluginDependencies2.get(l.id);if(u){this._inversePluginDependencies2.delete(l.id);for(let b=0,h=u.length;b<h;b++)this._loadPluginDependency(l.exports,u[b])}}}T.ModuleManager=f})(oe||(oe={}));var Y,oe;(function(T){const n=new T.Environment;let M=null;const A=function(_,l,o){typeof _!="string"&&(o=l,l=_,_=null),(typeof l!="object"||!Array.isArray(l))&&(o=l,l=null),l||(l=["require","exports","module"]),_?M.defineModule(_,l,o,null,null):M.enqueueDefineAnonymousModule(l,o)};A.amd={jQuery:!0};const i=function(_,l=!1){M.configure(_,l)},c=function(){if(arguments.length===1){if(arguments[0]instanceof Object&&!Array.isArray(arguments[0])){i(arguments[0]);return}if(typeof arguments[0]=="string")return M.synchronousRequire(arguments[0])}if((arguments.length===2||arguments.length===3)&&Array.isArray(arguments[0])){M.defineModule(T.Utilities.generateAnonymousModule(),arguments[0],arguments[1],arguments[2],null);return}throw new Error("Unrecognized require call")};c.config=i,c.getConfig=function(){return M.getConfig().getOptionsLiteral()},c.reset=function(){M=M.reset()},c.getBuildInfo=function(){return M.getBuildInfo()},c.getStats=function(){return M.getLoaderEvents()},c.define=A;function f(){if(typeof T.global.require<"u"||typeof require<"u"){const _=T.global.require||require;if(typeof _=="function"&&typeof _.resolve=="function"){const l=T.ensureRecordedNodeRequire(M.getRecorder(),_);T.global.nodeRequire=l,c.nodeRequire=l,c.__$__nodeRequire=l}}n.isNode&&!n.isElectronRenderer&&!n.isElectronNodeIntegrationWebWorker?module.exports=c:(n.isElectronRenderer||(T.global.define=A),T.global.require=c)}T.init=f,(typeof T.global.define!="function"||!T.global.define.amd)&&(M=new T.ModuleManager(n,T.createScriptLoader(n),A,c,T.Utilities.getHighPerformanceTimestamp()),typeof T.global.require<"u"&&typeof T.global.require!="function"&&c.config(T.global.require),Y=function(){return A.apply(null,arguments)},Y.amd=A.amd,typeof doNotInitLoader>"u"&&f())})(oe||(oe={}));var ue=this&&this.__awaiter||function(T,n,M,A){function i(c){return c instanceof M?c:new M(function(f){f(c)})}return new(M||(M=Promise))(function(c,f){function _(C){try{o(A.next(C))}catch(e){f(e)}}function l(C){try{o(A.throw(C))}catch(e){f(e)}}function o(C){C.done?c(C.value):i(C.value).then(_,l)}o((A=A.apply(T,n||[])).next())})};Y(X[19],J([0,1]),function(T,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.load=n.create=n.setPseudoTranslation=n.getConfiguredDefaultLocale=n.localize=void 0;let M=typeof document<"u"&&document.location&&document.location.hash.indexOf("pseudo=true")>=0;const A="i-default";function i(u,b){let h;return b.length===0?h=u:h=u.replace(/\{(\d+)\}/g,(S,v)=>{const N=v[0],y=b[N];let L=S;return typeof y=="string"?L=y:(typeof y=="number"||typeof y=="boolean"||y===void 0||y===null)&&(L=String(y)),L}),M&&(h="\uFF3B"+h.replace(/[aouei]/g,"$&$&")+"\uFF3D"),h}function c(u,b){let h=u[b];return h||(h=u["*"],h)?h:null}function f(u){return u.charAt(u.length-1)==="/"?u:u+"/"}function _(u,b,h){return ue(this,void 0,void 0,function*(){const S=f(u)+f(b)+"vscode/"+f(h),v=yield fetch(S);if(v.ok)return yield v.json();throw new Error(`${v.status} - ${v.statusText}`)})}function l(u){return function(b,h){const S=Array.prototype.slice.call(arguments,2);return i(u[b],S)}}function o(u,b,...h){return i(b,h)}n.localize=o;function C(u){}n.getConfiguredDefaultLocale=C;function e(u){M=u}n.setPseudoTranslation=e;function m(u,b){var h;return{localize:l(b[u]),getConfiguredDefaultLocale:(h=b.getConfiguredDefaultLocale)!==null&&h!==void 0?h:S=>{}}}n.create=m;function g(u,b,h,S){var v;const N=(v=S["vs/nls"])!==null&&v!==void 0?v:{};if(!u||u.length===0)return h({localize:o,getConfiguredDefaultLocale:()=>{var a;return(a=N.availableLanguages)===null||a===void 0?void 0:a["*"]}});const y=N.availableLanguages?c(N.availableLanguages,u):null,L=y===null||y===A;let r=".nls";L||(r=r+"."+y);const s=a=>{Array.isArray(a)?a.localize=l(a):a.localize=l(a[u]),a.getConfiguredDefaultLocale=()=>{var p;return(p=N.availableLanguages)===null||p===void 0?void 0:p["*"]},h(a)};typeof N.loadBundle=="function"?N.loadBundle(u,y,(a,p)=>{a?b([u+".nls"],s):s(p)}):N.translationServiceUrl&&!L?ue(this,void 0,void 0,function*(){var a;try{const p=yield _(N.translationServiceUrl,y,u);return s(p)}catch(p){if(!y.includes("-"))return console.error(p),b([u+".nls"],s);try{const d=y.split("-")[0],w=yield _(N.translationServiceUrl,d,u);return(a=N.availableLanguages)!==null&&a!==void 0||(N.availableLanguages={}),N.availableLanguages["*"]=d,s(w)}catch(d){return console.error(d),b([u+".nls"],s)}}}):b([u+r],s,a=>{if(r===".nls"){console.error("Failed trying to load default language strings",a);return}console.error(`Failed to load message bundle for language ${y}. Falling back to the default language:`,a),b([u+".nls"],s)})}n.load=g}),function(){const T=globalThis.MonacoEnvironment,n=T&&T.baseUrl?T.baseUrl:"../../../";function M(C,e){var m;if(T?.createTrustedTypesPolicy)try{return T.createTrustedTypesPolicy(C,e)}catch(g){console.warn(g);return}try{return(m=self.trustedTypes)===null||m===void 0?void 0:m.createPolicy(C,e)}catch(g){console.warn(g);return}}const A=M("amdLoader",{createScriptURL:C=>C,createScript:(C,...e)=>{const m=e.slice(0,-1).join(","),g=e.pop().toString();return`(function anonymous(${m}) { ${g}
})`}});function i(){try{return(A?globalThis.eval(A.createScript("","true")):new Function("true")).call(globalThis),!0}catch{return!1}}function c(){return new Promise((C,e)=>{if(typeof globalThis.define=="function"&&globalThis.define.amd)return C();const m=n+"vs/loader.js";if(!(/^((http:)|(https:)|(file:))/.test(m)&&m.substring(0,globalThis.origin.length)!==globalThis.origin)&&i()){fetch(m).then(u=>{if(u.status!==200)throw new Error(u.statusText);return u.text()}).then(u=>{u=`${u}
//# sourceURL=${m}`,(A?globalThis.eval(A.createScript("",u)):new Function(u)).call(globalThis),C()}).then(void 0,e);return}A?importScripts(A.createScriptURL(m)):importScripts(m),C()})}function f(){require.config({baseUrl:n,catchError:!0,trustedTypesPolicy:A,amdModulesPattern:/^vs\//})}function _(C){c().then(()=>{f(),require([C],function(e){setTimeout(function(){const m=e.create((g,u)=>{globalThis.postMessage(g,u)},null);for(globalThis.onmessage=g=>m.onmessage(g.data,g.ports);o.length>0;){const g=o.shift();m.onmessage(g.data,g.ports)}},0)})})}typeof globalThis.define=="function"&&globalThis.define.amd&&f();let l=!0;const o=[];globalThis.onmessage=C=>{if(!l){o.push(C);return}l=!1,_(C.data)}}(),Y(X[7],J([0,1]),function(T,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.CallbackIterable=n.ArrayQueue=n.reverseOrder=n.booleanComparator=n.numberComparator=n.tieBreakComparators=n.compareBy=n.CompareResult=n.splice=n.insertInto=n.asArray=n.pushMany=n.pushToEnd=n.pushToStart=n.arrayInsert=n.range=n.firstOrDefault=n.distinct=n.isNonEmptyArray=n.isFalsyOrEmpty=n.coalesceInPlace=n.coalesce=n.forEachWithNeighbors=n.forEachAdjacent=n.groupAdjacentBy=n.groupBy=n.quickSelect=n.binarySearch2=n.binarySearch=n.removeFastWithoutKeepingOrder=n.equals=n.tail2=n.tail=void 0;function M(k,q=0){return k[k.length-(1+q)]}n.tail=M;function A(k){if(k.length===0)throw new Error("Invalid tail call");return[k.slice(0,k.length-1),k[k.length-1]]}n.tail2=A;function i(k,q,x=(H,V)=>H===V){if(k===q)return!0;if(!k||!q||k.length!==q.length)return!1;for(let H=0,V=k.length;H<V;H++)if(!x(k[H],q[H]))return!1;return!0}n.equals=i;function c(k,q){const x=k.length-1;q<x&&(k[q]=k[x]),k.pop()}n.removeFastWithoutKeepingOrder=c;function f(k,q,x){return _(k.length,H=>x(k[H],q))}n.binarySearch=f;function _(k,q){let x=0,H=k-1;for(;x<=H;){const V=(x+H)/2|0,t=q(V);if(t<0)x=V+1;else if(t>0)H=V-1;else return V}return-(x+1)}n.binarySearch2=_;function l(k,q,x){if(k=k|0,k>=q.length)throw new TypeError("invalid index");const H=q[Math.floor(q.length*Math.random())],V=[],t=[],ne=[];for(const re of q){const le=x(re,H);le<0?V.push(re):le>0?t.push(re):ne.push(re)}return k<V.length?l(k,V,x):k<V.length+ne.length?ne[0]:l(k-(V.length+ne.length),t,x)}n.quickSelect=l;function o(k,q){const x=[];let H;for(const V of k.slice(0).sort(q))!H||q(H[0],V)!==0?(H=[V],x.push(H)):H.push(V);return x}n.groupBy=o;function*C(k,q){let x,H;for(const V of k)H!==void 0&&q(H,V)?x.push(V):(x&&(yield x),x=[V]),H=V;x&&(yield x)}n.groupAdjacentBy=C;function e(k,q){for(let x=0;x<=k.length;x++)q(x===0?void 0:k[x-1],x===k.length?void 0:k[x])}n.forEachAdjacent=e;function m(k,q){for(let x=0;x<k.length;x++)q(x===0?void 0:k[x-1],k[x],x+1===k.length?void 0:k[x+1])}n.forEachWithNeighbors=m;function g(k){return k.filter(q=>!!q)}n.coalesce=g;function u(k){let q=0;for(let x=0;x<k.length;x++)k[x]&&(k[q]=k[x],q+=1);k.length=q}n.coalesceInPlace=u;function b(k){return!Array.isArray(k)||k.length===0}n.isFalsyOrEmpty=b;function h(k){return Array.isArray(k)&&k.length>0}n.isNonEmptyArray=h;function S(k,q=x=>x){const x=new Set;return k.filter(H=>{const V=q(H);return x.has(V)?!1:(x.add(V),!0)})}n.distinct=S;function v(k,q){return k.length>0?k[0]:q}n.firstOrDefault=v;function N(k,q){let x=typeof q=="number"?k:0;typeof q=="number"?x=k:(x=0,q=k);const H=[];if(x<=q)for(let V=x;V<q;V++)H.push(V);else for(let V=x;V>q;V--)H.push(V);return H}n.range=N;function y(k,q,x){const H=k.slice(0,q),V=k.slice(q);return H.concat(x,V)}n.arrayInsert=y;function L(k,q){const x=k.indexOf(q);x>-1&&(k.splice(x,1),k.unshift(q))}n.pushToStart=L;function r(k,q){const x=k.indexOf(q);x>-1&&(k.splice(x,1),k.push(q))}n.pushToEnd=r;function s(k,q){for(const x of q)k.push(x)}n.pushMany=s;function a(k){return Array.isArray(k)?k:[k]}n.asArray=a;function p(k,q,x){const H=w(k,q),V=k.length,t=x.length;k.length=V+t;for(let ne=V-1;ne>=H;ne--)k[ne+t]=k[ne];for(let ne=0;ne<t;ne++)k[ne+H]=x[ne]}n.insertInto=p;function d(k,q,x,H){const V=w(k,q);let t=k.splice(V,x);return t===void 0&&(t=[]),p(k,V,H),t}n.splice=d;function w(k,q){return q<0?Math.max(q+k.length,0):Math.min(q,k.length)}var E;(function(k){function q(t){return t<0}k.isLessThan=q;function x(t){return t<=0}k.isLessThanOrEqual=x;function H(t){return t>0}k.isGreaterThan=H;function V(t){return t===0}k.isNeitherLessOrGreaterThan=V,k.greaterThan=1,k.lessThan=-1,k.neitherLessOrGreaterThan=0})(E||(n.CompareResult=E={}));function R(k,q){return(x,H)=>q(k(x),k(H))}n.compareBy=R;function D(...k){return(q,x)=>{for(const H of k){const V=H(q,x);if(!E.isNeitherLessOrGreaterThan(V))return V}return E.neitherLessOrGreaterThan}}n.tieBreakComparators=D;const F=(k,q)=>k-q;n.numberComparator=F;const U=(k,q)=>(0,n.numberComparator)(k?1:0,q?1:0);n.booleanComparator=U;function I(k){return(q,x)=>-k(q,x)}n.reverseOrder=I;class B{constructor(q){this.items=q,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(q){let x=this.firstIdx;for(;x<this.items.length&&q(this.items[x]);)x++;const H=x===this.firstIdx?null:this.items.slice(this.firstIdx,x);return this.firstIdx=x,H}takeFromEndWhile(q){let x=this.lastIdx;for(;x>=0&&q(this.items[x]);)x--;const H=x===this.lastIdx?null:this.items.slice(x+1,this.lastIdx+1);return this.lastIdx=x,H}peek(){if(this.length!==0)return this.items[this.firstIdx]}dequeue(){const q=this.items[this.firstIdx];return this.firstIdx++,q}takeCount(q){const x=this.items.slice(this.firstIdx,this.firstIdx+q);return this.firstIdx+=q,x}}n.ArrayQueue=B;class z{constructor(q){this.iterate=q}toArray(){const q=[];return this.iterate(x=>(q.push(x),!0)),q}filter(q){return new z(x=>this.iterate(H=>q(H)?x(H):!0))}map(q){return new z(x=>this.iterate(H=>x(q(H))))}findLast(q){let x;return this.iterate(H=>(q(H)&&(x=H),!0)),x}findLastMaxBy(q){let x,H=!0;return this.iterate(V=>((H||E.isGreaterThan(q(V,x)))&&(H=!1,x=V),!0)),x}}n.CallbackIterable=z,z.empty=new z(k=>{})}),Y(X[11],J([0,1]),function(T,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.mapFindFirst=n.findMaxIdxBy=n.findFirstMinBy=n.findLastMaxBy=n.findFirstMaxBy=n.MonotonousArray=n.findFirstIdxMonotonousOrArrLen=n.findFirstMonotonous=n.findLastIdxMonotonous=n.findLastMonotonous=n.findLastIdx=n.findLast=void 0;function M(u,b,h){const S=A(u,b);if(S!==-1)return u[S]}n.findLast=M;function A(u,b,h=u.length-1){for(let S=h;S>=0;S--){const v=u[S];if(b(v))return S}return-1}n.findLastIdx=A;function i(u,b){const h=c(u,b);return h===-1?void 0:u[h]}n.findLastMonotonous=i;function c(u,b,h=0,S=u.length){let v=h,N=S;for(;v<N;){const y=Math.floor((v+N)/2);b(u[y])?v=y+1:N=y}return v-1}n.findLastIdxMonotonous=c;function f(u,b){const h=_(u,b);return h===u.length?void 0:u[h]}n.findFirstMonotonous=f;function _(u,b,h=0,S=u.length){let v=h,N=S;for(;v<N;){const y=Math.floor((v+N)/2);b(u[y])?N=y:v=y+1}return v}n.findFirstIdxMonotonousOrArrLen=_;class l{constructor(b){this._array=b,this._findLastMonotonousLastIdx=0}findLastMonotonous(b){if(l.assertInvariants){if(this._prevFindLastPredicate){for(const S of this._array)if(this._prevFindLastPredicate(S)&&!b(S))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this._prevFindLastPredicate=b}const h=c(this._array,b,this._findLastMonotonousLastIdx);return this._findLastMonotonousLastIdx=h+1,h===-1?void 0:this._array[h]}}n.MonotonousArray=l,l.assertInvariants=!1;function o(u,b){if(u.length===0)return;let h=u[0];for(let S=1;S<u.length;S++){const v=u[S];b(v,h)>0&&(h=v)}return h}n.findFirstMaxBy=o;function C(u,b){if(u.length===0)return;let h=u[0];for(let S=1;S<u.length;S++){const v=u[S];b(v,h)>=0&&(h=v)}return h}n.findLastMaxBy=C;function e(u,b){return o(u,(h,S)=>-b(h,S))}n.findFirstMinBy=e;function m(u,b){if(u.length===0)return-1;let h=0;for(let S=1;S<u.length;S++){const v=u[S];b(v,u[h])>0&&(h=S)}return h}n.findMaxIdxBy=m;function g(u,b){for(const h of u){const S=b(h);if(S!==void 0)return S}}n.mapFindFirst=g}),Y(X[32],J([0,1]),function(T,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.CachedFunction=n.LRUCachedFunction=void 0;class M{constructor(c){this.fn=c,this.lastCache=void 0,this.lastArgKey=void 0}get(c){const f=JSON.stringify(c);return this.lastArgKey!==f&&(this.lastArgKey=f,this.lastCache=this.fn(c)),this.lastCache}}n.LRUCachedFunction=M;class A{get cachedValues(){return this._map}constructor(c){this.fn=c,this._map=new Map}get(c){if(this._map.has(c))return this._map.get(c);const f=this.fn(c);return this._map.set(c,f),f}}n.CachedFunction=A}),Y(X[33],J([0,1]),function(T,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.SetMap=n.diffSets=void 0;function M(i,c){const f=[],_=[];for(const l of i)c.has(l)||f.push(l);for(const l of c)i.has(l)||_.push(l);return{removed:f,added:_}}n.diffSets=M;class A{constructor(){this.map=new Map}add(c,f){let _=this.map.get(c);_||(_=new Set,this.map.set(c,_)),_.add(f)}delete(c,f){const _=this.map.get(c);_&&(_.delete(f),_.size===0&&this.map.delete(c))}forEach(c,f){const _=this.map.get(c);_&&_.forEach(f)}get(c){const f=this.map.get(c);return f||new Set}}n.SetMap=A}),Y(X[34],J([0,1]),function(T,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Color=n.HSVA=n.HSLA=n.RGBA=void 0;function M(_,l){const o=Math.pow(10,l);return Math.round(_*o)/o}class A{constructor(l,o,C,e=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,l))|0,this.g=Math.min(255,Math.max(0,o))|0,this.b=Math.min(255,Math.max(0,C))|0,this.a=M(Math.max(Math.min(1,e),0),3)}static equals(l,o){return l.r===o.r&&l.g===o.g&&l.b===o.b&&l.a===o.a}}n.RGBA=A;class i{constructor(l,o,C,e){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,l),0)|0,this.s=M(Math.max(Math.min(1,o),0),3),this.l=M(Math.max(Math.min(1,C),0),3),this.a=M(Math.max(Math.min(1,e),0),3)}static equals(l,o){return l.h===o.h&&l.s===o.s&&l.l===o.l&&l.a===o.a}static fromRGBA(l){const o=l.r/255,C=l.g/255,e=l.b/255,m=l.a,g=Math.max(o,C,e),u=Math.min(o,C,e);let b=0,h=0;const S=(u+g)/2,v=g-u;if(v>0){switch(h=Math.min(S<=.5?v/(2*S):v/(2-2*S),1),g){case o:b=(C-e)/v+(C<e?6:0);break;case C:b=(e-o)/v+2;break;case e:b=(o-C)/v+4;break}b*=60,b=Math.round(b)}return new i(b,h,S,m)}static _hue2rgb(l,o,C){return C<0&&(C+=1),C>1&&(C-=1),C<1/6?l+(o-l)*6*C:C<1/2?o:C<2/3?l+(o-l)*(2/3-C)*6:l}static toRGBA(l){const o=l.h/360,{s:C,l:e,a:m}=l;let g,u,b;if(C===0)g=u=b=e;else{const h=e<.5?e*(1+C):e+C-e*C,S=2*e-h;g=i._hue2rgb(S,h,o+1/3),u=i._hue2rgb(S,h,o),b=i._hue2rgb(S,h,o-1/3)}return new A(Math.round(g*255),Math.round(u*255),Math.round(b*255),m)}}n.HSLA=i;class c{constructor(l,o,C,e){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,l),0)|0,this.s=M(Math.max(Math.min(1,o),0),3),this.v=M(Math.max(Math.min(1,C),0),3),this.a=M(Math.max(Math.min(1,e),0),3)}static equals(l,o){return l.h===o.h&&l.s===o.s&&l.v===o.v&&l.a===o.a}static fromRGBA(l){const o=l.r/255,C=l.g/255,e=l.b/255,m=Math.max(o,C,e),g=Math.min(o,C,e),u=m-g,b=m===0?0:u/m;let h;return u===0?h=0:m===o?h=((C-e)/u%6+6)%6:m===C?h=(e-o)/u+2:h=(o-C)/u+4,new c(Math.round(h*60),b,m,l.a)}static toRGBA(l){const{h:o,s:C,v:e,a:m}=l,g=e*C,u=g*(1-Math.abs(o/60%2-1)),b=e-g;let[h,S,v]=[0,0,0];return o<60?(h=g,S=u):o<120?(h=u,S=g):o<180?(S=g,v=u):o<240?(S=u,v=g):o<300?(h=u,v=g):o<=360&&(h=g,v=u),h=Math.round((h+b)*255),S=Math.round((S+b)*255),v=Math.round((v+b)*255),new A(h,S,v,m)}}n.HSVA=c;class f{static fromHex(l){return f.Format.CSS.parseHex(l)||f.red}static equals(l,o){return!l&&!o?!0:!l||!o?!1:l.equals(o)}get hsla(){return this._hsla?this._hsla:i.fromRGBA(this.rgba)}get hsva(){return this._hsva?this._hsva:c.fromRGBA(this.rgba)}constructor(l){if(l)if(l instanceof A)this.rgba=l;else if(l instanceof i)this._hsla=l,this.rgba=i.toRGBA(l);else if(l instanceof c)this._hsva=l,this.rgba=c.toRGBA(l);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(l){return!!l&&A.equals(this.rgba,l.rgba)&&i.equals(this.hsla,l.hsla)&&c.equals(this.hsva,l.hsva)}getRelativeLuminance(){const l=f._relativeLuminanceForComponent(this.rgba.r),o=f._relativeLuminanceForComponent(this.rgba.g),C=f._relativeLuminanceForComponent(this.rgba.b),e=.2126*l+.7152*o+.0722*C;return M(e,4)}static _relativeLuminanceForComponent(l){const o=l/255;return o<=.03928?o/12.92:Math.pow((o+.055)/1.055,2.4)}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(l){const o=this.getRelativeLuminance(),C=l.getRelativeLuminance();return o>C}isDarkerThan(l){const o=this.getRelativeLuminance(),C=l.getRelativeLuminance();return o<C}lighten(l){return new f(new i(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*l,this.hsla.a))}darken(l){return new f(new i(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*l,this.hsla.a))}transparent(l){const{r:o,g:C,b:e,a:m}=this.rgba;return new f(new A(o,C,e,m*l))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new f(new A(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}makeOpaque(l){if(this.isOpaque()||l.rgba.a!==1)return this;const{r:o,g:C,b:e,a:m}=this.rgba;return new f(new A(l.rgba.r-m*(l.rgba.r-o),l.rgba.g-m*(l.rgba.g-C),l.rgba.b-m*(l.rgba.b-e),1))}toString(){return this._toString||(this._toString=f.Format.CSS.format(this)),this._toString}static getLighterColor(l,o,C){if(l.isLighterThan(o))return l;C=C||.5;const e=l.getRelativeLuminance(),m=o.getRelativeLuminance();return C=C*(m-e)/m,l.lighten(C)}static getDarkerColor(l,o,C){if(l.isDarkerThan(o))return l;C=C||.5;const e=l.getRelativeLuminance(),m=o.getRelativeLuminance();return C=C*(e-m)/e,l.darken(C)}}n.Color=f,f.white=new f(new A(255,255,255,1)),f.black=new f(new A(0,0,0,1)),f.red=new f(new A(255,0,0,1)),f.blue=new f(new A(0,0,255,1)),f.green=new f(new A(0,255,0,1)),f.cyan=new f(new A(0,255,255,1)),f.lightgrey=new f(new A(211,211,211,1)),f.transparent=new f(new A(0,0,0,0)),function(_){let l;(function(o){let C;(function(e){function m(r){return r.rgba.a===1?`rgb(${r.rgba.r}, ${r.rgba.g}, ${r.rgba.b})`:_.Format.CSS.formatRGBA(r)}e.formatRGB=m;function g(r){return`rgba(${r.rgba.r}, ${r.rgba.g}, ${r.rgba.b}, ${+r.rgba.a.toFixed(2)})`}e.formatRGBA=g;function u(r){return r.hsla.a===1?`hsl(${r.hsla.h}, ${(r.hsla.s*100).toFixed(2)}%, ${(r.hsla.l*100).toFixed(2)}%)`:_.Format.CSS.formatHSLA(r)}e.formatHSL=u;function b(r){return`hsla(${r.hsla.h}, ${(r.hsla.s*100).toFixed(2)}%, ${(r.hsla.l*100).toFixed(2)}%, ${r.hsla.a.toFixed(2)})`}e.formatHSLA=b;function h(r){const s=r.toString(16);return s.length!==2?"0"+s:s}function S(r){return`#${h(r.rgba.r)}${h(r.rgba.g)}${h(r.rgba.b)}`}e.formatHex=S;function v(r,s=!1){return s&&r.rgba.a===1?_.Format.CSS.formatHex(r):`#${h(r.rgba.r)}${h(r.rgba.g)}${h(r.rgba.b)}${h(Math.round(r.rgba.a*255))}`}e.formatHexA=v;function N(r){return r.isOpaque()?_.Format.CSS.formatHex(r):_.Format.CSS.formatRGBA(r)}e.format=N;function y(r){const s=r.length;if(s===0||r.charCodeAt(0)!==35)return null;if(s===7){const a=16*L(r.charCodeAt(1))+L(r.charCodeAt(2)),p=16*L(r.charCodeAt(3))+L(r.charCodeAt(4)),d=16*L(r.charCodeAt(5))+L(r.charCodeAt(6));return new _(new A(a,p,d,1))}if(s===9){const a=16*L(r.charCodeAt(1))+L(r.charCodeAt(2)),p=16*L(r.charCodeAt(3))+L(r.charCodeAt(4)),d=16*L(r.charCodeAt(5))+L(r.charCodeAt(6)),w=16*L(r.charCodeAt(7))+L(r.charCodeAt(8));return new _(new A(a,p,d,w/255))}if(s===4){const a=L(r.charCodeAt(1)),p=L(r.charCodeAt(2)),d=L(r.charCodeAt(3));return new _(new A(16*a+a,16*p+p,16*d+d))}if(s===5){const a=L(r.charCodeAt(1)),p=L(r.charCodeAt(2)),d=L(r.charCodeAt(3)),w=L(r.charCodeAt(4));return new _(new A(16*a+a,16*p+p,16*d+d,(16*w+w)/255))}return null}e.parseHex=y;function L(r){switch(r){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(C=o.CSS||(o.CSS={}))})(l=_.Format||(_.Format={}))}(f||(n.Color=f={}))}),Y(X[35],J([0,1]),function(T,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.DiffChange=void 0;class M{constructor(i,c,f,_){this.originalStart=i,this.originalLength=c,this.modifiedStart=f,this.modifiedLength=_}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}n.DiffChange=M}),Y(X[5],J([0,1]),function(T,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.BugIndicatingError=n.ErrorNoTelemetry=n.NotSupportedError=n.illegalState=n.illegalArgument=n.canceled=n.CancellationError=n.isCancellationError=n.transformErrorForSerialization=n.onUnexpectedExternalError=n.onUnexpectedError=n.errorHandler=n.ErrorHandler=void 0;class M{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(h){setTimeout(()=>{throw h.stack?g.isErrorNoTelemetry(h)?new g(h.message+`

`+h.stack):new Error(h.message+`

`+h.stack):h},0)}}emit(h){this.listeners.forEach(S=>{S(h)})}onUnexpectedError(h){this.unexpectedErrorHandler(h),this.emit(h)}onUnexpectedExternalError(h){this.unexpectedErrorHandler(h)}}n.ErrorHandler=M,n.errorHandler=new M;function A(b){_(b)||n.errorHandler.onUnexpectedError(b)}n.onUnexpectedError=A;function i(b){_(b)||n.errorHandler.onUnexpectedExternalError(b)}n.onUnexpectedExternalError=i;function c(b){if(b instanceof Error){const{name:h,message:S}=b,v=b.stacktrace||b.stack;return{$isError:!0,name:h,message:S,stack:v,noTelemetry:g.isErrorNoTelemetry(b)}}return b}n.transformErrorForSerialization=c;const f="Canceled";function _(b){return b instanceof l?!0:b instanceof Error&&b.name===f&&b.message===f}n.isCancellationError=_;class l extends Error{constructor(){super(f),this.name=this.message}}n.CancellationError=l;function o(){const b=new Error(f);return b.name=b.message,b}n.canceled=o;function C(b){return b?new Error(`Illegal argument: ${b}`):new Error("Illegal argument")}n.illegalArgument=C;function e(b){return b?new Error(`Illegal state: ${b}`):new Error("Illegal state")}n.illegalState=e;class m extends Error{constructor(h){super("NotSupported"),h&&(this.message=h)}}n.NotSupportedError=m;class g extends Error{constructor(h){super(h),this.name="CodeExpectedError"}static fromError(h){if(h instanceof g)return h;const S=new g;return S.message=h.message,S.stack=h.stack,S}static isErrorNoTelemetry(h){return h.name==="CodeExpectedError"}}n.ErrorNoTelemetry=g;class u extends Error{constructor(h){super(h||"An unexpected bug occurred."),Object.setPrototypeOf(this,u.prototype)}}n.BugIndicatingError=u}),Y(X[12],J([0,1,5]),function(T,n,M){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.checkAdjacentItems=n.assertFn=n.assertNever=n.ok=void 0;function A(_,l){if(!_)throw new Error(l?`Assertion failed (${l})`:"Assertion Failed")}n.ok=A;function i(_,l="Unreachable"){throw new Error(l)}n.assertNever=i;function c(_){if(!_()){debugger;_(),(0,M.onUnexpectedError)(new M.BugIndicatingError("Assertion Failed"))}}n.assertFn=c;function f(_,l){let o=0;for(;o<_.length-1;){const C=_[o],e=_[o+1];if(!l(C,e))return!1;o++}return!0}n.checkAdjacentItems=f}),Y(X[20],J([0,1]),function(T,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.once=void 0;function M(A){const i=this;let c=!1,f;return function(){return c||(c=!0,f=A.apply(i,arguments)),f}}n.once=M}),Y(X[21],J([0,1]),function(T,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Iterable=void 0;var M;(function(A){function i(L){return L&&typeof L=="object"&&typeof L[Symbol.iterator]=="function"}A.is=i;const c=Object.freeze([]);function f(){return c}A.empty=f;function*_(L){yield L}A.single=_;function l(L){return i(L)?L:_(L)}A.wrap=l;function o(L){return L||c}A.from=o;function*C(L){for(let r=L.length-1;r>=0;r--)yield L[r]}A.reverse=C;function e(L){return!L||L[Symbol.iterator]().next().done===!0}A.isEmpty=e;function m(L){return L[Symbol.iterator]().next().value}A.first=m;function g(L,r){for(const s of L)if(r(s))return!0;return!1}A.some=g;function u(L,r){for(const s of L)if(r(s))return s}A.find=u;function*b(L,r){for(const s of L)r(s)&&(yield s)}A.filter=b;function*h(L,r){let s=0;for(const a of L)yield r(a,s++)}A.map=h;function*S(...L){for(const r of L)for(const s of r)yield s}A.concat=S;function v(L,r,s){let a=s;for(const p of L)a=r(a,p);return a}A.reduce=v;function*N(L,r,s=L.length){for(r<0&&(r+=L.length),s<0?s+=L.length:s>L.length&&(s=L.length);r<s;r++)yield L[r]}A.slice=N;function y(L,r=Number.POSITIVE_INFINITY){const s=[];if(r===0)return[s,L];const a=L[Symbol.iterator]();for(let p=0;p<r;p++){const d=a.next();if(d.done)return[s,A.empty()];s.push(d.value)}return[s,{[Symbol.iterator](){return a}}]}A.consume=y})(M||(n.Iterable=M={}))}),Y(X[36],J([0,1]),function(T,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.KeyChord=n.KeyCodeUtils=n.IMMUTABLE_KEY_CODE_TO_CODE=n.IMMUTABLE_CODE_TO_KEY_CODE=n.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE=n.EVENT_KEY_CODE_MAP=void 0;class M{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(m,g){this._keyCodeToStr[m]=g,this._strToKeyCode[g.toLowerCase()]=m}keyCodeToStr(m){return this._keyCodeToStr[m]}strToKeyCode(m){return this._strToKeyCode[m.toLowerCase()]||0}}const A=new M,i=new M,c=new M;n.EVENT_KEY_CODE_MAP=new Array(230),n.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE={};const f=[],_=Object.create(null),l=Object.create(null);n.IMMUTABLE_CODE_TO_KEY_CODE=[],n.IMMUTABLE_KEY_CODE_TO_CODE=[];for(let e=0;e<=193;e++)n.IMMUTABLE_CODE_TO_KEY_CODE[e]=-1;for(let e=0;e<=132;e++)n.IMMUTABLE_KEY_CODE_TO_CODE[e]=-1;(function(){const e="",m=[[1,0,"None",0,"unknown",0,"VK_UNKNOWN",e,e],[1,1,"Hyper",0,e,0,e,e,e],[1,2,"Super",0,e,0,e,e,e],[1,3,"Fn",0,e,0,e,e,e],[1,4,"FnLock",0,e,0,e,e,e],[1,5,"Suspend",0,e,0,e,e,e],[1,6,"Resume",0,e,0,e,e,e],[1,7,"Turbo",0,e,0,e,e,e],[1,8,"Sleep",0,e,0,"VK_SLEEP",e,e],[1,9,"WakeUp",0,e,0,e,e,e],[0,10,"KeyA",31,"A",65,"VK_A",e,e],[0,11,"KeyB",32,"B",66,"VK_B",e,e],[0,12,"KeyC",33,"C",67,"VK_C",e,e],[0,13,"KeyD",34,"D",68,"VK_D",e,e],[0,14,"KeyE",35,"E",69,"VK_E",e,e],[0,15,"KeyF",36,"F",70,"VK_F",e,e],[0,16,"KeyG",37,"G",71,"VK_G",e,e],[0,17,"KeyH",38,"H",72,"VK_H",e,e],[0,18,"KeyI",39,"I",73,"VK_I",e,e],[0,19,"KeyJ",40,"J",74,"VK_J",e,e],[0,20,"KeyK",41,"K",75,"VK_K",e,e],[0,21,"KeyL",42,"L",76,"VK_L",e,e],[0,22,"KeyM",43,"M",77,"VK_M",e,e],[0,23,"KeyN",44,"N",78,"VK_N",e,e],[0,24,"KeyO",45,"O",79,"VK_O",e,e],[0,25,"KeyP",46,"P",80,"VK_P",e,e],[0,26,"KeyQ",47,"Q",81,"VK_Q",e,e],[0,27,"KeyR",48,"R",82,"VK_R",e,e],[0,28,"KeyS",49,"S",83,"VK_S",e,e],[0,29,"KeyT",50,"T",84,"VK_T",e,e],[0,30,"KeyU",51,"U",85,"VK_U",e,e],[0,31,"KeyV",52,"V",86,"VK_V",e,e],[0,32,"KeyW",53,"W",87,"VK_W",e,e],[0,33,"KeyX",54,"X",88,"VK_X",e,e],[0,34,"KeyY",55,"Y",89,"VK_Y",e,e],[0,35,"KeyZ",56,"Z",90,"VK_Z",e,e],[0,36,"Digit1",22,"1",49,"VK_1",e,e],[0,37,"Digit2",23,"2",50,"VK_2",e,e],[0,38,"Digit3",24,"3",51,"VK_3",e,e],[0,39,"Digit4",25,"4",52,"VK_4",e,e],[0,40,"Digit5",26,"5",53,"VK_5",e,e],[0,41,"Digit6",27,"6",54,"VK_6",e,e],[0,42,"Digit7",28,"7",55,"VK_7",e,e],[0,43,"Digit8",29,"8",56,"VK_8",e,e],[0,44,"Digit9",30,"9",57,"VK_9",e,e],[0,45,"Digit0",21,"0",48,"VK_0",e,e],[1,46,"Enter",3,"Enter",13,"VK_RETURN",e,e],[1,47,"Escape",9,"Escape",27,"VK_ESCAPE",e,e],[1,48,"Backspace",1,"Backspace",8,"VK_BACK",e,e],[1,49,"Tab",2,"Tab",9,"VK_TAB",e,e],[1,50,"Space",10,"Space",32,"VK_SPACE",e,e],[0,51,"Minus",88,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[0,52,"Equal",86,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[0,53,"BracketLeft",92,"[",219,"VK_OEM_4","[","OEM_4"],[0,54,"BracketRight",94,"]",221,"VK_OEM_6","]","OEM_6"],[0,55,"Backslash",93,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,56,"IntlHash",0,e,0,e,e,e],[0,57,"Semicolon",85,";",186,"VK_OEM_1",";","OEM_1"],[0,58,"Quote",95,"'",222,"VK_OEM_7","'","OEM_7"],[0,59,"Backquote",91,"`",192,"VK_OEM_3","`","OEM_3"],[0,60,"Comma",87,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[0,61,"Period",89,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[0,62,"Slash",90,"/",191,"VK_OEM_2","/","OEM_2"],[1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",e,e],[1,64,"F1",59,"F1",112,"VK_F1",e,e],[1,65,"F2",60,"F2",113,"VK_F2",e,e],[1,66,"F3",61,"F3",114,"VK_F3",e,e],[1,67,"F4",62,"F4",115,"VK_F4",e,e],[1,68,"F5",63,"F5",116,"VK_F5",e,e],[1,69,"F6",64,"F6",117,"VK_F6",e,e],[1,70,"F7",65,"F7",118,"VK_F7",e,e],[1,71,"F8",66,"F8",119,"VK_F8",e,e],[1,72,"F9",67,"F9",120,"VK_F9",e,e],[1,73,"F10",68,"F10",121,"VK_F10",e,e],[1,74,"F11",69,"F11",122,"VK_F11",e,e],[1,75,"F12",70,"F12",123,"VK_F12",e,e],[1,76,"PrintScreen",0,e,0,e,e,e],[1,77,"ScrollLock",84,"ScrollLock",145,"VK_SCROLL",e,e],[1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",e,e],[1,79,"Insert",19,"Insert",45,"VK_INSERT",e,e],[1,80,"Home",14,"Home",36,"VK_HOME",e,e],[1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",e,e],[1,82,"Delete",20,"Delete",46,"VK_DELETE",e,e],[1,83,"End",13,"End",35,"VK_END",e,e],[1,84,"PageDown",12,"PageDown",34,"VK_NEXT",e,e],[1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",e],[1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",e],[1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",e],[1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",e],[1,89,"NumLock",83,"NumLock",144,"VK_NUMLOCK",e,e],[1,90,"NumpadDivide",113,"NumPad_Divide",111,"VK_DIVIDE",e,e],[1,91,"NumpadMultiply",108,"NumPad_Multiply",106,"VK_MULTIPLY",e,e],[1,92,"NumpadSubtract",111,"NumPad_Subtract",109,"VK_SUBTRACT",e,e],[1,93,"NumpadAdd",109,"NumPad_Add",107,"VK_ADD",e,e],[1,94,"NumpadEnter",3,e,0,e,e,e],[1,95,"Numpad1",99,"NumPad1",97,"VK_NUMPAD1",e,e],[1,96,"Numpad2",100,"NumPad2",98,"VK_NUMPAD2",e,e],[1,97,"Numpad3",101,"NumPad3",99,"VK_NUMPAD3",e,e],[1,98,"Numpad4",102,"NumPad4",100,"VK_NUMPAD4",e,e],[1,99,"Numpad5",103,"NumPad5",101,"VK_NUMPAD5",e,e],[1,100,"Numpad6",104,"NumPad6",102,"VK_NUMPAD6",e,e],[1,101,"Numpad7",105,"NumPad7",103,"VK_NUMPAD7",e,e],[1,102,"Numpad8",106,"NumPad8",104,"VK_NUMPAD8",e,e],[1,103,"Numpad9",107,"NumPad9",105,"VK_NUMPAD9",e,e],[1,104,"Numpad0",98,"NumPad0",96,"VK_NUMPAD0",e,e],[1,105,"NumpadDecimal",112,"NumPad_Decimal",110,"VK_DECIMAL",e,e],[0,106,"IntlBackslash",97,"OEM_102",226,"VK_OEM_102",e,e],[1,107,"ContextMenu",58,"ContextMenu",93,e,e,e],[1,108,"Power",0,e,0,e,e,e],[1,109,"NumpadEqual",0,e,0,e,e,e],[1,110,"F13",71,"F13",124,"VK_F13",e,e],[1,111,"F14",72,"F14",125,"VK_F14",e,e],[1,112,"F15",73,"F15",126,"VK_F15",e,e],[1,113,"F16",74,"F16",127,"VK_F16",e,e],[1,114,"F17",75,"F17",128,"VK_F17",e,e],[1,115,"F18",76,"F18",129,"VK_F18",e,e],[1,116,"F19",77,"F19",130,"VK_F19",e,e],[1,117,"F20",78,"F20",131,"VK_F20",e,e],[1,118,"F21",79,"F21",132,"VK_F21",e,e],[1,119,"F22",80,"F22",133,"VK_F22",e,e],[1,120,"F23",81,"F23",134,"VK_F23",e,e],[1,121,"F24",82,"F24",135,"VK_F24",e,e],[1,122,"Open",0,e,0,e,e,e],[1,123,"Help",0,e,0,e,e,e],[1,124,"Select",0,e,0,e,e,e],[1,125,"Again",0,e,0,e,e,e],[1,126,"Undo",0,e,0,e,e,e],[1,127,"Cut",0,e,0,e,e,e],[1,128,"Copy",0,e,0,e,e,e],[1,129,"Paste",0,e,0,e,e,e],[1,130,"Find",0,e,0,e,e,e],[1,131,"AudioVolumeMute",117,"AudioVolumeMute",173,"VK_VOLUME_MUTE",e,e],[1,132,"AudioVolumeUp",118,"AudioVolumeUp",175,"VK_VOLUME_UP",e,e],[1,133,"AudioVolumeDown",119,"AudioVolumeDown",174,"VK_VOLUME_DOWN",e,e],[1,134,"NumpadComma",110,"NumPad_Separator",108,"VK_SEPARATOR",e,e],[0,135,"IntlRo",115,"ABNT_C1",193,"VK_ABNT_C1",e,e],[1,136,"KanaMode",0,e,0,e,e,e],[0,137,"IntlYen",0,e,0,e,e,e],[1,138,"Convert",0,e,0,e,e,e],[1,139,"NonConvert",0,e,0,e,e,e],[1,140,"Lang1",0,e,0,e,e,e],[1,141,"Lang2",0,e,0,e,e,e],[1,142,"Lang3",0,e,0,e,e,e],[1,143,"Lang4",0,e,0,e,e,e],[1,144,"Lang5",0,e,0,e,e,e],[1,145,"Abort",0,e,0,e,e,e],[1,146,"Props",0,e,0,e,e,e],[1,147,"NumpadParenLeft",0,e,0,e,e,e],[1,148,"NumpadParenRight",0,e,0,e,e,e],[1,149,"NumpadBackspace",0,e,0,e,e,e],[1,150,"NumpadMemoryStore",0,e,0,e,e,e],[1,151,"NumpadMemoryRecall",0,e,0,e,e,e],[1,152,"NumpadMemoryClear",0,e,0,e,e,e],[1,153,"NumpadMemoryAdd",0,e,0,e,e,e],[1,154,"NumpadMemorySubtract",0,e,0,e,e,e],[1,155,"NumpadClear",131,"Clear",12,"VK_CLEAR",e,e],[1,156,"NumpadClearEntry",0,e,0,e,e,e],[1,0,e,5,"Ctrl",17,"VK_CONTROL",e,e],[1,0,e,4,"Shift",16,"VK_SHIFT",e,e],[1,0,e,6,"Alt",18,"VK_MENU",e,e],[1,0,e,57,"Meta",91,"VK_COMMAND",e,e],[1,157,"ControlLeft",5,e,0,"VK_LCONTROL",e,e],[1,158,"ShiftLeft",4,e,0,"VK_LSHIFT",e,e],[1,159,"AltLeft",6,e,0,"VK_LMENU",e,e],[1,160,"MetaLeft",57,e,0,"VK_LWIN",e,e],[1,161,"ControlRight",5,e,0,"VK_RCONTROL",e,e],[1,162,"ShiftRight",4,e,0,"VK_RSHIFT",e,e],[1,163,"AltRight",6,e,0,"VK_RMENU",e,e],[1,164,"MetaRight",57,e,0,"VK_RWIN",e,e],[1,165,"BrightnessUp",0,e,0,e,e,e],[1,166,"BrightnessDown",0,e,0,e,e,e],[1,167,"MediaPlay",0,e,0,e,e,e],[1,168,"MediaRecord",0,e,0,e,e,e],[1,169,"MediaFastForward",0,e,0,e,e,e],[1,170,"MediaRewind",0,e,0,e,e,e],[1,171,"MediaTrackNext",124,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",e,e],[1,172,"MediaTrackPrevious",125,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",e,e],[1,173,"MediaStop",126,"MediaStop",178,"VK_MEDIA_STOP",e,e],[1,174,"Eject",0,e,0,e,e,e],[1,175,"MediaPlayPause",127,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",e,e],[1,176,"MediaSelect",128,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",e,e],[1,177,"LaunchMail",129,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",e,e],[1,178,"LaunchApp2",130,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",e,e],[1,179,"LaunchApp1",0,e,0,"VK_MEDIA_LAUNCH_APP1",e,e],[1,180,"SelectTask",0,e,0,e,e,e],[1,181,"LaunchScreenSaver",0,e,0,e,e,e],[1,182,"BrowserSearch",120,"BrowserSearch",170,"VK_BROWSER_SEARCH",e,e],[1,183,"BrowserHome",121,"BrowserHome",172,"VK_BROWSER_HOME",e,e],[1,184,"BrowserBack",122,"BrowserBack",166,"VK_BROWSER_BACK",e,e],[1,185,"BrowserForward",123,"BrowserForward",167,"VK_BROWSER_FORWARD",e,e],[1,186,"BrowserStop",0,e,0,"VK_BROWSER_STOP",e,e],[1,187,"BrowserRefresh",0,e,0,"VK_BROWSER_REFRESH",e,e],[1,188,"BrowserFavorites",0,e,0,"VK_BROWSER_FAVORITES",e,e],[1,189,"ZoomToggle",0,e,0,e,e,e],[1,190,"MailReply",0,e,0,e,e,e],[1,191,"MailForward",0,e,0,e,e,e],[1,192,"MailSend",0,e,0,e,e,e],[1,0,e,114,"KeyInComposition",229,e,e,e],[1,0,e,116,"ABNT_C2",194,"VK_ABNT_C2",e,e],[1,0,e,96,"OEM_8",223,"VK_OEM_8",e,e],[1,0,e,0,e,0,"VK_KANA",e,e],[1,0,e,0,e,0,"VK_HANGUL",e,e],[1,0,e,0,e,0,"VK_JUNJA",e,e],[1,0,e,0,e,0,"VK_FINAL",e,e],[1,0,e,0,e,0,"VK_HANJA",e,e],[1,0,e,0,e,0,"VK_KANJI",e,e],[1,0,e,0,e,0,"VK_CONVERT",e,e],[1,0,e,0,e,0,"VK_NONCONVERT",e,e],[1,0,e,0,e,0,"VK_ACCEPT",e,e],[1,0,e,0,e,0,"VK_MODECHANGE",e,e],[1,0,e,0,e,0,"VK_SELECT",e,e],[1,0,e,0,e,0,"VK_PRINT",e,e],[1,0,e,0,e,0,"VK_EXECUTE",e,e],[1,0,e,0,e,0,"VK_SNAPSHOT",e,e],[1,0,e,0,e,0,"VK_HELP",e,e],[1,0,e,0,e,0,"VK_APPS",e,e],[1,0,e,0,e,0,"VK_PROCESSKEY",e,e],[1,0,e,0,e,0,"VK_PACKET",e,e],[1,0,e,0,e,0,"VK_DBE_SBCSCHAR",e,e],[1,0,e,0,e,0,"VK_DBE_DBCSCHAR",e,e],[1,0,e,0,e,0,"VK_ATTN",e,e],[1,0,e,0,e,0,"VK_CRSEL",e,e],[1,0,e,0,e,0,"VK_EXSEL",e,e],[1,0,e,0,e,0,"VK_EREOF",e,e],[1,0,e,0,e,0,"VK_PLAY",e,e],[1,0,e,0,e,0,"VK_ZOOM",e,e],[1,0,e,0,e,0,"VK_NONAME",e,e],[1,0,e,0,e,0,"VK_PA1",e,e],[1,0,e,0,e,0,"VK_OEM_CLEAR",e,e]],g=[],u=[];for(const b of m){const[h,S,v,N,y,L,r,s,a]=b;if(u[S]||(u[S]=!0,f[S]=v,_[v]=S,l[v.toLowerCase()]=S,h&&(n.IMMUTABLE_CODE_TO_KEY_CODE[S]=N,N!==0&&N!==3&&N!==5&&N!==4&&N!==6&&N!==57&&(n.IMMUTABLE_KEY_CODE_TO_CODE[N]=S))),!g[N]){if(g[N]=!0,!y)throw new Error(`String representation missing for key code ${N} around scan code ${v}`);A.define(N,y),i.define(N,s||y),c.define(N,a||s||y)}L&&(n.EVENT_KEY_CODE_MAP[L]=N),r&&(n.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE[r]=N)}n.IMMUTABLE_KEY_CODE_TO_CODE[3]=46})();var o;(function(e){function m(v){return A.keyCodeToStr(v)}e.toString=m;function g(v){return A.strToKeyCode(v)}e.fromString=g;function u(v){return i.keyCodeToStr(v)}e.toUserSettingsUS=u;function b(v){return c.keyCodeToStr(v)}e.toUserSettingsGeneral=b;function h(v){return i.strToKeyCode(v)||c.strToKeyCode(v)}e.fromUserSettings=h;function S(v){if(v>=98&&v<=113)return null;switch(v){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return A.keyCodeToStr(v)}e.toElectronAccelerator=S})(o||(n.KeyCodeUtils=o={}));function C(e,m){const g=(m&65535)<<16>>>0;return(e|g)>>>0}n.KeyChord=C}),Y(X[37],J([0,1]),function(T,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Lazy=void 0;class M{constructor(i){this.executor=i,this._didRun=!1}get value(){if(!this._didRun)try{this._value=this.executor()}catch(i){this._error=i}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}}n.Lazy=M}),Y(X[13],J([0,1,20,21]),function(T,n,M,A){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.DisposableMap=n.ImmortalReference=n.RefCountedDisposable=n.MutableDisposable=n.Disposable=n.DisposableStore=n.toDisposable=n.combinedDisposable=n.dispose=n.isDisposable=n.markAsSingleton=n.markAsDisposed=n.trackDisposable=n.setDisposableTracker=void 0;const i=!1;let c=null;function f(r){c=r}if(n.setDisposableTracker=f,i){const r="__is_disposable_tracked__";f(new class{trackDisposable(s){const a=new Error("Potentially leaked disposable").stack;setTimeout(()=>{s[r]||console.log(a)},3e3)}setParent(s,a){if(s&&s!==S.None)try{s[r]=!0}catch{}}markAsDisposed(s){if(s&&s!==S.None)try{s[r]=!0}catch{}}markAsSingleton(s){}})}function _(r){return c?.trackDisposable(r),r}n.trackDisposable=_;function l(r){c?.markAsDisposed(r)}n.markAsDisposed=l;function o(r,s){c?.setParent(r,s)}function C(r,s){if(c)for(const a of r)c.setParent(a,s)}function e(r){return c?.markAsSingleton(r),r}n.markAsSingleton=e;function m(r){return typeof r.dispose=="function"&&r.dispose.length===0}n.isDisposable=m;function g(r){if(A.Iterable.is(r)){const s=[];for(const a of r)if(a)try{a.dispose()}catch(p){s.push(p)}if(s.length===1)throw s[0];if(s.length>1)throw new AggregateError(s,"Encountered errors while disposing of store");return Array.isArray(r)?[]:r}else if(r)return r.dispose(),r}n.dispose=g;function u(...r){const s=b(()=>g(r));return C(r,s),s}n.combinedDisposable=u;function b(r){const s=_({dispose:(0,M.once)(()=>{l(s),r()})});return s}n.toDisposable=b;class h{constructor(){this._toDispose=new Set,this._isDisposed=!1,_(this)}dispose(){this._isDisposed||(l(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){if(this._toDispose.size!==0)try{g(this._toDispose)}finally{this._toDispose.clear()}}add(s){if(!s)return s;if(s===this)throw new Error("Cannot register a disposable on itself!");return o(s,this),this._isDisposed?h.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(s),s}}n.DisposableStore=h,h.DISABLE_DISPOSED_WARNING=!1;class S{constructor(){this._store=new h,_(this),o(this._store,this)}dispose(){l(this),this._store.dispose()}_register(s){if(s===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(s)}}n.Disposable=S,S.None=Object.freeze({dispose(){}});class v{constructor(){this._isDisposed=!1,_(this)}get value(){return this._isDisposed?void 0:this._value}set value(s){var a;this._isDisposed||s===this._value||((a=this._value)===null||a===void 0||a.dispose(),s&&o(s,this),this._value=s)}clear(){this.value=void 0}dispose(){var s;this._isDisposed=!0,l(this),(s=this._value)===null||s===void 0||s.dispose(),this._value=void 0}}n.MutableDisposable=v;class N{constructor(s){this._disposable=s,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter===0&&this._disposable.dispose(),this}}n.RefCountedDisposable=N;class y{constructor(s){this.object=s}dispose(){}}n.ImmortalReference=y;class L{constructor(){this._store=new Map,this._isDisposed=!1,_(this)}dispose(){l(this),this._isDisposed=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this._store.size)try{g(this._store.values())}finally{this._store.clear()}}get(s){return this._store.get(s)}set(s,a,p=!1){var d;this._isDisposed&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),p||(d=this._store.get(s))===null||d===void 0||d.dispose(),this._store.set(s,a)}deleteAndDispose(s){var a;(a=this._store.get(s))===null||a===void 0||a.dispose(),this._store.delete(s)}[Symbol.iterator](){return this._store[Symbol.iterator]()}}n.DisposableMap=L}),Y(X[22],J([0,1]),function(T,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.LinkedList=void 0;class M{constructor(c){this.element=c,this.next=M.Undefined,this.prev=M.Undefined}}M.Undefined=new M(void 0);class A{constructor(){this._first=M.Undefined,this._last=M.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===M.Undefined}clear(){let c=this._first;for(;c!==M.Undefined;){const f=c.next;c.prev=M.Undefined,c.next=M.Undefined,c=f}this._first=M.Undefined,this._last=M.Undefined,this._size=0}unshift(c){return this._insert(c,!1)}push(c){return this._insert(c,!0)}_insert(c,f){const _=new M(c);if(this._first===M.Undefined)this._first=_,this._last=_;else if(f){const o=this._last;this._last=_,_.prev=o,o.next=_}else{const o=this._first;this._first=_,_.next=o,o.prev=_}this._size+=1;let l=!1;return()=>{l||(l=!0,this._remove(_))}}shift(){if(this._first!==M.Undefined){const c=this._first.element;return this._remove(this._first),c}}pop(){if(this._last!==M.Undefined){const c=this._last.element;return this._remove(this._last),c}}_remove(c){if(c.prev!==M.Undefined&&c.next!==M.Undefined){const f=c.prev;f.next=c.next,c.next.prev=f}else c.prev===M.Undefined&&c.next===M.Undefined?(this._first=M.Undefined,this._last=M.Undefined):c.next===M.Undefined?(this._last=this._last.prev,this._last.next=M.Undefined):c.prev===M.Undefined&&(this._first=this._first.next,this._first.prev=M.Undefined);this._size-=1}*[Symbol.iterator](){let c=this._first;for(;c!==M.Undefined;)yield c.element,c=c.next}}n.LinkedList=A}),Y(X[23],J([0,1]),function(T,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.StopWatch=void 0;const M=globalThis.performance&&typeof globalThis.performance.now=="function";class A{static create(c){return new A(c)}constructor(c){this._now=M&&c===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this._startTime=this._now(),this._stopTime=-1}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}}n.StopWatch=A}),Y(X[9],J([0,1,5,20,13,22,23]),function(T,n,M,A,i,c,f){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Relay=n.EventBufferer=n.EventMultiplexer=n.MicrotaskEmitter=n.DebounceEmitter=n.PauseableEmitter=n.createEventDeliveryQueue=n.Emitter=n.EventProfiling=n.Event=void 0;const _=!1,l=!1;var o;(function(d){d.None=()=>i.Disposable.None;function w(Z){if(l){const{onDidAddListener:j}=Z,G=g.create();let Q=0;Z.onDidAddListener=()=>{++Q===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),G.print()),j?.()}}}function E(Z,j){return x(Z,()=>{},0,void 0,!0,void 0,j)}d.defer=E;function R(Z){return(j,G=null,Q)=>{let K=!1,te;return te=Z(P=>{if(!K)return te?te.dispose():K=!0,j.call(G,P)},null,Q),K&&te.dispose(),te}}d.once=R;function D(Z,j,G){return k((Q,K=null,te)=>Z(P=>Q.call(K,j(P)),null,te),G)}d.map=D;function F(Z,j,G){return k((Q,K=null,te)=>Z(P=>{j(P),Q.call(K,P)},null,te),G)}d.forEach=F;function U(Z,j,G){return k((Q,K=null,te)=>Z(P=>j(P)&&Q.call(K,P),null,te),G)}d.filter=U;function I(Z){return Z}d.signal=I;function B(...Z){return(j,G=null,Q)=>{const K=(0,i.combinedDisposable)(...Z.map(te=>te(P=>j.call(G,P))));return q(K,Q)}}d.any=B;function z(Z,j,G,Q){let K=G;return D(Z,te=>(K=j(K,te),K),Q)}d.reduce=z;function k(Z,j){let G;const Q={onWillAddFirstListener(){G=Z(K.fire,K)},onDidRemoveLastListener(){G?.dispose()}};j||w(Q);const K=new S(Q);return j?.add(K),K.event}function q(Z,j){return j instanceof Array?j.push(Z):j&&j.add(Z),Z}function x(Z,j,G=100,Q=!1,K=!1,te,P){let O,W,$,ee=0,ie;const ae={leakWarningThreshold:te,onWillAddFirstListener(){O=Z(fe=>{ee++,W=j(W,fe),Q&&!$&&(ce.fire(W),W=void 0),ie=()=>{const se=W;W=void 0,$=void 0,(!Q||ee>1)&&ce.fire(se),ee=0},typeof G=="number"?(clearTimeout($),$=setTimeout(ie,G)):$===void 0&&($=0,queueMicrotask(ie))})},onWillRemoveListener(){K&&ee>0&&ie?.()},onDidRemoveLastListener(){ie=void 0,O.dispose()}};P||w(ae);const ce=new S(ae);return P?.add(ce),ce.event}d.debounce=x;function H(Z,j=0,G){return d.debounce(Z,(Q,K)=>Q?(Q.push(K),Q):[K],j,void 0,!0,void 0,G)}d.accumulate=H;function V(Z,j=(Q,K)=>Q===K,G){let Q=!0,K;return U(Z,te=>{const P=Q||!j(te,K);return Q=!1,K=te,P},G)}d.latch=V;function t(Z,j,G){return[d.filter(Z,j,G),d.filter(Z,Q=>!j(Q),G)]}d.split=t;function ne(Z,j=!1,G=[],Q){let K=G.slice(),te=Z(W=>{K?K.push(W):O.fire(W)});Q&&Q.add(te);const P=()=>{K?.forEach(W=>O.fire(W)),K=null},O=new S({onWillAddFirstListener(){te||(te=Z(W=>O.fire(W)),Q&&Q.add(te))},onDidAddFirstListener(){K&&(j?setTimeout(P):P())},onDidRemoveLastListener(){te&&te.dispose(),te=null}});return Q&&Q.add(O),O.event}d.buffer=ne;function re(Z,j){return(Q,K,te)=>{const P=j(new me);return Z(function(O){const W=P.evaluate(O);W!==le&&Q.call(K,W)},void 0,te)}}d.chain=re;const le=Symbol("HaltChainable");class me{constructor(){this.steps=[]}map(j){return this.steps.push(j),this}forEach(j){return this.steps.push(G=>(j(G),G)),this}filter(j){return this.steps.push(G=>j(G)?G:le),this}reduce(j,G){let Q=G;return this.steps.push(K=>(Q=j(Q,K),Q)),this}latch(j=(G,Q)=>G===Q){let G=!0,Q;return this.steps.push(K=>{const te=G||!j(K,Q);return G=!1,Q=K,te?K:le}),this}evaluate(j){for(const G of this.steps)if(j=G(j),j===le)break;return j}}function Le(Z,j,G=Q=>Q){const Q=(...O)=>P.fire(G(...O)),K=()=>Z.on(j,Q),te=()=>Z.removeListener(j,Q),P=new S({onWillAddFirstListener:K,onDidRemoveLastListener:te});return P.event}d.fromNodeEventEmitter=Le;function pe(Z,j,G=Q=>Q){const Q=(...O)=>P.fire(G(...O)),K=()=>Z.addEventListener(j,Q),te=()=>Z.removeEventListener(j,Q),P=new S({onWillAddFirstListener:K,onDidRemoveLastListener:te});return P.event}d.fromDOMEventEmitter=pe;function Ce(Z){return new Promise(j=>R(Z)(j))}d.toPromise=Ce;function be(Z){const j=new S;return Z.then(G=>{j.fire(G)},()=>{j.fire(void 0)}).finally(()=>{j.dispose()}),j.event}d.fromPromise=be;function we(Z,j){return j(void 0),Z(G=>j(G))}d.runAndSubscribe=we;function Se(Z,j){let G=null;function Q(te){G?.dispose(),G=new i.DisposableStore,j(te,G)}Q(void 0);const K=Z(te=>Q(te));return(0,i.toDisposable)(()=>{K.dispose(),G?.dispose()})}d.runAndSubscribeWithStore=Se;class ye{constructor(j,G){this._observable=j,this._counter=0,this._hasChanged=!1;const Q={onWillAddFirstListener:()=>{j.addObserver(this)},onDidRemoveLastListener:()=>{j.removeObserver(this)}};G||w(Q),this.emitter=new S(Q),G&&G.add(this.emitter)}beginUpdate(j){this._counter++}handlePossibleChange(j){}handleChange(j,G){this._hasChanged=!0}endUpdate(j){this._counter--,this._counter===0&&(this._observable.reportChanges(),this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this._observable.get())))}}function _e(Z,j){return new ye(Z,j).emitter.event}d.fromObservable=_e;function de(Z){return j=>{let G=0,Q=!1;const K={beginUpdate(){G++},endUpdate(){G--,G===0&&(Z.reportChanges(),Q&&(Q=!1,j()))},handlePossibleChange(){},handleChange(){Q=!0}};return Z.addObserver(K),Z.reportChanges(),{dispose(){Z.removeObserver(K)}}}}d.fromObservableLight=de})(o||(n.Event=o={}));class C{constructor(w){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${w}_${C._idPool++}`,C.all.add(this)}start(w){this._stopWatch=new f.StopWatch,this.listenerCount=w}stop(){if(this._stopWatch){const w=this._stopWatch.elapsed();this.durations.push(w),this.elapsedOverall+=w,this.invocationCount+=1,this._stopWatch=void 0}}}n.EventProfiling=C,C.all=new Set,C._idPool=0;let e=-1;class m{constructor(w,E=Math.random().toString(18).slice(2,5)){this.threshold=w,this.name=E,this._warnCountdown=0}dispose(){var w;(w=this._stacks)===null||w===void 0||w.clear()}check(w,E){const R=this.threshold;if(R<=0||E<R)return;this._stacks||(this._stacks=new Map);const D=this._stacks.get(w.value)||0;if(this._stacks.set(w.value,D+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=R*.5;let F,U=0;for(const[I,B]of this._stacks)(!F||U<B)&&(F=I,U=B);console.warn(`[${this.name}] potential listener LEAK detected, having ${E} listeners already. MOST frequent listener (${U}):`),console.warn(F)}return()=>{const F=this._stacks.get(w.value)||0;this._stacks.set(w.value,F-1)}}}class g{static create(){var w;return new g((w=new Error().stack)!==null&&w!==void 0?w:"")}constructor(w){this.value=w}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class u{constructor(w){this.value=w}}const b=2,h=(d,w)=>{if(d instanceof u)w(d);else for(let E=0;E<d.length;E++){const R=d[E];R&&w(R)}};class S{constructor(w){var E,R,D,F,U;this._size=0,this._options=w,this._leakageMon=e>0||!((E=this._options)===null||E===void 0)&&E.leakWarningThreshold?new m((D=(R=this._options)===null||R===void 0?void 0:R.leakWarningThreshold)!==null&&D!==void 0?D:e):void 0,this._perfMon=!((F=this._options)===null||F===void 0)&&F._profName?new C(this._options._profName):void 0,this._deliveryQueue=(U=this._options)===null||U===void 0?void 0:U.deliveryQueue}dispose(){var w,E,R,D;if(!this._disposed){if(this._disposed=!0,((w=this._deliveryQueue)===null||w===void 0?void 0:w.current)===this&&this._deliveryQueue.reset(),this._listeners){if(_){const F=this._listeners;queueMicrotask(()=>{h(F,U=>{var I;return(I=U.stack)===null||I===void 0?void 0:I.print()})})}this._listeners=void 0,this._size=0}(R=(E=this._options)===null||E===void 0?void 0:E.onDidRemoveLastListener)===null||R===void 0||R.call(E),(D=this._leakageMon)===null||D===void 0||D.dispose()}}get event(){var w;return(w=this._event)!==null&&w!==void 0||(this._event=(E,R,D)=>{var F,U,I,B,z;if(this._leakageMon&&this._size>this._leakageMon.threshold*3)return console.warn(`[${this._leakageMon.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),i.Disposable.None;if(this._disposed)return i.Disposable.None;R&&(E=E.bind(R));const k=new u(E);let q,x;this._leakageMon&&this._size>=Math.ceil(this._leakageMon.threshold*.2)&&(k.stack=g.create(),q=this._leakageMon.check(k.stack,this._size+1)),_&&(k.stack=x??g.create()),this._listeners?this._listeners instanceof u?((z=this._deliveryQueue)!==null&&z!==void 0||(this._deliveryQueue=new N),this._listeners=[this._listeners,k]):this._listeners.push(k):((U=(F=this._options)===null||F===void 0?void 0:F.onWillAddFirstListener)===null||U===void 0||U.call(F,this),this._listeners=k,(B=(I=this._options)===null||I===void 0?void 0:I.onDidAddFirstListener)===null||B===void 0||B.call(I,this)),this._size++;const H=(0,i.toDisposable)(()=>{q?.(),this._removeListener(k)});return D instanceof i.DisposableStore?D.add(H):Array.isArray(D)&&D.push(H),H}),this._event}_removeListener(w){var E,R,D,F;if((R=(E=this._options)===null||E===void 0?void 0:E.onWillRemoveListener)===null||R===void 0||R.call(E,this),!this._listeners)return;if(this._size===1){this._listeners=void 0,(F=(D=this._options)===null||D===void 0?void 0:D.onDidRemoveLastListener)===null||F===void 0||F.call(D,this),this._size=0;return}const U=this._listeners,I=U.indexOf(w);if(I===-1)throw console.log("disposed?",this._disposed),console.log("size?",this._size),console.log("arr?",JSON.stringify(this._listeners)),new Error("Attempted to dispose unknown listener");this._size--,U[I]=void 0;const B=this._deliveryQueue.current===this;if(this._size*b<=U.length){let z=0;for(let k=0;k<U.length;k++)U[k]?U[z++]=U[k]:B&&(this._deliveryQueue.end--,z<this._deliveryQueue.i&&this._deliveryQueue.i--);U.length=z}}_deliver(w,E){var R;if(!w)return;const D=((R=this._options)===null||R===void 0?void 0:R.onListenerError)||M.onUnexpectedError;if(!D){w.value(E);return}try{w.value(E)}catch(F){D(F)}}_deliverQueue(w){const E=w.current._listeners;for(;w.i<w.end;)this._deliver(E[w.i++],w.value);w.reset()}fire(w){var E,R,D,F;if(!((E=this._deliveryQueue)===null||E===void 0)&&E.current&&(this._deliverQueue(this._deliveryQueue),(R=this._perfMon)===null||R===void 0||R.stop()),(D=this._perfMon)===null||D===void 0||D.start(this._size),this._listeners)if(this._listeners instanceof u)this._deliver(this._listeners,w);else{const U=this._deliveryQueue;U.enqueue(this,w,this._listeners.length),this._deliverQueue(U)}(F=this._perfMon)===null||F===void 0||F.stop()}hasListeners(){return this._size>0}}n.Emitter=S;const v=()=>new N;n.createEventDeliveryQueue=v;class N{constructor(){this.i=-1,this.end=0}enqueue(w,E,R){this.i=0,this.end=R,this.current=w,this.value=E}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class y extends S{constructor(w){super(w),this._isPaused=0,this._eventQueue=new c.LinkedList,this._mergeFn=w?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused===0)if(this._mergeFn){if(this._eventQueue.size>0){const w=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(w))}}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(w){this._size&&(this._isPaused!==0?this._eventQueue.push(w):super.fire(w))}}n.PauseableEmitter=y;class L extends y{constructor(w){var E;super(w),this._delay=(E=w.delay)!==null&&E!==void 0?E:100}fire(w){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(w)}}n.DebounceEmitter=L;class r extends S{constructor(w){super(w),this._queuedEvents=[],this._mergeFn=w?.merge}fire(w){this.hasListeners()&&(this._queuedEvents.push(w),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(E=>super.fire(E)),this._queuedEvents=[]}))}}n.MicrotaskEmitter=r;class s{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new S({onWillAddFirstListener:()=>this.onFirstListenerAdd(),onDidRemoveLastListener:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(w){const E={event:w,listener:null};this.events.push(E),this.hasListeners&&this.hook(E);const R=()=>{this.hasListeners&&this.unhook(E);const D=this.events.indexOf(E);this.events.splice(D,1)};return(0,i.toDisposable)((0,A.once)(R))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(w=>this.hook(w))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(w=>this.unhook(w))}hook(w){w.listener=w.event(E=>this.emitter.fire(E))}unhook(w){w.listener&&w.listener.dispose(),w.listener=null}dispose(){this.emitter.dispose()}}n.EventMultiplexer=s;class a{constructor(){this.buffers=[]}wrapEvent(w){return(E,R,D)=>w(F=>{const U=this.buffers[this.buffers.length-1];U?U.push(()=>E.call(R,F)):E.call(R,F)},void 0,D)}bufferEvents(w){const E=[];this.buffers.push(E);const R=w();return this.buffers.pop(),E.forEach(D=>D()),R}}n.EventBufferer=a;class p{constructor(){this.listening=!1,this.inputEvent=o.None,this.inputEventListener=i.Disposable.None,this.emitter=new S({onDidAddFirstListener:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onDidRemoveLastListener:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(w){this.inputEvent=w,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=w(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}n.Relay=p}),Y(X[38],J([0,1,9]),function(T,n,M){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.CancellationTokenSource=n.CancellationToken=void 0;const A=Object.freeze(function(_,l){const o=setTimeout(_.bind(l),0);return{dispose(){clearTimeout(o)}}});var i;(function(_){function l(o){return o===_.None||o===_.Cancelled||o instanceof c?!0:!o||typeof o!="object"?!1:typeof o.isCancellationRequested=="boolean"&&typeof o.onCancellationRequested=="function"}_.isCancellationToken=l,_.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:M.Event.None}),_.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:A})})(i||(n.CancellationToken=i={}));class c{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?A:(this._emitter||(this._emitter=new M.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class f{constructor(l){this._token=void 0,this._parentListener=void 0,this._parentListener=l&&l.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new c),this._token}cancel(){this._token?this._token instanceof c&&this._token.cancel():this._token=i.Cancelled}dispose(l=!1){var o;l&&this.cancel(),(o=this._parentListener)===null||o===void 0||o.dispose(),this._token?this._token instanceof c&&this._token.dispose():this._token=i.None}}n.CancellationTokenSource=f}),Y(X[6],J([0,1,32,37]),function(T,n,M,A){"use strict";var i;Object.defineProperty(n,"__esModule",{value:!0}),n.InvisibleCharacters=n.AmbiguousCharacters=n.noBreakWhitespace=n.getLeftDeleteOffset=n.singleLetterHash=n.containsUppercaseCharacter=n.startsWithUTF8BOM=n.UTF8_BOM_CHARACTER=n.isEmojiImprecise=n.isFullWidthCharacter=n.containsUnusualLineTerminators=n.UNUSUAL_LINE_TERMINATORS=n.isBasicASCII=n.containsRTL=n.getCharContainingOffset=n.prevCharLength=n.nextCharLength=n.GraphemeIterator=n.CodePointIterator=n.getNextCodePoint=n.computeCodePoint=n.isLowSurrogate=n.isHighSurrogate=n.commonSuffixLength=n.commonPrefixLength=n.startsWithIgnoreCase=n.equalsIgnoreCase=n.isUpperAsciiLetter=n.isLowerAsciiLetter=n.isAsciiDigit=n.compareSubstringIgnoreCase=n.compareIgnoreCase=n.compareSubstring=n.compare=n.lastNonWhitespaceIndex=n.getLeadingWhitespace=n.firstNonWhitespaceIndex=n.splitLines=n.regExpLeadsToEndlessLoop=n.createRegExp=n.stripWildcards=n.convertSimple2RegExpPattern=n.rtrim=n.ltrim=n.trim=n.escapeRegExpCharacters=n.escape=n.format=n.isFalsyOrWhitespace=void 0;function c(P){return!P||typeof P!="string"?!0:P.trim().length===0}n.isFalsyOrWhitespace=c;const f=/{(\d+)}/g;function _(P,...O){return O.length===0?P:P.replace(f,function(W,$){const ee=parseInt($,10);return isNaN(ee)||ee<0||ee>=O.length?W:O[ee]})}n.format=_;function l(P){return P.replace(/[<>&]/g,function(O){switch(O){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return O}})}n.escape=l;function o(P){return P.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}n.escapeRegExpCharacters=o;function C(P,O=" "){const W=e(P,O);return m(W,O)}n.trim=C;function e(P,O){if(!P||!O)return P;const W=O.length;if(W===0||P.length===0)return P;let $=0;for(;P.indexOf(O,$)===$;)$=$+W;return P.substring($)}n.ltrim=e;function m(P,O){if(!P||!O)return P;const W=O.length,$=P.length;if(W===0||$===0)return P;let ee=$,ie=-1;for(;ie=P.lastIndexOf(O,ee-1),!(ie===-1||ie+W!==ee);){if(ie===0)return"";ee=ie}return P.substring(0,ee)}n.rtrim=m;function g(P){return P.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}n.convertSimple2RegExpPattern=g;function u(P){return P.replace(/\*/g,"")}n.stripWildcards=u;function b(P,O,W={}){if(!P)throw new Error("Cannot create regex from empty string");O||(P=o(P)),W.wholeWord&&(/\B/.test(P.charAt(0))||(P="\\b"+P),/\B/.test(P.charAt(P.length-1))||(P=P+"\\b"));let $="";return W.global&&($+="g"),W.matchCase||($+="i"),W.multiline&&($+="m"),W.unicode&&($+="u"),new RegExp(P,$)}n.createRegExp=b;function h(P){return P.source==="^"||P.source==="^$"||P.source==="$"||P.source==="^\\s*$"?!1:!!(P.exec("")&&P.lastIndex===0)}n.regExpLeadsToEndlessLoop=h;function S(P){return P.split(/\r\n|\r|\n/)}n.splitLines=S;function v(P){for(let O=0,W=P.length;O<W;O++){const $=P.charCodeAt(O);if($!==32&&$!==9)return O}return-1}n.firstNonWhitespaceIndex=v;function N(P,O=0,W=P.length){for(let $=O;$<W;$++){const ee=P.charCodeAt($);if(ee!==32&&ee!==9)return P.substring(O,$)}return P.substring(O,W)}n.getLeadingWhitespace=N;function y(P,O=P.length-1){for(let W=O;W>=0;W--){const $=P.charCodeAt(W);if($!==32&&$!==9)return W}return-1}n.lastNonWhitespaceIndex=y;function L(P,O){return P<O?-1:P>O?1:0}n.compare=L;function r(P,O,W=0,$=P.length,ee=0,ie=O.length){for(;W<$&&ee<ie;W++,ee++){const fe=P.charCodeAt(W),se=O.charCodeAt(ee);if(fe<se)return-1;if(fe>se)return 1}const ae=$-W,ce=ie-ee;return ae<ce?-1:ae>ce?1:0}n.compareSubstring=r;function s(P,O){return a(P,O,0,P.length,0,O.length)}n.compareIgnoreCase=s;function a(P,O,W=0,$=P.length,ee=0,ie=O.length){for(;W<$&&ee<ie;W++,ee++){let fe=P.charCodeAt(W),se=O.charCodeAt(ee);if(fe===se)continue;if(fe>=128||se>=128)return r(P.toLowerCase(),O.toLowerCase(),W,$,ee,ie);d(fe)&&(fe-=32),d(se)&&(se-=32);const he=fe-se;if(he!==0)return he}const ae=$-W,ce=ie-ee;return ae<ce?-1:ae>ce?1:0}n.compareSubstringIgnoreCase=a;function p(P){return P>=48&&P<=57}n.isAsciiDigit=p;function d(P){return P>=97&&P<=122}n.isLowerAsciiLetter=d;function w(P){return P>=65&&P<=90}n.isUpperAsciiLetter=w;function E(P,O){return P.length===O.length&&a(P,O)===0}n.equalsIgnoreCase=E;function R(P,O){const W=O.length;return O.length>P.length?!1:a(P,O,0,W)===0}n.startsWithIgnoreCase=R;function D(P,O){const W=Math.min(P.length,O.length);let $;for($=0;$<W;$++)if(P.charCodeAt($)!==O.charCodeAt($))return $;return W}n.commonPrefixLength=D;function F(P,O){const W=Math.min(P.length,O.length);let $;const ee=P.length-1,ie=O.length-1;for($=0;$<W;$++)if(P.charCodeAt(ee-$)!==O.charCodeAt(ie-$))return $;return W}n.commonSuffixLength=F;function U(P){return 55296<=P&&P<=56319}n.isHighSurrogate=U;function I(P){return 56320<=P&&P<=57343}n.isLowSurrogate=I;function B(P,O){return(P-55296<<10)+(O-56320)+65536}n.computeCodePoint=B;function z(P,O,W){const $=P.charCodeAt(W);if(U($)&&W+1<O){const ee=P.charCodeAt(W+1);if(I(ee))return B($,ee)}return $}n.getNextCodePoint=z;function k(P,O){const W=P.charCodeAt(O-1);if(I(W)&&O>1){const $=P.charCodeAt(O-2);if(U($))return B($,W)}return W}class q{get offset(){return this._offset}constructor(O,W=0){this._str=O,this._len=O.length,this._offset=W}setOffset(O){this._offset=O}prevCodePoint(){const O=k(this._str,this._offset);return this._offset-=O>=65536?2:1,O}nextCodePoint(){const O=z(this._str,this._len,this._offset);return this._offset+=O>=65536?2:1,O}eol(){return this._offset>=this._len}}n.CodePointIterator=q;class x{get offset(){return this._iterator.offset}constructor(O,W=0){this._iterator=new q(O,W)}nextGraphemeLength(){const O=de.getInstance(),W=this._iterator,$=W.offset;let ee=O.getGraphemeBreakType(W.nextCodePoint());for(;!W.eol();){const ie=W.offset,ae=O.getGraphemeBreakType(W.nextCodePoint());if(_e(ee,ae)){W.setOffset(ie);break}ee=ae}return W.offset-$}prevGraphemeLength(){const O=de.getInstance(),W=this._iterator,$=W.offset;let ee=O.getGraphemeBreakType(W.prevCodePoint());for(;W.offset>0;){const ie=W.offset,ae=O.getGraphemeBreakType(W.prevCodePoint());if(_e(ae,ee)){W.setOffset(ie);break}ee=ae}return $-W.offset}eol(){return this._iterator.eol()}}n.GraphemeIterator=x;function H(P,O){return new x(P,O).nextGraphemeLength()}n.nextCharLength=H;function V(P,O){return new x(P,O).prevGraphemeLength()}n.prevCharLength=V;function t(P,O){O>0&&I(P.charCodeAt(O))&&O--;const W=O+H(P,O);return[W-V(P,W),W]}n.getCharContainingOffset=t;let ne;function re(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function le(P){return ne||(ne=re()),ne.test(P)}n.containsRTL=le;const me=/^[\t\n\r\x20-\x7E]*$/;function Le(P){return me.test(P)}n.isBasicASCII=Le,n.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function pe(P){return n.UNUSUAL_LINE_TERMINATORS.test(P)}n.containsUnusualLineTerminators=pe;function Ce(P){return P>=11904&&P<=55215||P>=63744&&P<=64255||P>=65281&&P<=65374}n.isFullWidthCharacter=Ce;function be(P){return P>=127462&&P<=127487||P===8986||P===8987||P===9200||P===9203||P>=9728&&P<=10175||P===11088||P===11093||P>=127744&&P<=128591||P>=128640&&P<=128764||P>=128992&&P<=129008||P>=129280&&P<=129535||P>=129648&&P<=129782}n.isEmojiImprecise=be,n.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function we(P){return!!(P&&P.length>0&&P.charCodeAt(0)===65279)}n.startsWithUTF8BOM=we;function Se(P,O=!1){return P?(O&&(P=P.replace(/\\./g,"")),P.toLowerCase()!==P):!1}n.containsUppercaseCharacter=Se;function ye(P){return P=P%(2*26),P<26?String.fromCharCode(97+P):String.fromCharCode(65+P-26)}n.singleLetterHash=ye;function _e(P,O){return P===0?O!==5&&O!==7:P===2&&O===3?!1:P===4||P===2||P===3||O===4||O===2||O===3?!0:!(P===8&&(O===8||O===9||O===11||O===12)||(P===11||P===9)&&(O===9||O===10)||(P===12||P===10)&&O===10||O===5||O===13||O===7||P===1||P===13&&O===14||P===6&&O===6)}class de{static getInstance(){return de._INSTANCE||(de._INSTANCE=new de),de._INSTANCE}constructor(){this._data=Z()}getGraphemeBreakType(O){if(O<32)return O===10?3:O===13?2:4;if(O<127)return 0;const W=this._data,$=W.length/3;let ee=1;for(;ee<=$;)if(O<W[3*ee])ee=2*ee;else if(O>W[3*ee+1])ee=2*ee+1;else return W[3*ee+2];return 0}}de._INSTANCE=null;function Z(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function j(P,O){if(P===0)return 0;const W=G(P,O);if(W!==void 0)return W;const $=new q(O,P);return $.prevCodePoint(),$.offset}n.getLeftDeleteOffset=j;function G(P,O){const W=new q(O,P);let $=W.prevCodePoint();for(;Q($)||$===65039||$===8419;){if(W.offset===0)return;$=W.prevCodePoint()}if(!be($))return;let ee=W.offset;return ee>0&&W.prevCodePoint()===8205&&(ee=W.offset),ee}function Q(P){return 127995<=P&&P<=127999}n.noBreakWhitespace="\xA0";class K{static getInstance(O){return i.cache.get(Array.from(O))}static getLocales(){return i._locales.value}constructor(O){this.confusableDictionary=O}isAmbiguous(O){return this.confusableDictionary.has(O)}getPrimaryConfusable(O){return this.confusableDictionary.get(O)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}n.AmbiguousCharacters=K,i=K,K.ambiguousCharacterData=new A.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),K.cache=new M.LRUCachedFunction(P=>{function O(se){const he=new Map;for(let ge=0;ge<se.length;ge+=2)he.set(se[ge],se[ge+1]);return he}function W(se,he){const ge=new Map(se);for(const[ve,Ne]of he)ge.set(ve,Ne);return ge}function $(se,he){if(!se)return he;const ge=new Map;for(const[ve,Ne]of se)he.has(ve)&&ge.set(ve,Ne);return ge}const ee=i.ambiguousCharacterData.value;let ie=P.filter(se=>!se.startsWith("_")&&se in ee);ie.length===0&&(ie=["_default"]);let ae;for(const se of ie){const he=O(ee[se]);ae=$(ae,he)}const ce=O(ee._common),fe=W(ce,ae);return new i(fe)}),K._locales=new A.Lazy(()=>Object.keys(i.ambiguousCharacterData.value).filter(P=>!P.startsWith("_")));class te{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(te.getRawData())),this._data}static isInvisibleCharacter(O){return te.getData().has(O)}static get codePoints(){return te.getData()}}n.InvisibleCharacters=te,te._data=void 0}),Y(X[39],J([0,1,6]),function(T,n,M){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.StringSHA1=n.toHexString=n.stringHash=n.numberHash=n.doHash=n.hash=void 0;function A(b){return i(b,0)}n.hash=A;function i(b,h){switch(typeof b){case"object":return b===null?c(349,h):Array.isArray(b)?l(b,h):o(b,h);case"string":return _(b,h);case"boolean":return f(b,h);case"number":return c(b,h);case"undefined":return c(937,h);default:return c(617,h)}}n.doHash=i;function c(b,h){return(h<<5)-h+b|0}n.numberHash=c;function f(b,h){return c(b?433:863,h)}function _(b,h){h=c(149417,h);for(let S=0,v=b.length;S<v;S++)h=c(b.charCodeAt(S),h);return h}n.stringHash=_;function l(b,h){return h=c(104579,h),b.reduce((S,v)=>i(v,S),h)}function o(b,h){return h=c(181387,h),Object.keys(b).sort().reduce((S,v)=>(S=_(v,S),i(b[v],S)),h)}function C(b,h,S=32){const v=S-h,N=~((1<<v)-1);return(b<<h|(N&b)>>>v)>>>0}function e(b,h=0,S=b.byteLength,v=0){for(let N=0;N<S;N++)b[h+N]=v}function m(b,h,S="0"){for(;b.length<h;)b=S+b;return b}function g(b,h=32){return b instanceof ArrayBuffer?Array.from(new Uint8Array(b)).map(S=>S.toString(16).padStart(2,"0")).join(""):m((b>>>0).toString(16),h/4)}n.toHexString=g;class u{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(h){const S=h.length;if(S===0)return;const v=this._buff;let N=this._buffLen,y=this._leftoverHighSurrogate,L,r;for(y!==0?(L=y,r=-1,y=0):(L=h.charCodeAt(0),r=0);;){let s=L;if(M.isHighSurrogate(L))if(r+1<S){const a=h.charCodeAt(r+1);M.isLowSurrogate(a)?(r++,s=M.computeCodePoint(L,a)):s=65533}else{y=L;break}else M.isLowSurrogate(L)&&(s=65533);if(N=this._push(v,N,s),r++,r<S)L=h.charCodeAt(r);else break}this._buffLen=N,this._leftoverHighSurrogate=y}_push(h,S,v){return v<128?h[S++]=v:v<2048?(h[S++]=192|(v&1984)>>>6,h[S++]=128|(v&63)>>>0):v<65536?(h[S++]=224|(v&61440)>>>12,h[S++]=128|(v&4032)>>>6,h[S++]=128|(v&63)>>>0):(h[S++]=240|(v&1835008)>>>18,h[S++]=128|(v&258048)>>>12,h[S++]=128|(v&4032)>>>6,h[S++]=128|(v&63)>>>0),S>=64&&(this._step(),S-=64,this._totalLen+=64,h[0]=h[64+0],h[1]=h[64+1],h[2]=h[64+2]),S}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),g(this._h0)+g(this._h1)+g(this._h2)+g(this._h3)+g(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,e(this._buff,this._buffLen),this._buffLen>56&&(this._step(),e(this._buff));const h=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(h/4294967296),!1),this._buffDV.setUint32(60,h%4294967296,!1),this._step()}_step(){const h=u._bigBlock32,S=this._buffDV;for(let d=0;d<64;d+=4)h.setUint32(d,S.getUint32(d,!1),!1);for(let d=64;d<320;d+=4)h.setUint32(d,C(h.getUint32(d-12,!1)^h.getUint32(d-32,!1)^h.getUint32(d-56,!1)^h.getUint32(d-64,!1),1),!1);let v=this._h0,N=this._h1,y=this._h2,L=this._h3,r=this._h4,s,a,p;for(let d=0;d<80;d++)d<20?(s=N&y|~N&L,a=1518500249):d<40?(s=N^y^L,a=1859775393):d<60?(s=N&y|N&L|y&L,a=2400959708):(s=N^y^L,a=3395469782),p=C(v,5)+s+r+a+h.getUint32(d*4,!1)&4294967295,r=L,L=y,y=C(N,30),N=v,v=p;this._h0=this._h0+v&4294967295,this._h1=this._h1+N&4294967295,this._h2=this._h2+y&4294967295,this._h3=this._h3+L&4294967295,this._h4=this._h4+r&4294967295}}n.StringSHA1=u,u._bigBlock32=new DataView(new ArrayBuffer(320))}),Y(X[24],J([0,1,35,39]),function(T,n,M,A){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.LcsDiff=n.stringDiff=n.StringDiffSequence=void 0;class i{constructor(e){this.source=e}getElements(){const e=this.source,m=new Int32Array(e.length);for(let g=0,u=e.length;g<u;g++)m[g]=e.charCodeAt(g);return m}}n.StringDiffSequence=i;function c(C,e,m){return new o(new i(C),new i(e)).ComputeDiff(m).changes}n.stringDiff=c;class f{static Assert(e,m){if(!e)throw new Error(m)}}class _{static Copy(e,m,g,u,b){for(let h=0;h<b;h++)g[u+h]=e[m+h]}static Copy2(e,m,g,u,b){for(let h=0;h<b;h++)g[u+h]=e[m+h]}}class l{constructor(){this.m_changes=[],this.m_originalStart=1073741824,this.m_modifiedStart=1073741824,this.m_originalCount=0,this.m_modifiedCount=0}MarkNextChange(){(this.m_originalCount>0||this.m_modifiedCount>0)&&this.m_changes.push(new M.DiffChange(this.m_originalStart,this.m_originalCount,this.m_modifiedStart,this.m_modifiedCount)),this.m_originalCount=0,this.m_modifiedCount=0,this.m_originalStart=1073741824,this.m_modifiedStart=1073741824}AddOriginalElement(e,m){this.m_originalStart=Math.min(this.m_originalStart,e),this.m_modifiedStart=Math.min(this.m_modifiedStart,m),this.m_originalCount++}AddModifiedElement(e,m){this.m_originalStart=Math.min(this.m_originalStart,e),this.m_modifiedStart=Math.min(this.m_modifiedStart,m),this.m_modifiedCount++}getChanges(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes}getReverseChanges(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes.reverse(),this.m_changes}}class o{constructor(e,m,g=null){this.ContinueProcessingPredicate=g,this._originalSequence=e,this._modifiedSequence=m;const[u,b,h]=o._getElements(e),[S,v,N]=o._getElements(m);this._hasStrings=h&&N,this._originalStringElements=u,this._originalElementsOrHash=b,this._modifiedStringElements=S,this._modifiedElementsOrHash=v,this.m_forwardHistory=[],this.m_reverseHistory=[]}static _isStringArray(e){return e.length>0&&typeof e[0]=="string"}static _getElements(e){const m=e.getElements();if(o._isStringArray(m)){const g=new Int32Array(m.length);for(let u=0,b=m.length;u<b;u++)g[u]=(0,A.stringHash)(m[u],0);return[m,g,!0]}return m instanceof Int32Array?[[],m,!1]:[[],new Int32Array(m),!1]}ElementsAreEqual(e,m){return this._originalElementsOrHash[e]!==this._modifiedElementsOrHash[m]?!1:this._hasStrings?this._originalStringElements[e]===this._modifiedStringElements[m]:!0}ElementsAreStrictEqual(e,m){if(!this.ElementsAreEqual(e,m))return!1;const g=o._getStrictElement(this._originalSequence,e),u=o._getStrictElement(this._modifiedSequence,m);return g===u}static _getStrictElement(e,m){return typeof e.getStrictElement=="function"?e.getStrictElement(m):null}OriginalElementsAreEqual(e,m){return this._originalElementsOrHash[e]!==this._originalElementsOrHash[m]?!1:this._hasStrings?this._originalStringElements[e]===this._originalStringElements[m]:!0}ModifiedElementsAreEqual(e,m){return this._modifiedElementsOrHash[e]!==this._modifiedElementsOrHash[m]?!1:this._hasStrings?this._modifiedStringElements[e]===this._modifiedStringElements[m]:!0}ComputeDiff(e){return this._ComputeDiff(0,this._originalElementsOrHash.length-1,0,this._modifiedElementsOrHash.length-1,e)}_ComputeDiff(e,m,g,u,b){const h=[!1];let S=this.ComputeDiffRecursive(e,m,g,u,h);return b&&(S=this.PrettifyChanges(S)),{quitEarly:h[0],changes:S}}ComputeDiffRecursive(e,m,g,u,b){for(b[0]=!1;e<=m&&g<=u&&this.ElementsAreEqual(e,g);)e++,g++;for(;m>=e&&u>=g&&this.ElementsAreEqual(m,u);)m--,u--;if(e>m||g>u){let L;return g<=u?(f.Assert(e===m+1,"originalStart should only be one more than originalEnd"),L=[new M.DiffChange(e,0,g,u-g+1)]):e<=m?(f.Assert(g===u+1,"modifiedStart should only be one more than modifiedEnd"),L=[new M.DiffChange(e,m-e+1,g,0)]):(f.Assert(e===m+1,"originalStart should only be one more than originalEnd"),f.Assert(g===u+1,"modifiedStart should only be one more than modifiedEnd"),L=[]),L}const h=[0],S=[0],v=this.ComputeRecursionPoint(e,m,g,u,h,S,b),N=h[0],y=S[0];if(v!==null)return v;if(!b[0]){const L=this.ComputeDiffRecursive(e,N,g,y,b);let r=[];return b[0]?r=[new M.DiffChange(N+1,m-(N+1)+1,y+1,u-(y+1)+1)]:r=this.ComputeDiffRecursive(N+1,m,y+1,u,b),this.ConcatenateChanges(L,r)}return[new M.DiffChange(e,m-e+1,g,u-g+1)]}WALKTRACE(e,m,g,u,b,h,S,v,N,y,L,r,s,a,p,d,w,E){let R=null,D=null,F=new l,U=m,I=g,B=s[0]-d[0]-u,z=-1073741824,k=this.m_forwardHistory.length-1;do{const q=B+e;q===U||q<I&&N[q-1]<N[q+1]?(L=N[q+1],a=L-B-u,L<z&&F.MarkNextChange(),z=L,F.AddModifiedElement(L+1,a),B=q+1-e):(L=N[q-1]+1,a=L-B-u,L<z&&F.MarkNextChange(),z=L-1,F.AddOriginalElement(L,a+1),B=q-1-e),k>=0&&(N=this.m_forwardHistory[k],e=N[0],U=1,I=N.length-1)}while(--k>=-1);if(R=F.getReverseChanges(),E[0]){let q=s[0]+1,x=d[0]+1;if(R!==null&&R.length>0){const H=R[R.length-1];q=Math.max(q,H.getOriginalEnd()),x=Math.max(x,H.getModifiedEnd())}D=[new M.DiffChange(q,r-q+1,x,p-x+1)]}else{F=new l,U=h,I=S,B=s[0]-d[0]-v,z=1073741824,k=w?this.m_reverseHistory.length-1:this.m_reverseHistory.length-2;do{const q=B+b;q===U||q<I&&y[q-1]>=y[q+1]?(L=y[q+1]-1,a=L-B-v,L>z&&F.MarkNextChange(),z=L+1,F.AddOriginalElement(L+1,a+1),B=q+1-b):(L=y[q-1],a=L-B-v,L>z&&F.MarkNextChange(),z=L,F.AddModifiedElement(L+1,a+1),B=q-1-b),k>=0&&(y=this.m_reverseHistory[k],b=y[0],U=1,I=y.length-1)}while(--k>=-1);D=F.getChanges()}return this.ConcatenateChanges(R,D)}ComputeRecursionPoint(e,m,g,u,b,h,S){let v=0,N=0,y=0,L=0,r=0,s=0;e--,g--,b[0]=0,h[0]=0,this.m_forwardHistory=[],this.m_reverseHistory=[];const a=m-e+(u-g),p=a+1,d=new Int32Array(p),w=new Int32Array(p),E=u-g,R=m-e,D=e-g,F=m-u,I=(R-E)%2===0;d[E]=e,w[R]=m,S[0]=!1;for(let B=1;B<=a/2+1;B++){let z=0,k=0;y=this.ClipDiagonalBound(E-B,B,E,p),L=this.ClipDiagonalBound(E+B,B,E,p);for(let x=y;x<=L;x+=2){x===y||x<L&&d[x-1]<d[x+1]?v=d[x+1]:v=d[x-1]+1,N=v-(x-E)-D;const H=v;for(;v<m&&N<u&&this.ElementsAreEqual(v+1,N+1);)v++,N++;if(d[x]=v,v+N>z+k&&(z=v,k=N),!I&&Math.abs(x-R)<=B-1&&v>=w[x])return b[0]=v,h[0]=N,H<=w[x]&&1447>0&&B<=1447+1?this.WALKTRACE(E,y,L,D,R,r,s,F,d,w,v,m,b,N,u,h,I,S):null}const q=(z-e+(k-g)-B)/2;if(this.ContinueProcessingPredicate!==null&&!this.ContinueProcessingPredicate(z,q))return S[0]=!0,b[0]=z,h[0]=k,q>0&&1447>0&&B<=1447+1?this.WALKTRACE(E,y,L,D,R,r,s,F,d,w,v,m,b,N,u,h,I,S):(e++,g++,[new M.DiffChange(e,m-e+1,g,u-g+1)]);r=this.ClipDiagonalBound(R-B,B,R,p),s=this.ClipDiagonalBound(R+B,B,R,p);for(let x=r;x<=s;x+=2){x===r||x<s&&w[x-1]>=w[x+1]?v=w[x+1]-1:v=w[x-1],N=v-(x-R)-F;const H=v;for(;v>e&&N>g&&this.ElementsAreEqual(v,N);)v--,N--;if(w[x]=v,I&&Math.abs(x-E)<=B&&v<=d[x])return b[0]=v,h[0]=N,H>=d[x]&&1447>0&&B<=1447+1?this.WALKTRACE(E,y,L,D,R,r,s,F,d,w,v,m,b,N,u,h,I,S):null}if(B<=1447){let x=new Int32Array(L-y+2);x[0]=E-y+1,_.Copy2(d,y,x,1,L-y+1),this.m_forwardHistory.push(x),x=new Int32Array(s-r+2),x[0]=R-r+1,_.Copy2(w,r,x,1,s-r+1),this.m_reverseHistory.push(x)}}return this.WALKTRACE(E,y,L,D,R,r,s,F,d,w,v,m,b,N,u,h,I,S)}PrettifyChanges(e){for(let m=0;m<e.length;m++){const g=e[m],u=m<e.length-1?e[m+1].originalStart:this._originalElementsOrHash.length,b=m<e.length-1?e[m+1].modifiedStart:this._modifiedElementsOrHash.length,h=g.originalLength>0,S=g.modifiedLength>0;for(;g.originalStart+g.originalLength<u&&g.modifiedStart+g.modifiedLength<b&&(!h||this.OriginalElementsAreEqual(g.originalStart,g.originalStart+g.originalLength))&&(!S||this.ModifiedElementsAreEqual(g.modifiedStart,g.modifiedStart+g.modifiedLength));){const N=this.ElementsAreStrictEqual(g.originalStart,g.modifiedStart);if(this.ElementsAreStrictEqual(g.originalStart+g.originalLength,g.modifiedStart+g.modifiedLength)&&!N)break;g.originalStart++,g.modifiedStart++}const v=[null];if(m<e.length-1&&this.ChangesOverlap(e[m],e[m+1],v)){e[m]=v[0],e.splice(m+1,1),m--;continue}}for(let m=e.length-1;m>=0;m--){const g=e[m];let u=0,b=0;if(m>0){const L=e[m-1];u=L.originalStart+L.originalLength,b=L.modifiedStart+L.modifiedLength}const h=g.originalLength>0,S=g.modifiedLength>0;let v=0,N=this._boundaryScore(g.originalStart,g.originalLength,g.modifiedStart,g.modifiedLength);for(let L=1;;L++){const r=g.originalStart-L,s=g.modifiedStart-L;if(r<u||s<b||h&&!this.OriginalElementsAreEqual(r,r+g.originalLength)||S&&!this.ModifiedElementsAreEqual(s,s+g.modifiedLength))break;const p=(r===u&&s===b?5:0)+this._boundaryScore(r,g.originalLength,s,g.modifiedLength);p>N&&(N=p,v=L)}g.originalStart-=v,g.modifiedStart-=v;const y=[null];if(m>0&&this.ChangesOverlap(e[m-1],e[m],y)){e[m-1]=y[0],e.splice(m,1),m++;continue}}if(this._hasStrings)for(let m=1,g=e.length;m<g;m++){const u=e[m-1],b=e[m],h=b.originalStart-u.originalStart-u.originalLength,S=u.originalStart,v=b.originalStart+b.originalLength,N=v-S,y=u.modifiedStart,L=b.modifiedStart+b.modifiedLength,r=L-y;if(h<5&&N<20&&r<20){const s=this._findBetterContiguousSequence(S,N,y,r,h);if(s){const[a,p]=s;(a!==u.originalStart+u.originalLength||p!==u.modifiedStart+u.modifiedLength)&&(u.originalLength=a-u.originalStart,u.modifiedLength=p-u.modifiedStart,b.originalStart=a+h,b.modifiedStart=p+h,b.originalLength=v-b.originalStart,b.modifiedLength=L-b.modifiedStart)}}}return e}_findBetterContiguousSequence(e,m,g,u,b){if(m<b||u<b)return null;const h=e+m-b+1,S=g+u-b+1;let v=0,N=0,y=0;for(let L=e;L<h;L++)for(let r=g;r<S;r++){const s=this._contiguousSequenceScore(L,r,b);s>0&&s>v&&(v=s,N=L,y=r)}return v>0?[N,y]:null}_contiguousSequenceScore(e,m,g){let u=0;for(let b=0;b<g;b++){if(!this.ElementsAreEqual(e+b,m+b))return 0;u+=this._originalStringElements[e+b].length}return u}_OriginalIsBoundary(e){return e<=0||e>=this._originalElementsOrHash.length-1?!0:this._hasStrings&&/^\s*$/.test(this._originalStringElements[e])}_OriginalRegionIsBoundary(e,m){if(this._OriginalIsBoundary(e)||this._OriginalIsBoundary(e-1))return!0;if(m>0){const g=e+m;if(this._OriginalIsBoundary(g-1)||this._OriginalIsBoundary(g))return!0}return!1}_ModifiedIsBoundary(e){return e<=0||e>=this._modifiedElementsOrHash.length-1?!0:this._hasStrings&&/^\s*$/.test(this._modifiedStringElements[e])}_ModifiedRegionIsBoundary(e,m){if(this._ModifiedIsBoundary(e)||this._ModifiedIsBoundary(e-1))return!0;if(m>0){const g=e+m;if(this._ModifiedIsBoundary(g-1)||this._ModifiedIsBoundary(g))return!0}return!1}_boundaryScore(e,m,g,u){const b=this._OriginalRegionIsBoundary(e,m)?1:0,h=this._ModifiedRegionIsBoundary(g,u)?1:0;return b+h}ConcatenateChanges(e,m){const g=[];if(e.length===0||m.length===0)return m.length>0?m:e;if(this.ChangesOverlap(e[e.length-1],m[0],g)){const u=new Array(e.length+m.length-1);return _.Copy(e,0,u,0,e.length-1),u[e.length-1]=g[0],_.Copy(m,1,u,e.length,m.length-1),u}else{const u=new Array(e.length+m.length);return _.Copy(e,0,u,0,e.length),_.Copy(m,0,u,e.length,m.length),u}}ChangesOverlap(e,m,g){if(f.Assert(e.originalStart<=m.originalStart,"Left change is not less than or equal to right change"),f.Assert(e.modifiedStart<=m.modifiedStart,"Left change is not less than or equal to right change"),e.originalStart+e.originalLength>=m.originalStart||e.modifiedStart+e.modifiedLength>=m.modifiedStart){const u=e.originalStart;let b=e.originalLength;const h=e.modifiedStart;let S=e.modifiedLength;return e.originalStart+e.originalLength>=m.originalStart&&(b=m.originalStart+m.originalLength-e.originalStart),e.modifiedStart+e.modifiedLength>=m.modifiedStart&&(S=m.modifiedStart+m.modifiedLength-e.modifiedStart),g[0]=new M.DiffChange(u,b,h,S),!0}else return g[0]=null,!1}ClipDiagonalBound(e,m,g,u){if(e>=0&&e<u)return e;const b=g,h=u-g-1,S=m%2===0;if(e<0){const v=b%2===0;return S===v?0:1}else{const v=h%2===0;return S===v?u-1:u-2}}}n.LcsDiff=o}),Y(X[25],J([0,1]),function(T,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.validateConstraint=n.validateConstraints=n.isFunction=n.assertIsDefined=n.assertType=n.isUndefinedOrNull=n.isDefined=n.isUndefined=n.isBoolean=n.isIterable=n.isNumber=n.isTypedArray=n.isObject=n.isString=void 0;function M(h){return typeof h=="string"}n.isString=M;function A(h){return typeof h=="object"&&h!==null&&!Array.isArray(h)&&!(h instanceof RegExp)&&!(h instanceof Date)}n.isObject=A;function i(h){const S=Object.getPrototypeOf(Uint8Array);return typeof h=="object"&&h instanceof S}n.isTypedArray=i;function c(h){return typeof h=="number"&&!isNaN(h)}n.isNumber=c;function f(h){return!!h&&typeof h[Symbol.iterator]=="function"}n.isIterable=f;function _(h){return h===!0||h===!1}n.isBoolean=_;function l(h){return typeof h>"u"}n.isUndefined=l;function o(h){return!C(h)}n.isDefined=o;function C(h){return l(h)||h===null}n.isUndefinedOrNull=C;function e(h,S){if(!h)throw new Error(S?`Unexpected type, expected '${S}'`:"Unexpected type")}n.assertType=e;function m(h){if(C(h))throw new Error("Assertion Failed: argument is undefined or null");return h}n.assertIsDefined=m;function g(h){return typeof h=="function"}n.isFunction=g;function u(h,S){const v=Math.min(h.length,S.length);for(let N=0;N<v;N++)b(h[N],S[N])}n.validateConstraints=u;function b(h,S){if(M(S)){if(typeof h!==S)throw new Error(`argument does not match constraint: typeof ${S}`)}else if(g(S)){try{if(h instanceof S)return}catch{}if(!C(h)&&h.constructor===S||S.length===1&&S.call(void 0,h)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}n.validateConstraint=b}),Y(X[40],J([0,1,25]),function(T,n,M){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Codicon=n.getCodiconFontCharacters=void 0;const A=Object.create(null);function i(f,_){if((0,M.isString)(_)){const l=A[_];if(l===void 0)throw new Error(`${f} references an unknown codicon: ${_}`);_=l}return A[f]=_,{id:f}}function c(){return A}n.getCodiconFontCharacters=c,n.Codicon={add:i("add",6e4),plus:i("plus",6e4),gistNew:i("gist-new",6e4),repoCreate:i("repo-create",6e4),lightbulb:i("lightbulb",60001),lightBulb:i("light-bulb",60001),repo:i("repo",60002),repoDelete:i("repo-delete",60002),gistFork:i("gist-fork",60003),repoForked:i("repo-forked",60003),gitPullRequest:i("git-pull-request",60004),gitPullRequestAbandoned:i("git-pull-request-abandoned",60004),recordKeys:i("record-keys",60005),keyboard:i("keyboard",60005),tag:i("tag",60006),tagAdd:i("tag-add",60006),tagRemove:i("tag-remove",60006),gitPullRequestLabel:i("git-pull-request-label",60006),person:i("person",60007),personFollow:i("person-follow",60007),personOutline:i("person-outline",60007),personFilled:i("person-filled",60007),gitBranch:i("git-branch",60008),gitBranchCreate:i("git-branch-create",60008),gitBranchDelete:i("git-branch-delete",60008),sourceControl:i("source-control",60008),mirror:i("mirror",60009),mirrorPublic:i("mirror-public",60009),star:i("star",60010),starAdd:i("star-add",60010),starDelete:i("star-delete",60010),starEmpty:i("star-empty",60010),comment:i("comment",60011),commentAdd:i("comment-add",60011),alert:i("alert",60012),warning:i("warning",60012),search:i("search",60013),searchSave:i("search-save",60013),logOut:i("log-out",60014),signOut:i("sign-out",60014),logIn:i("log-in",60015),signIn:i("sign-in",60015),eye:i("eye",60016),eyeUnwatch:i("eye-unwatch",60016),eyeWatch:i("eye-watch",60016),circleFilled:i("circle-filled",60017),primitiveDot:i("primitive-dot",60017),closeDirty:i("close-dirty",60017),debugBreakpoint:i("debug-breakpoint",60017),debugBreakpointDisabled:i("debug-breakpoint-disabled",60017),debugHint:i("debug-hint",60017),primitiveSquare:i("primitive-square",60018),edit:i("edit",60019),pencil:i("pencil",60019),info:i("info",60020),issueOpened:i("issue-opened",60020),gistPrivate:i("gist-private",60021),gitForkPrivate:i("git-fork-private",60021),lock:i("lock",60021),mirrorPrivate:i("mirror-private",60021),close:i("close",60022),removeClose:i("remove-close",60022),x:i("x",60022),repoSync:i("repo-sync",60023),sync:i("sync",60023),clone:i("clone",60024),desktopDownload:i("desktop-download",60024),beaker:i("beaker",60025),microscope:i("microscope",60025),vm:i("vm",60026),deviceDesktop:i("device-desktop",60026),file:i("file",60027),fileText:i("file-text",60027),more:i("more",60028),ellipsis:i("ellipsis",60028),kebabHorizontal:i("kebab-horizontal",60028),mailReply:i("mail-reply",60029),reply:i("reply",60029),organization:i("organization",60030),organizationFilled:i("organization-filled",60030),organizationOutline:i("organization-outline",60030),newFile:i("new-file",60031),fileAdd:i("file-add",60031),newFolder:i("new-folder",60032),fileDirectoryCreate:i("file-directory-create",60032),trash:i("trash",60033),trashcan:i("trashcan",60033),history:i("history",60034),clock:i("clock",60034),folder:i("folder",60035),fileDirectory:i("file-directory",60035),symbolFolder:i("symbol-folder",60035),logoGithub:i("logo-github",60036),markGithub:i("mark-github",60036),github:i("github",60036),terminal:i("terminal",60037),console:i("console",60037),repl:i("repl",60037),zap:i("zap",60038),symbolEvent:i("symbol-event",60038),error:i("error",60039),stop:i("stop",60039),variable:i("variable",60040),symbolVariable:i("symbol-variable",60040),array:i("array",60042),symbolArray:i("symbol-array",60042),symbolModule:i("symbol-module",60043),symbolPackage:i("symbol-package",60043),symbolNamespace:i("symbol-namespace",60043),symbolObject:i("symbol-object",60043),symbolMethod:i("symbol-method",60044),symbolFunction:i("symbol-function",60044),symbolConstructor:i("symbol-constructor",60044),symbolBoolean:i("symbol-boolean",60047),symbolNull:i("symbol-null",60047),symbolNumeric:i("symbol-numeric",60048),symbolNumber:i("symbol-number",60048),symbolStructure:i("symbol-structure",60049),symbolStruct:i("symbol-struct",60049),symbolParameter:i("symbol-parameter",60050),symbolTypeParameter:i("symbol-type-parameter",60050),symbolKey:i("symbol-key",60051),symbolText:i("symbol-text",60051),symbolReference:i("symbol-reference",60052),goToFile:i("go-to-file",60052),symbolEnum:i("symbol-enum",60053),symbolValue:i("symbol-value",60053),symbolRuler:i("symbol-ruler",60054),symbolUnit:i("symbol-unit",60054),activateBreakpoints:i("activate-breakpoints",60055),archive:i("archive",60056),arrowBoth:i("arrow-both",60057),arrowDown:i("arrow-down",60058),arrowLeft:i("arrow-left",60059),arrowRight:i("arrow-right",60060),arrowSmallDown:i("arrow-small-down",60061),arrowSmallLeft:i("arrow-small-left",60062),arrowSmallRight:i("arrow-small-right",60063),arrowSmallUp:i("arrow-small-up",60064),arrowUp:i("arrow-up",60065),bell:i("bell",60066),bold:i("bold",60067),book:i("book",60068),bookmark:i("bookmark",60069),debugBreakpointConditionalUnverified:i("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:i("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:i("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:i("debug-breakpoint-data-unverified",60072),debugBreakpointData:i("debug-breakpoint-data",60073),debugBreakpointDataDisabled:i("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:i("debug-breakpoint-log-unverified",60074),debugBreakpointLog:i("debug-breakpoint-log",60075),debugBreakpointLogDisabled:i("debug-breakpoint-log-disabled",60075),briefcase:i("briefcase",60076),broadcast:i("broadcast",60077),browser:i("browser",60078),bug:i("bug",60079),calendar:i("calendar",60080),caseSensitive:i("case-sensitive",60081),check:i("check",60082),checklist:i("checklist",60083),chevronDown:i("chevron-down",60084),dropDownButton:i("drop-down-button",60084),chevronLeft:i("chevron-left",60085),chevronRight:i("chevron-right",60086),chevronUp:i("chevron-up",60087),chromeClose:i("chrome-close",60088),chromeMaximize:i("chrome-maximize",60089),chromeMinimize:i("chrome-minimize",60090),chromeRestore:i("chrome-restore",60091),circle:i("circle",60092),circleOutline:i("circle-outline",60092),debugBreakpointUnverified:i("debug-breakpoint-unverified",60092),circleSlash:i("circle-slash",60093),circuitBoard:i("circuit-board",60094),clearAll:i("clear-all",60095),clippy:i("clippy",60096),closeAll:i("close-all",60097),cloudDownload:i("cloud-download",60098),cloudUpload:i("cloud-upload",60099),code:i("code",60100),collapseAll:i("collapse-all",60101),colorMode:i("color-mode",60102),commentDiscussion:i("comment-discussion",60103),compareChanges:i("compare-changes",60157),creditCard:i("credit-card",60105),dash:i("dash",60108),dashboard:i("dashboard",60109),database:i("database",60110),debugContinue:i("debug-continue",60111),debugDisconnect:i("debug-disconnect",60112),debugPause:i("debug-pause",60113),debugRestart:i("debug-restart",60114),debugStart:i("debug-start",60115),debugStepInto:i("debug-step-into",60116),debugStepOut:i("debug-step-out",60117),debugStepOver:i("debug-step-over",60118),debugStop:i("debug-stop",60119),debug:i("debug",60120),deviceCameraVideo:i("device-camera-video",60121),deviceCamera:i("device-camera",60122),deviceMobile:i("device-mobile",60123),diffAdded:i("diff-added",60124),diffIgnored:i("diff-ignored",60125),diffModified:i("diff-modified",60126),diffRemoved:i("diff-removed",60127),diffRenamed:i("diff-renamed",60128),diff:i("diff",60129),discard:i("discard",60130),editorLayout:i("editor-layout",60131),emptyWindow:i("empty-window",60132),exclude:i("exclude",60133),extensions:i("extensions",60134),eyeClosed:i("eye-closed",60135),fileBinary:i("file-binary",60136),fileCode:i("file-code",60137),fileMedia:i("file-media",60138),filePdf:i("file-pdf",60139),fileSubmodule:i("file-submodule",60140),fileSymlinkDirectory:i("file-symlink-directory",60141),fileSymlinkFile:i("file-symlink-file",60142),fileZip:i("file-zip",60143),files:i("files",60144),filter:i("filter",60145),flame:i("flame",60146),foldDown:i("fold-down",60147),foldUp:i("fold-up",60148),fold:i("fold",60149),folderActive:i("folder-active",60150),folderOpened:i("folder-opened",60151),gear:i("gear",60152),gift:i("gift",60153),gistSecret:i("gist-secret",60154),gist:i("gist",60155),gitCommit:i("git-commit",60156),gitCompare:i("git-compare",60157),gitMerge:i("git-merge",60158),githubAction:i("github-action",60159),githubAlt:i("github-alt",60160),globe:i("globe",60161),grabber:i("grabber",60162),graph:i("graph",60163),gripper:i("gripper",60164),heart:i("heart",60165),home:i("home",60166),horizontalRule:i("horizontal-rule",60167),hubot:i("hubot",60168),inbox:i("inbox",60169),issueClosed:i("issue-closed",60324),issueReopened:i("issue-reopened",60171),issues:i("issues",60172),italic:i("italic",60173),jersey:i("jersey",60174),json:i("json",60175),bracket:i("bracket",60175),kebabVertical:i("kebab-vertical",60176),key:i("key",60177),law:i("law",60178),lightbulbAutofix:i("lightbulb-autofix",60179),linkExternal:i("link-external",60180),link:i("link",60181),listOrdered:i("list-ordered",60182),listUnordered:i("list-unordered",60183),liveShare:i("live-share",60184),loading:i("loading",60185),location:i("location",60186),mailRead:i("mail-read",60187),mail:i("mail",60188),markdown:i("markdown",60189),megaphone:i("megaphone",60190),mention:i("mention",60191),milestone:i("milestone",60192),gitPullRequestMilestone:i("git-pull-request-milestone",60192),mortarBoard:i("mortar-board",60193),move:i("move",60194),multipleWindows:i("multiple-windows",60195),mute:i("mute",60196),noNewline:i("no-newline",60197),note:i("note",60198),octoface:i("octoface",60199),openPreview:i("open-preview",60200),package_:i("package",60201),paintcan:i("paintcan",60202),pin:i("pin",60203),play:i("play",60204),run:i("run",60204),plug:i("plug",60205),preserveCase:i("preserve-case",60206),preview:i("preview",60207),project:i("project",60208),pulse:i("pulse",60209),question:i("question",60210),quote:i("quote",60211),radioTower:i("radio-tower",60212),reactions:i("reactions",60213),references:i("references",60214),refresh:i("refresh",60215),regex:i("regex",60216),remoteExplorer:i("remote-explorer",60217),remote:i("remote",60218),remove:i("remove",60219),replaceAll:i("replace-all",60220),replace:i("replace",60221),repoClone:i("repo-clone",60222),repoForcePush:i("repo-force-push",60223),repoPull:i("repo-pull",60224),repoPush:i("repo-push",60225),report:i("report",60226),requestChanges:i("request-changes",60227),rocket:i("rocket",60228),rootFolderOpened:i("root-folder-opened",60229),rootFolder:i("root-folder",60230),rss:i("rss",60231),ruby:i("ruby",60232),saveAll:i("save-all",60233),saveAs:i("save-as",60234),save:i("save",60235),screenFull:i("screen-full",60236),screenNormal:i("screen-normal",60237),searchStop:i("search-stop",60238),server:i("server",60240),settingsGear:i("settings-gear",60241),settings:i("settings",60242),shield:i("shield",60243),smiley:i("smiley",60244),sortPrecedence:i("sort-precedence",60245),splitHorizontal:i("split-horizontal",60246),splitVertical:i("split-vertical",60247),squirrel:i("squirrel",60248),starFull:i("star-full",60249),starHalf:i("star-half",60250),symbolClass:i("symbol-class",60251),symbolColor:i("symbol-color",60252),symbolCustomColor:i("symbol-customcolor",60252),symbolConstant:i("symbol-constant",60253),symbolEnumMember:i("symbol-enum-member",60254),symbolField:i("symbol-field",60255),symbolFile:i("symbol-file",60256),symbolInterface:i("symbol-interface",60257),symbolKeyword:i("symbol-keyword",60258),symbolMisc:i("symbol-misc",60259),symbolOperator:i("symbol-operator",60260),symbolProperty:i("symbol-property",60261),wrench:i("wrench",60261),wrenchSubaction:i("wrench-subaction",60261),symbolSnippet:i("symbol-snippet",60262),tasklist:i("tasklist",60263),telescope:i("telescope",60264),textSize:i("text-size",60265),threeBars:i("three-bars",60266),thumbsdown:i("thumbsdown",60267),thumbsup:i("thumbsup",60268),tools:i("tools",60269),triangleDown:i("triangle-down",60270),triangleLeft:i("triangle-left",60271),triangleRight:i("triangle-right",60272),triangleUp:i("triangle-up",60273),twitter:i("twitter",60274),unfold:i("unfold",60275),unlock:i("unlock",60276),unmute:i("unmute",60277),unverified:i("unverified",60278),verified:i("verified",60279),versions:i("versions",60280),vmActive:i("vm-active",60281),vmOutline:i("vm-outline",60282),vmRunning:i("vm-running",60283),watch:i("watch",60284),whitespace:i("whitespace",60285),wholeWord:i("whole-word",60286),window:i("window",60287),wordWrap:i("word-wrap",60288),zoomIn:i("zoom-in",60289),zoomOut:i("zoom-out",60290),listFilter:i("list-filter",60291),listFlat:i("list-flat",60292),listSelection:i("list-selection",60293),selection:i("selection",60293),listTree:i("list-tree",60294),debugBreakpointFunctionUnverified:i("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:i("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:i("debug-breakpoint-function-disabled",60296),debugStackframeActive:i("debug-stackframe-active",60297),circleSmallFilled:i("circle-small-filled",60298),debugStackframeDot:i("debug-stackframe-dot",60298),debugStackframe:i("debug-stackframe",60299),debugStackframeFocused:i("debug-stackframe-focused",60299),debugBreakpointUnsupported:i("debug-breakpoint-unsupported",60300),symbolString:i("symbol-string",60301),debugReverseContinue:i("debug-reverse-continue",60302),debugStepBack:i("debug-step-back",60303),debugRestartFrame:i("debug-restart-frame",60304),callIncoming:i("call-incoming",60306),callOutgoing:i("call-outgoing",60307),menu:i("menu",60308),expandAll:i("expand-all",60309),feedback:i("feedback",60310),gitPullRequestReviewer:i("git-pull-request-reviewer",60310),groupByRefType:i("group-by-ref-type",60311),ungroupByRefType:i("ungroup-by-ref-type",60312),account:i("account",60313),gitPullRequestAssignee:i("git-pull-request-assignee",60313),bellDot:i("bell-dot",60314),debugConsole:i("debug-console",60315),library:i("library",60316),output:i("output",60317),runAll:i("run-all",60318),syncIgnored:i("sync-ignored",60319),pinned:i("pinned",60320),githubInverted:i("github-inverted",60321),debugAlt:i("debug-alt",60305),serverProcess:i("server-process",60322),serverEnvironment:i("server-environment",60323),pass:i("pass",60324),stopCircle:i("stop-circle",60325),playCircle:i("play-circle",60326),record:i("record",60327),debugAltSmall:i("debug-alt-small",60328),vmConnect:i("vm-connect",60329),cloud:i("cloud",60330),merge:i("merge",60331),exportIcon:i("export",60332),graphLeft:i("graph-left",60333),magnet:i("magnet",60334),notebook:i("notebook",60335),redo:i("redo",60336),checkAll:i("check-all",60337),pinnedDirty:i("pinned-dirty",60338),passFilled:i("pass-filled",60339),circleLargeFilled:i("circle-large-filled",60340),circleLarge:i("circle-large",60341),circleLargeOutline:i("circle-large-outline",60341),combine:i("combine",60342),gather:i("gather",60342),table:i("table",60343),variableGroup:i("variable-group",60344),typeHierarchy:i("type-hierarchy",60345),typeHierarchySub:i("type-hierarchy-sub",60346),typeHierarchySuper:i("type-hierarchy-super",60347),gitPullRequestCreate:i("git-pull-request-create",60348),runAbove:i("run-above",60349),runBelow:i("run-below",60350),notebookTemplate:i("notebook-template",60351),debugRerun:i("debug-rerun",60352),workspaceTrusted:i("workspace-trusted",60353),workspaceUntrusted:i("workspace-untrusted",60354),workspaceUnspecified:i("workspace-unspecified",60355),terminalCmd:i("terminal-cmd",60356),terminalDebian:i("terminal-debian",60357),terminalLinux:i("terminal-linux",60358),terminalPowershell:i("terminal-powershell",60359),terminalTmux:i("terminal-tmux",60360),terminalUbuntu:i("terminal-ubuntu",60361),terminalBash:i("terminal-bash",60362),arrowSwap:i("arrow-swap",60363),copy:i("copy",60364),personAdd:i("person-add",60365),filterFilled:i("filter-filled",60366),wand:i("wand",60367),debugLineByLine:i("debug-line-by-line",60368),inspect:i("inspect",60369),layers:i("layers",60370),layersDot:i("layers-dot",60371),layersActive:i("layers-active",60372),compass:i("compass",60373),compassDot:i("compass-dot",60374),compassActive:i("compass-active",60375),azure:i("azure",60376),issueDraft:i("issue-draft",60377),gitPullRequestClosed:i("git-pull-request-closed",60378),gitPullRequestDraft:i("git-pull-request-draft",60379),debugAll:i("debug-all",60380),debugCoverage:i("debug-coverage",60381),runErrors:i("run-errors",60382),folderLibrary:i("folder-library",60383),debugContinueSmall:i("debug-continue-small",60384),beakerStop:i("beaker-stop",60385),graphLine:i("graph-line",60386),graphScatter:i("graph-scatter",60387),pieChart:i("pie-chart",60388),bracketDot:i("bracket-dot",60389),bracketError:i("bracket-error",60390),lockSmall:i("lock-small",60391),azureDevops:i("azure-devops",60392),verifiedFilled:i("verified-filled",60393),newLine:i("newline",60394),layout:i("layout",60395),layoutActivitybarLeft:i("layout-activitybar-left",60396),layoutActivitybarRight:i("layout-activitybar-right",60397),layoutPanelLeft:i("layout-panel-left",60398),layoutPanelCenter:i("layout-panel-center",60399),layoutPanelJustify:i("layout-panel-justify",60400),layoutPanelRight:i("layout-panel-right",60401),layoutPanel:i("layout-panel",60402),layoutSidebarLeft:i("layout-sidebar-left",60403),layoutSidebarRight:i("layout-sidebar-right",60404),layoutStatusbar:i("layout-statusbar",60405),layoutMenubar:i("layout-menubar",60406),layoutCentered:i("layout-centered",60407),layoutSidebarRightOff:i("layout-sidebar-right-off",60416),layoutPanelOff:i("layout-panel-off",60417),layoutSidebarLeftOff:i("layout-sidebar-left-off",60418),target:i("target",60408),indent:i("indent",60409),recordSmall:i("record-small",60410),errorSmall:i("error-small",60411),arrowCircleDown:i("arrow-circle-down",60412),arrowCircleLeft:i("arrow-circle-left",60413),arrowCircleRight:i("arrow-circle-right",60414),arrowCircleUp:i("arrow-circle-up",60415),heartFilled:i("heart-filled",60420),map:i("map",60421),mapFilled:i("map-filled",60422),circleSmall:i("circle-small",60423),bellSlash:i("bell-slash",60424),bellSlashDot:i("bell-slash-dot",60425),commentUnresolved:i("comment-unresolved",60426),gitPullRequestGoToChanges:i("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:i("git-pull-request-new-changes",60428),searchFuzzy:i("search-fuzzy",60429),commentDraft:i("comment-draft",60430),send:i("send",60431),sparkle:i("sparkle",60432),insert:i("insert",60433),mic:i("mic",60434),dialogError:i("dialog-error","error"),dialogWarning:i("dialog-warning","warning"),dialogInfo:i("dialog-info","info"),dialogClose:i("dialog-close","close"),treeItemExpanded:i("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:i("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:i("tree-filter-on-type-off","list-selection"),treeFilterClear:i("tree-filter-clear","close"),treeItemLoading:i("tree-item-loading","loading"),menuSelection:i("menu-selection","check"),menuSubmenu:i("menu-submenu","chevron-right"),menuBarMore:i("menubar-more","more"),scrollbarButtonLeft:i("scrollbar-button-left","triangle-left"),scrollbarButtonRight:i("scrollbar-button-right","triangle-right"),scrollbarButtonUp:i("scrollbar-button-up","triangle-up"),scrollbarButtonDown:i("scrollbar-button-down","triangle-down"),toolBarMore:i("toolbar-more","more"),quickInputBack:i("quick-input-back","arrow-left")}}),Y(X[14],J([0,1,25]),function(T,n,M){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.createProxyObject=n.getAllMethodNames=n.getAllPropertyNames=n.equals=n.mixin=n.cloneAndChange=n.deepFreeze=n.deepClone=void 0;function A(g){if(!g||typeof g!="object"||g instanceof RegExp)return g;const u=Array.isArray(g)?[]:{};return Object.entries(g).forEach(([b,h])=>{u[b]=h&&typeof h=="object"?A(h):h}),u}n.deepClone=A;function i(g){if(!g||typeof g!="object")return g;const u=[g];for(;u.length>0;){const b=u.shift();Object.freeze(b);for(const h in b)if(c.call(b,h)){const S=b[h];typeof S=="object"&&!Object.isFrozen(S)&&!(0,M.isTypedArray)(S)&&u.push(S)}}return g}n.deepFreeze=i;const c=Object.prototype.hasOwnProperty;function f(g,u){return _(g,u,new Set)}n.cloneAndChange=f;function _(g,u,b){if((0,M.isUndefinedOrNull)(g))return g;const h=u(g);if(typeof h<"u")return h;if(Array.isArray(g)){const S=[];for(const v of g)S.push(_(v,u,b));return S}if((0,M.isObject)(g)){if(b.has(g))throw new Error("Cannot clone recursive data-structure");b.add(g);const S={};for(const v in g)c.call(g,v)&&(S[v]=_(g[v],u,b));return b.delete(g),S}return g}function l(g,u,b=!0){return(0,M.isObject)(g)?((0,M.isObject)(u)&&Object.keys(u).forEach(h=>{h in g?b&&((0,M.isObject)(g[h])&&(0,M.isObject)(u[h])?l(g[h],u[h],b):g[h]=u[h]):g[h]=u[h]}),g):u}n.mixin=l;function o(g,u){if(g===u)return!0;if(g==null||u===null||u===void 0||typeof g!=typeof u||typeof g!="object"||Array.isArray(g)!==Array.isArray(u))return!1;let b,h;if(Array.isArray(g)){if(g.length!==u.length)return!1;for(b=0;b<g.length;b++)if(!o(g[b],u[b]))return!1}else{const S=[];for(h in g)S.push(h);S.sort();const v=[];for(h in u)v.push(h);if(v.sort(),!o(S,v))return!1;for(b=0;b<S.length;b++)if(!o(g[S[b]],u[S[b]]))return!1}return!0}n.equals=o;function C(g){let u=[];for(;Object.prototype!==g;)u=u.concat(Object.getOwnPropertyNames(g)),g=Object.getPrototypeOf(g);return u}n.getAllPropertyNames=C;function e(g){const u=[];for(const b of C(g))typeof g[b]=="function"&&u.push(b);return u}n.getAllMethodNames=e;function m(g,u){const b=S=>function(){const v=Array.prototype.slice.call(arguments,0);return u(S,v)},h={};for(const S of g)h[S]=b(S);return h}n.createProxyObject=m}),Y(X[26],J([0,1]),function(T,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.toUint32=n.toUint8=void 0;function M(i){return i<0?0:i>255?255:i|0}n.toUint8=M;function A(i){return i<0?0:i>4294967295?4294967295:i|0}n.toUint32=A}),Y(X[27],J([0,1,26]),function(T,n,M){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.CharacterSet=n.CharacterClassifier=void 0;class A{constructor(f){const _=(0,M.toUint8)(f);this._defaultValue=_,this._asciiMap=A._createAsciiMap(_),this._map=new Map}static _createAsciiMap(f){const _=new Uint8Array(256);return _.fill(f),_}set(f,_){const l=(0,M.toUint8)(_);f>=0&&f<256?this._asciiMap[f]=l:this._map.set(f,l)}get(f){return f>=0&&f<256?this._asciiMap[f]:this._map.get(f)||this._defaultValue}clear(){this._asciiMap.fill(this._defaultValue),this._map.clear()}}n.CharacterClassifier=A;class i{constructor(){this._actual=new A(0)}add(f){this._actual.set(f,1)}has(f){return this._actual.get(f)===1}clear(){return this._actual.clear()}}n.CharacterSet=i}),Y(X[3],J([0,1,5]),function(T,n,M){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.OffsetRangeSet=n.OffsetRange=void 0;class A{static addRange(f,_){let l=0;for(;l<_.length&&_[l].endExclusive<f.start;)l++;let o=l;for(;o<_.length&&_[o].start<=f.endExclusive;)o++;if(l===o)_.splice(l,0,f);else{const C=Math.min(f.start,_[l].start),e=Math.max(f.endExclusive,_[o-1].endExclusive);_.splice(l,o-l,new A(C,e))}}static tryCreate(f,_){if(!(f>_))return new A(f,_)}static ofLength(f){return new A(0,f)}constructor(f,_){if(this.start=f,this.endExclusive=_,f>_)throw new M.BugIndicatingError(`Invalid range: ${this.toString()}`)}get isEmpty(){return this.start===this.endExclusive}delta(f){return new A(this.start+f,this.endExclusive+f)}deltaStart(f){return new A(this.start+f,this.endExclusive)}deltaEnd(f){return new A(this.start,this.endExclusive+f)}get length(){return this.endExclusive-this.start}toString(){return`[${this.start}, ${this.endExclusive})`}equals(f){return this.start===f.start&&this.endExclusive===f.endExclusive}containsRange(f){return this.start<=f.start&&f.endExclusive<=this.endExclusive}contains(f){return this.start<=f&&f<this.endExclusive}join(f){return new A(Math.min(this.start,f.start),Math.max(this.endExclusive,f.endExclusive))}intersect(f){const _=Math.max(this.start,f.start),l=Math.min(this.endExclusive,f.endExclusive);if(_<=l)return new A(_,l)}slice(f){return f.slice(this.start,this.endExclusive)}clip(f){if(this.isEmpty)throw new M.BugIndicatingError(`Invalid clipping range: ${this.toString()}`);return Math.max(this.start,Math.min(this.endExclusive-1,f))}clipCyclic(f){if(this.isEmpty)throw new M.BugIndicatingError(`Invalid clipping range: ${this.toString()}`);return f<this.start?this.endExclusive-(this.start-f)%this.length:f>=this.endExclusive?this.start+(f-this.start)%this.length:f}forEach(f){for(let _=this.start;_<this.endExclusive;_++)f(_)}}n.OffsetRange=A;class i{constructor(){this._sortedRanges=[]}addRange(f){let _=0;for(;_<this._sortedRanges.length&&this._sortedRanges[_].endExclusive<f.start;)_++;let l=_;for(;l<this._sortedRanges.length&&this._sortedRanges[l].start<=f.endExclusive;)l++;if(_===l)this._sortedRanges.splice(_,0,f);else{const o=Math.min(f.start,this._sortedRanges[_].start),C=Math.max(f.endExclusive,this._sortedRanges[l-1].endExclusive);this._sortedRanges.splice(_,l-_,new A(o,C))}}toString(){return this._sortedRanges.map(f=>f.toString()).join(", ")}intersectsStrict(f){let _=0;for(;_<this._sortedRanges.length&&this._sortedRanges[_].endExclusive<=f.start;)_++;return _<this._sortedRanges.length&&this._sortedRanges[_].start<f.endExclusive}intersectWithRange(f){const _=new i;for(const l of this._sortedRanges){const o=l.intersect(f);o&&_.addRange(o)}return _}intersectWithRangeLength(f){return this.intersectWithRange(f).length}get length(){return this._sortedRanges.reduce((f,_)=>f+_.length,0)}}n.OffsetRangeSet=i}),Y(X[4],J([0,1]),function(T,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Position=void 0;class M{constructor(i,c){this.lineNumber=i,this.column=c}with(i=this.lineNumber,c=this.column){return i===this.lineNumber&&c===this.column?this:new M(i,c)}delta(i=0,c=0){return this.with(this.lineNumber+i,this.column+c)}equals(i){return M.equals(this,i)}static equals(i,c){return!i&&!c?!0:!!i&&!!c&&i.lineNumber===c.lineNumber&&i.column===c.column}isBefore(i){return M.isBefore(this,i)}static isBefore(i,c){return i.lineNumber<c.lineNumber?!0:c.lineNumber<i.lineNumber?!1:i.column<c.column}isBeforeOrEqual(i){return M.isBeforeOrEqual(this,i)}static isBeforeOrEqual(i,c){return i.lineNumber<c.lineNumber?!0:c.lineNumber<i.lineNumber?!1:i.column<=c.column}static compare(i,c){const f=i.lineNumber|0,_=c.lineNumber|0;if(f===_){const l=i.column|0,o=c.column|0;return l-o}return f-_}clone(){return new M(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(i){return new M(i.lineNumber,i.column)}static isIPosition(i){return i&&typeof i.lineNumber=="number"&&typeof i.column=="number"}}n.Position=M}),Y(X[2],J([0,1,4]),function(T,n,M){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Range=void 0;class A{constructor(c,f,_,l){c>_||c===_&&f>l?(this.startLineNumber=_,this.startColumn=l,this.endLineNumber=c,this.endColumn=f):(this.startLineNumber=c,this.startColumn=f,this.endLineNumber=_,this.endColumn=l)}isEmpty(){return A.isEmpty(this)}static isEmpty(c){return c.startLineNumber===c.endLineNumber&&c.startColumn===c.endColumn}containsPosition(c){return A.containsPosition(this,c)}static containsPosition(c,f){return!(f.lineNumber<c.startLineNumber||f.lineNumber>c.endLineNumber||f.lineNumber===c.startLineNumber&&f.column<c.startColumn||f.lineNumber===c.endLineNumber&&f.column>c.endColumn)}static strictContainsPosition(c,f){return!(f.lineNumber<c.startLineNumber||f.lineNumber>c.endLineNumber||f.lineNumber===c.startLineNumber&&f.column<=c.startColumn||f.lineNumber===c.endLineNumber&&f.column>=c.endColumn)}containsRange(c){return A.containsRange(this,c)}static containsRange(c,f){return!(f.startLineNumber<c.startLineNumber||f.endLineNumber<c.startLineNumber||f.startLineNumber>c.endLineNumber||f.endLineNumber>c.endLineNumber||f.startLineNumber===c.startLineNumber&&f.startColumn<c.startColumn||f.endLineNumber===c.endLineNumber&&f.endColumn>c.endColumn)}strictContainsRange(c){return A.strictContainsRange(this,c)}static strictContainsRange(c,f){return!(f.startLineNumber<c.startLineNumber||f.endLineNumber<c.startLineNumber||f.startLineNumber>c.endLineNumber||f.endLineNumber>c.endLineNumber||f.startLineNumber===c.startLineNumber&&f.startColumn<=c.startColumn||f.endLineNumber===c.endLineNumber&&f.endColumn>=c.endColumn)}plusRange(c){return A.plusRange(this,c)}static plusRange(c,f){let _,l,o,C;return f.startLineNumber<c.startLineNumber?(_=f.startLineNumber,l=f.startColumn):f.startLineNumber===c.startLineNumber?(_=f.startLineNumber,l=Math.min(f.startColumn,c.startColumn)):(_=c.startLineNumber,l=c.startColumn),f.endLineNumber>c.endLineNumber?(o=f.endLineNumber,C=f.endColumn):f.endLineNumber===c.endLineNumber?(o=f.endLineNumber,C=Math.max(f.endColumn,c.endColumn)):(o=c.endLineNumber,C=c.endColumn),new A(_,l,o,C)}intersectRanges(c){return A.intersectRanges(this,c)}static intersectRanges(c,f){let _=c.startLineNumber,l=c.startColumn,o=c.endLineNumber,C=c.endColumn;const e=f.startLineNumber,m=f.startColumn,g=f.endLineNumber,u=f.endColumn;return _<e?(_=e,l=m):_===e&&(l=Math.max(l,m)),o>g?(o=g,C=u):o===g&&(C=Math.min(C,u)),_>o||_===o&&l>C?null:new A(_,l,o,C)}equalsRange(c){return A.equalsRange(this,c)}static equalsRange(c,f){return!c&&!f?!0:!!c&&!!f&&c.startLineNumber===f.startLineNumber&&c.startColumn===f.startColumn&&c.endLineNumber===f.endLineNumber&&c.endColumn===f.endColumn}getEndPosition(){return A.getEndPosition(this)}static getEndPosition(c){return new M.Position(c.endLineNumber,c.endColumn)}getStartPosition(){return A.getStartPosition(this)}static getStartPosition(c){return new M.Position(c.startLineNumber,c.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(c,f){return new A(this.startLineNumber,this.startColumn,c,f)}setStartPosition(c,f){return new A(c,f,this.endLineNumber,this.endColumn)}collapseToStart(){return A.collapseToStart(this)}static collapseToStart(c){return new A(c.startLineNumber,c.startColumn,c.startLineNumber,c.startColumn)}collapseToEnd(){return A.collapseToEnd(this)}static collapseToEnd(c){return new A(c.endLineNumber,c.endColumn,c.endLineNumber,c.endColumn)}delta(c){return new A(this.startLineNumber+c,this.startColumn,this.endLineNumber+c,this.endColumn)}static fromPositions(c,f=c){return new A(c.lineNumber,c.column,f.lineNumber,f.column)}static lift(c){return c?new A(c.startLineNumber,c.startColumn,c.endLineNumber,c.endColumn):null}static isIRange(c){return c&&typeof c.startLineNumber=="number"&&typeof c.startColumn=="number"&&typeof c.endLineNumber=="number"&&typeof c.endColumn=="number"}static areIntersectingOrTouching(c,f){return!(c.endLineNumber<f.startLineNumber||c.endLineNumber===f.startLineNumber&&c.endColumn<f.startColumn||f.endLineNumber<c.startLineNumber||f.endLineNumber===c.startLineNumber&&f.endColumn<c.startColumn)}static areIntersecting(c,f){return!(c.endLineNumber<f.startLineNumber||c.endLineNumber===f.startLineNumber&&c.endColumn<=f.startColumn||f.endLineNumber<c.startLineNumber||f.endLineNumber===c.startLineNumber&&f.endColumn<=c.startColumn)}static compareRangesUsingStarts(c,f){if(c&&f){const o=c.startLineNumber|0,C=f.startLineNumber|0;if(o===C){const e=c.startColumn|0,m=f.startColumn|0;if(e===m){const g=c.endLineNumber|0,u=f.endLineNumber|0;if(g===u){const b=c.endColumn|0,h=f.endColumn|0;return b-h}return g-u}return e-m}return o-C}return(c?1:0)-(f?1:0)}static compareRangesUsingEnds(c,f){return c.endLineNumber===f.endLineNumber?c.endColumn===f.endColumn?c.startLineNumber===f.startLineNumber?c.startColumn-f.startColumn:c.startLineNumber-f.startLineNumber:c.endColumn-f.endColumn:c.endLineNumber-f.endLineNumber}static spansMultipleLines(c){return c.endLineNumber>c.startLineNumber}toJSON(){return this}}n.Range=A}),Y(X[10],J([0,1,5,3,2,11]),function(T,n,M,A,i,c){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.LineRangeSet=n.LineRange=void 0;class f{static fromRange(o){return new f(o.startLineNumber,o.endLineNumber)}static joinMany(o){if(o.length===0)return[];let C=new _(o[0].slice());for(let e=1;e<o.length;e++)C=C.getUnion(new _(o[e].slice()));return C.ranges}static ofLength(o,C){return new f(o,o+C)}static deserialize(o){return new f(o[0],o[1])}constructor(o,C){if(o>C)throw new M.BugIndicatingError(`startLineNumber ${o} cannot be after endLineNumberExclusive ${C}`);this.startLineNumber=o,this.endLineNumberExclusive=C}contains(o){return this.startLineNumber<=o&&o<this.endLineNumberExclusive}get isEmpty(){return this.startLineNumber===this.endLineNumberExclusive}delta(o){return new f(this.startLineNumber+o,this.endLineNumberExclusive+o)}deltaLength(o){return new f(this.startLineNumber,this.endLineNumberExclusive+o)}get length(){return this.endLineNumberExclusive-this.startLineNumber}join(o){return new f(Math.min(this.startLineNumber,o.startLineNumber),Math.max(this.endLineNumberExclusive,o.endLineNumberExclusive))}toString(){return`[${this.startLineNumber},${this.endLineNumberExclusive})`}intersect(o){const C=Math.max(this.startLineNumber,o.startLineNumber),e=Math.min(this.endLineNumberExclusive,o.endLineNumberExclusive);if(C<=e)return new f(C,e)}intersectsStrict(o){return this.startLineNumber<o.endLineNumberExclusive&&o.startLineNumber<this.endLineNumberExclusive}overlapOrTouch(o){return this.startLineNumber<=o.endLineNumberExclusive&&o.startLineNumber<=this.endLineNumberExclusive}equals(o){return this.startLineNumber===o.startLineNumber&&this.endLineNumberExclusive===o.endLineNumberExclusive}toInclusiveRange(){return this.isEmpty?null:new i.Range(this.startLineNumber,1,this.endLineNumberExclusive-1,Number.MAX_SAFE_INTEGER)}toExclusiveRange(){return new i.Range(this.startLineNumber,1,this.endLineNumberExclusive,1)}mapToLineArray(o){const C=[];for(let e=this.startLineNumber;e<this.endLineNumberExclusive;e++)C.push(o(e));return C}forEach(o){for(let C=this.startLineNumber;C<this.endLineNumberExclusive;C++)o(C)}serialize(){return[this.startLineNumber,this.endLineNumberExclusive]}includes(o){return this.startLineNumber<=o&&o<this.endLineNumberExclusive}toOffsetRange(){return new A.OffsetRange(this.startLineNumber-1,this.endLineNumberExclusive-1)}}n.LineRange=f;class _{constructor(o=[]){this._normalizedRanges=o}get ranges(){return this._normalizedRanges}addRange(o){if(o.length===0)return;const C=(0,c.findFirstIdxMonotonousOrArrLen)(this._normalizedRanges,m=>m.endLineNumberExclusive>=o.startLineNumber),e=(0,c.findLastIdxMonotonous)(this._normalizedRanges,m=>m.startLineNumber<=o.endLineNumberExclusive)+1;if(C===e)this._normalizedRanges.splice(C,0,o);else if(C===e-1){const m=this._normalizedRanges[C];this._normalizedRanges[C]=m.join(o)}else{const m=this._normalizedRanges[C].join(this._normalizedRanges[e-1]).join(o);this._normalizedRanges.splice(C,e-C,m)}}contains(o){const C=(0,c.findLastMonotonous)(this._normalizedRanges,e=>e.startLineNumber<=o);return!!C&&C.endLineNumberExclusive>o}getUnion(o){if(this._normalizedRanges.length===0)return o;if(o._normalizedRanges.length===0)return this;const C=[];let e=0,m=0,g=null;for(;e<this._normalizedRanges.length||m<o._normalizedRanges.length;){let u=null;if(e<this._normalizedRanges.length&&m<o._normalizedRanges.length){const b=this._normalizedRanges[e],h=o._normalizedRanges[m];b.startLineNumber<h.startLineNumber?(u=b,e++):(u=h,m++)}else e<this._normalizedRanges.length?(u=this._normalizedRanges[e],e++):(u=o._normalizedRanges[m],m++);g===null?g=u:g.endLineNumberExclusive>=u.startLineNumber?g=new f(g.startLineNumber,Math.max(g.endLineNumberExclusive,u.endLineNumberExclusive)):(C.push(g),g=u)}return g!==null&&C.push(g),new _(C)}subtractFrom(o){const C=(0,c.findFirstIdxMonotonousOrArrLen)(this._normalizedRanges,u=>u.endLineNumberExclusive>=o.startLineNumber),e=(0,c.findLastIdxMonotonous)(this._normalizedRanges,u=>u.startLineNumber<=o.endLineNumberExclusive)+1;if(C===e)return new _([o]);const m=[];let g=o.startLineNumber;for(let u=C;u<e;u++){const b=this._normalizedRanges[u];b.startLineNumber>g&&m.push(new f(g,b.startLineNumber)),g=b.endLineNumberExclusive}return g<o.endLineNumberExclusive&&m.push(new f(g,o.endLineNumberExclusive)),new _(m)}toString(){return this._normalizedRanges.map(o=>o.toString()).join(", ")}getIntersection(o){const C=[];let e=0,m=0;for(;e<this._normalizedRanges.length&&m<o._normalizedRanges.length;){const g=this._normalizedRanges[e],u=o._normalizedRanges[m],b=g.intersect(u);b&&!b.isEmpty&&C.push(b),g.endLineNumberExclusive<u.endLineNumberExclusive?e++:m++}return new _(C)}getWithDelta(o){return new _(this._normalizedRanges.map(C=>C.delta(o)))}}n.LineRangeSet=_}),Y(X[41],J([0,1,4,2]),function(T,n,M,A){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Selection=void 0;class i extends A.Range{constructor(f,_,l,o){super(f,_,l,o),this.selectionStartLineNumber=f,this.selectionStartColumn=_,this.positionLineNumber=l,this.positionColumn=o}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(f){return i.selectionsEqual(this,f)}static selectionsEqual(f,_){return f.selectionStartLineNumber===_.selectionStartLineNumber&&f.selectionStartColumn===_.selectionStartColumn&&f.positionLineNumber===_.positionLineNumber&&f.positionColumn===_.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(f,_){return this.getDirection()===0?new i(this.startLineNumber,this.startColumn,f,_):new i(f,_,this.startLineNumber,this.startColumn)}getPosition(){return new M.Position(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new M.Position(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(f,_){return this.getDirection()===0?new i(f,_,this.endLineNumber,this.endColumn):new i(this.endLineNumber,this.endColumn,f,_)}static fromPositions(f,_=f){return new i(f.lineNumber,f.column,_.lineNumber,_.column)}static fromRange(f,_){return _===0?new i(f.startLineNumber,f.startColumn,f.endLineNumber,f.endColumn):new i(f.endLineNumber,f.endColumn,f.startLineNumber,f.startColumn)}static liftSelection(f){return new i(f.selectionStartLineNumber,f.selectionStartColumn,f.positionLineNumber,f.positionColumn)}static selectionsArrEqual(f,_){if(f&&!_||!f&&_)return!1;if(!f&&!_)return!0;if(f.length!==_.length)return!1;for(let l=0,o=f.length;l<o;l++)if(!this.selectionsEqual(f[l],_[l]))return!1;return!0}static isISelection(f){return f&&typeof f.selectionStartLineNumber=="number"&&typeof f.selectionStartColumn=="number"&&typeof f.positionLineNumber=="number"&&typeof f.positionColumn=="number"}static createWithDirection(f,_,l,o,C){return C===0?new i(f,_,l,o):new i(l,o,f,_)}}n.Selection=i}),Y(X[42],J([0,1,27]),function(T,n,M){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.getMapForWordSeparators=n.WordCharacterClassifier=void 0;class A extends M.CharacterClassifier{constructor(f){super(0);for(let _=0,l=f.length;_<l;_++)this.set(f.charCodeAt(_),2);this.set(32,1),this.set(9,1)}}n.WordCharacterClassifier=A;function i(c){const f={};return _=>(f.hasOwnProperty(_)||(f[_]=c(_)),f[_])}n.getMapForWordSeparators=i(c=>new A(c))}),Y(X[28],J([0,1,21,22]),function(T,n,M,A){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.getWordAtText=n.ensureValidWordDefinition=n.DEFAULT_WORD_REGEXP=n.USUAL_WORD_SEPARATORS=void 0,n.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function i(o=""){let C="(-?\\d*\\.\\d\\w*)|([^";for(const e of n.USUAL_WORD_SEPARATORS)o.indexOf(e)>=0||(C+="\\"+e);return C+="\\s]+)",new RegExp(C,"g")}n.DEFAULT_WORD_REGEXP=i();function c(o){let C=n.DEFAULT_WORD_REGEXP;if(o&&o instanceof RegExp)if(o.global)C=o;else{let e="g";o.ignoreCase&&(e+="i"),o.multiline&&(e+="m"),o.unicode&&(e+="u"),C=new RegExp(o.source,e)}return C.lastIndex=0,C}n.ensureValidWordDefinition=c;const f=new A.LinkedList;f.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function _(o,C,e,m,g){if(g||(g=M.Iterable.first(f)),e.length>g.maxLen){let v=o-g.maxLen/2;return v<0?v=0:m+=v,e=e.substring(v,o+g.maxLen/2),_(o,C,e,m,g)}const u=Date.now(),b=o-1-m;let h=-1,S=null;for(let v=1;!(Date.now()-u>=g.timeBudget);v++){const N=b-g.windowSize*v;C.lastIndex=Math.max(0,N);const y=l(C,e,b,h);if(!y&&S||(S=y,N<=0))break;h=N}if(S){const v={word:S[0],startColumn:m+1+S.index,endColumn:m+1+S.index+S[0].length};return C.lastIndex=0,v}return null}n.getWordAtText=_;function l(o,C,e,m){let g;for(;g=o.exec(C);){const u=g.index||0;if(u<=e&&o.lastIndex>=e)return g;if(m>0&&u>m)return null}return null}}),Y(X[8],J([0,1,7,5,3]),function(T,n,M,A,i){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.DateTimeout=n.InfiniteTimeout=n.OffsetPair=n.SequenceDiff=n.DiffAlgorithmResult=void 0;class c{static trivial(e,m){return new c([new f(i.OffsetRange.ofLength(e.length),i.OffsetRange.ofLength(m.length))],!1)}static trivialTimedOut(e,m){return new c([new f(i.OffsetRange.ofLength(e.length),i.OffsetRange.ofLength(m.length))],!0)}constructor(e,m){this.diffs=e,this.hitTimeout=m}}n.DiffAlgorithmResult=c;class f{static invert(e,m){const g=[];return(0,M.forEachAdjacent)(e,(u,b)=>{g.push(f.fromOffsetPairs(u?u.getEndExclusives():_.zero,b?b.getStarts():new _(m,(u?u.seq2Range.endExclusive-u.seq1Range.endExclusive:0)+m)))}),g}static fromOffsetPairs(e,m){return new f(new i.OffsetRange(e.offset1,m.offset1),new i.OffsetRange(e.offset2,m.offset2))}constructor(e,m){this.seq1Range=e,this.seq2Range=m}swap(){return new f(this.seq2Range,this.seq1Range)}toString(){return`${this.seq1Range} <-> ${this.seq2Range}`}join(e){return new f(this.seq1Range.join(e.seq1Range),this.seq2Range.join(e.seq2Range))}delta(e){return e===0?this:new f(this.seq1Range.delta(e),this.seq2Range.delta(e))}deltaStart(e){return e===0?this:new f(this.seq1Range.deltaStart(e),this.seq2Range.deltaStart(e))}deltaEnd(e){return e===0?this:new f(this.seq1Range.deltaEnd(e),this.seq2Range.deltaEnd(e))}intersect(e){const m=this.seq1Range.intersect(e.seq1Range),g=this.seq2Range.intersect(e.seq2Range);if(!(!m||!g))return new f(m,g)}getStarts(){return new _(this.seq1Range.start,this.seq2Range.start)}getEndExclusives(){return new _(this.seq1Range.endExclusive,this.seq2Range.endExclusive)}}n.SequenceDiff=f;class _{constructor(e,m){this.offset1=e,this.offset2=m}toString(){return`${this.offset1} <-> ${this.offset2}`}}n.OffsetPair=_,_.zero=new _(0,0),_.max=new _(Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER);class l{isValid(){return!0}}n.InfiniteTimeout=l,l.instance=new l;class o{constructor(e){if(this.timeout=e,this.startTime=Date.now(),this.valid=!0,e<=0)throw new A.BugIndicatingError("timeout must be positive")}isValid(){if(!(Date.now()-this.startTime<this.timeout)&&this.valid){this.valid=!1;debugger}return this.valid}}n.DateTimeout=o}),Y(X[29],J([0,1,3,8]),function(T,n,M,A){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.MyersDiffAlgorithm=void 0;class i{compute(o,C,e=A.InfiniteTimeout.instance){if(o.length===0||C.length===0)return A.DiffAlgorithmResult.trivial(o,C);const m=o,g=C;function u(s,a){for(;s<m.length&&a<g.length&&m.getElement(s)===g.getElement(a);)s++,a++;return s}let b=0;const h=new f;h.set(0,u(0,0));const S=new _;S.set(0,h.get(0)===0?null:new c(null,0,0,h.get(0)));let v=0;e:for(;;){if(b++,!e.isValid())return A.DiffAlgorithmResult.trivialTimedOut(m,g);const s=-Math.min(b,g.length+b%2),a=Math.min(b,m.length+b%2);for(v=s;v<=a;v+=2){let p=0;const d=v===a?-1:h.get(v+1),w=v===s?-1:h.get(v-1)+1;p++;const E=Math.min(Math.max(d,w),m.length),R=E-v;if(p++,E>m.length||R>g.length)continue;const D=u(E,R);h.set(v,D);const F=E===d?S.get(v+1):S.get(v-1);if(S.set(v,D!==E?new c(F,E,R,D-E):F),h.get(v)===m.length&&h.get(v)-v===g.length)break e}}let N=S.get(v);const y=[];let L=m.length,r=g.length;for(;;){const s=N?N.x+N.length:0,a=N?N.y+N.length:0;if((s!==L||a!==r)&&y.push(new A.SequenceDiff(new M.OffsetRange(s,L),new M.OffsetRange(a,r))),!N)break;L=N.x,r=N.y,N=N.prev}return y.reverse(),new A.DiffAlgorithmResult(y,!1)}}n.MyersDiffAlgorithm=i;class c{constructor(o,C,e,m){this.prev=o,this.x=C,this.y=e,this.length=m}}class f{constructor(){this.positiveArr=new Int32Array(10),this.negativeArr=new Int32Array(10)}get(o){return o<0?(o=-o-1,this.negativeArr[o]):this.positiveArr[o]}set(o,C){if(o<0){if(o=-o-1,o>=this.negativeArr.length){const e=this.negativeArr;this.negativeArr=new Int32Array(e.length*2),this.negativeArr.set(e)}this.negativeArr[o]=C}else{if(o>=this.positiveArr.length){const e=this.positiveArr;this.positiveArr=new Int32Array(e.length*2),this.positiveArr.set(e)}this.positiveArr[o]=C}}}class _{constructor(){this.positiveArr=[],this.negativeArr=[]}get(o){return o<0?(o=-o-1,this.negativeArr[o]):this.positiveArr[o]}set(o,C){o<0?(o=-o-1,this.negativeArr[o]=C):this.positiveArr[o]=C}}}),Y(X[43],J([0,1,7,3,8]),function(T,n,M,A,i){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.removeVeryShortMatchingTextBetweenLongDiffs=n.removeVeryShortMatchingLinesBetweenDiffs=n.extendDiffsToEntireWordIfAppropriate=n.removeShortMatches=n.optimizeSequenceDiffs=void 0;function c(u,b,h){let S=h;return S=f(u,b,S),S=_(u,b,S),S}n.optimizeSequenceDiffs=c;function f(u,b,h){if(h.length===0)return h;const S=[];S.push(h[0]);for(let N=1;N<h.length;N++){const y=S[S.length-1];let L=h[N];if(L.seq1Range.isEmpty||L.seq2Range.isEmpty){const r=L.seq1Range.start-y.seq1Range.endExclusive;let s;for(s=1;s<=r&&!(u.getElement(L.seq1Range.start-s)!==u.getElement(L.seq1Range.endExclusive-s)||b.getElement(L.seq2Range.start-s)!==b.getElement(L.seq2Range.endExclusive-s));s++);if(s--,s===r){S[S.length-1]=new i.SequenceDiff(new A.OffsetRange(y.seq1Range.start,L.seq1Range.endExclusive-r),new A.OffsetRange(y.seq2Range.start,L.seq2Range.endExclusive-r));continue}L=L.delta(-s)}S.push(L)}const v=[];for(let N=0;N<S.length-1;N++){const y=S[N+1];let L=S[N];if(L.seq1Range.isEmpty||L.seq2Range.isEmpty){const r=y.seq1Range.start-L.seq1Range.endExclusive;let s;for(s=0;s<r&&!(u.getElement(L.seq1Range.start+s)!==u.getElement(L.seq1Range.endExclusive+s)||b.getElement(L.seq2Range.start+s)!==b.getElement(L.seq2Range.endExclusive+s));s++);if(s===r){S[N+1]=new i.SequenceDiff(new A.OffsetRange(L.seq1Range.start+r,y.seq1Range.endExclusive),new A.OffsetRange(L.seq2Range.start+r,y.seq2Range.endExclusive));continue}s>0&&(L=L.delta(s))}v.push(L)}return S.length>0&&v.push(S[S.length-1]),v}function _(u,b,h){if(!u.getBoundaryScore||!b.getBoundaryScore)return h;for(let S=0;S<h.length;S++){const v=S>0?h[S-1]:void 0,N=h[S],y=S+1<h.length?h[S+1]:void 0,L=new A.OffsetRange(v?v.seq1Range.start+1:0,y?y.seq1Range.endExclusive-1:u.length),r=new A.OffsetRange(v?v.seq2Range.start+1:0,y?y.seq2Range.endExclusive-1:b.length);N.seq1Range.isEmpty?h[S]=l(N,u,b,L,r):N.seq2Range.isEmpty&&(h[S]=l(N.swap(),b,u,r,L).swap())}return h}function l(u,b,h,S,v){let y=1;for(;u.seq1Range.start-y>=S.start&&u.seq2Range.start-y>=v.start&&h.isStronglyEqual(u.seq2Range.start-y,u.seq2Range.endExclusive-y)&&y<100;)y++;y--;let L=0;for(;u.seq1Range.start+L<S.endExclusive&&u.seq2Range.endExclusive+L<v.endExclusive&&h.isStronglyEqual(u.seq2Range.start+L,u.seq2Range.endExclusive+L)&&L<100;)L++;if(y===0&&L===0)return u;let r=0,s=-1;for(let a=-y;a<=L;a++){const p=u.seq2Range.start+a,d=u.seq2Range.endExclusive+a,w=u.seq1Range.start+a,E=b.getBoundaryScore(w)+h.getBoundaryScore(p)+h.getBoundaryScore(d);E>s&&(s=E,r=a)}return u.delta(r)}function o(u,b,h){const S=[];for(const v of h){const N=S[S.length-1];if(!N){S.push(v);continue}v.seq1Range.start-N.seq1Range.endExclusive<=2||v.seq2Range.start-N.seq2Range.endExclusive<=2?S[S.length-1]=new i.SequenceDiff(N.seq1Range.join(v.seq1Range),N.seq2Range.join(v.seq2Range)):S.push(v)}return S}n.removeShortMatches=o;function C(u,b,h){const S=[];let v;function N(){if(!v)return;const L=v.s1Range.length-v.deleted,r=v.s2Range.length-v.added;Math.max(v.deleted,v.added)+(v.count-1)>L&&S.push(new i.SequenceDiff(v.s1Range,v.s2Range)),v=void 0}for(const L of h){let r=function(w,E){var R,D,F,U;if(!v||!v.s1Range.containsRange(w)||!v.s2Range.containsRange(E))if(v&&!(v.s1Range.endExclusive<w.start&&v.s2Range.endExclusive<E.start)){const z=A.OffsetRange.tryCreate(v.s1Range.endExclusive,w.start),k=A.OffsetRange.tryCreate(v.s2Range.endExclusive,E.start);v.deleted+=(R=z?.length)!==null&&R!==void 0?R:0,v.added+=(D=k?.length)!==null&&D!==void 0?D:0,v.s1Range=v.s1Range.join(w),v.s2Range=v.s2Range.join(E)}else N(),v={added:0,deleted:0,count:0,s1Range:w,s2Range:E};const I=w.intersect(L.seq1Range),B=E.intersect(L.seq2Range);v.count++,v.deleted+=(F=I?.length)!==null&&F!==void 0?F:0,v.added+=(U=B?.length)!==null&&U!==void 0?U:0};const s=u.findWordContaining(L.seq1Range.start-1),a=b.findWordContaining(L.seq2Range.start-1),p=u.findWordContaining(L.seq1Range.endExclusive),d=b.findWordContaining(L.seq2Range.endExclusive);s&&p&&a&&d&&s.equals(p)&&a.equals(d)?r(s,a):(s&&a&&r(s,a),p&&d&&r(p,d))}return N(),e(h,S)}n.extendDiffsToEntireWordIfAppropriate=C;function e(u,b){const h=[];for(;u.length>0||b.length>0;){const S=u[0],v=b[0];let N;S&&(!v||S.seq1Range.start<v.seq1Range.start)?N=u.shift():N=b.shift(),h.length>0&&h[h.length-1].seq1Range.endExclusive>=N.seq1Range.start?h[h.length-1]=h[h.length-1].join(N):h.push(N)}return h}function m(u,b,h){let S=h;if(S.length===0)return S;let v=0,N;do{N=!1;const y=[S[0]];for(let L=1;L<S.length;L++){let a=function(d,w){const E=new A.OffsetRange(s.seq1Range.endExclusive,r.seq1Range.start);return u.getText(E).replace(/\s/g,"").length<=4&&(d.seq1Range.length+d.seq2Range.length>5||w.seq1Range.length+w.seq2Range.length>5)};const r=S[L],s=y[y.length-1];a(s,r)?(N=!0,y[y.length-1]=y[y.length-1].join(r)):y.push(r)}S=y}while(v++<10&&N);return S}n.removeVeryShortMatchingLinesBetweenDiffs=m;function g(u,b,h){let S=h;if(S.length===0)return S;let v=0,N;do{N=!1;const L=[S[0]];for(let r=1;r<S.length;r++){let p=function(w,E){const R=new A.OffsetRange(a.seq1Range.endExclusive,s.seq1Range.start);if(u.countLinesIn(R)>5||R.length>500)return!1;const F=u.getText(R).trim();if(F.length>20||F.split(/\r\n|\r|\n/).length>1)return!1;const U=u.countLinesIn(w.seq1Range),I=w.seq1Range.length,B=b.countLinesIn(w.seq2Range),z=w.seq2Range.length,k=u.countLinesIn(E.seq1Range),q=E.seq1Range.length,x=b.countLinesIn(E.seq2Range),H=E.seq2Range.length,V=2*40+50;function t(ne){return Math.min(ne,V)}return Math.pow(Math.pow(t(U*40+I),1.5)+Math.pow(t(B*40+z),1.5),1.5)+Math.pow(Math.pow(t(k*40+q),1.5)+Math.pow(t(x*40+H),1.5),1.5)>Math.pow(Math.pow(V,1.5),1.5)*1.3};const s=S[r],a=L[L.length-1];p(a,s)?(N=!0,L[L.length-1]=L[L.length-1].join(s)):L.push(s)}S=L}while(v++<10&&N);const y=[];return(0,M.forEachWithNeighbors)(S,(L,r,s)=>{let a=r;function p(F){return F.length>0&&F.trim().length<=3&&r.seq1Range.length+r.seq2Range.length>100}const d=u.extendToFullLines(r.seq1Range),w=u.getText(new A.OffsetRange(d.start,r.seq1Range.start));p(w)&&(a=a.deltaStart(-w.length));const E=u.getText(new A.OffsetRange(r.seq1Range.endExclusive,d.endExclusive));p(E)&&(a=a.deltaEnd(E.length));const R=i.SequenceDiff.fromOffsetPairs(L?L.getEndExclusives():i.OffsetPair.zero,s?s.getStarts():i.OffsetPair.max),D=a.intersect(R);y.push(D)}),y}n.removeVeryShortMatchingTextBetweenLongDiffs=g}),Y(X[44],J([0,1]),function(T,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.LineSequence=void 0;class M{constructor(c,f){this.trimmedHash=c,this.lines=f}getElement(c){return this.trimmedHash[c]}get length(){return this.trimmedHash.length}getBoundaryScore(c){const f=c===0?0:A(this.lines[c-1]),_=c===this.lines.length?0:A(this.lines[c]);return 1e3-(f+_)}getText(c){return this.lines.slice(c.start,c.endExclusive).join(`
`)}isStronglyEqual(c,f){return this.lines[c]===this.lines[f]}}n.LineSequence=M;function A(i){let c=0;for(;c<i.length&&(i.charCodeAt(c)===32||i.charCodeAt(c)===9);)c++;return c}}),Y(X[15],J([0,1]),function(T,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.LineRangeFragment=n.isSpace=n.Array2D=void 0;class M{constructor(f,_){this.width=f,this.height=_,this.array=[],this.array=new Array(f*_)}get(f,_){return this.array[f+_*this.width]}set(f,_,l){this.array[f+_*this.width]=l}}n.Array2D=M;function A(c){return c===32||c===9}n.isSpace=A;class i{static getKey(f){let _=this.chrKeys.get(f);return _===void 0&&(_=this.chrKeys.size,this.chrKeys.set(f,_)),_}constructor(f,_,l){this.range=f,this.lines=_,this.source=l,this.histogram=[];let o=0;for(let C=f.startLineNumber-1;C<f.endLineNumberExclusive-1;C++){const e=_[C];for(let g=0;g<e.length;g++){o++;const u=e[g],b=i.getKey(u);this.histogram[b]=(this.histogram[b]||0)+1}o++;const m=i.getKey(`
`);this.histogram[m]=(this.histogram[m]||0)+1}this.totalCount=o}computeSimilarity(f){var _,l;let o=0;const C=Math.max(this.histogram.length,f.histogram.length);for(let e=0;e<C;e++)o+=Math.abs(((_=this.histogram[e])!==null&&_!==void 0?_:0)-((l=f.histogram[e])!==null&&l!==void 0?l:0));return 1-o/(this.totalCount+f.totalCount)}}n.LineRangeFragment=i,i.chrKeys=new Map}),Y(X[45],J([0,1,3,8,15]),function(T,n,M,A,i){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.DynamicProgrammingDiffing=void 0;class c{compute(_,l,o=A.InfiniteTimeout.instance,C){if(_.length===0||l.length===0)return A.DiffAlgorithmResult.trivial(_,l);const e=new i.Array2D(_.length,l.length),m=new i.Array2D(_.length,l.length),g=new i.Array2D(_.length,l.length);for(let y=0;y<_.length;y++)for(let L=0;L<l.length;L++){if(!o.isValid())return A.DiffAlgorithmResult.trivialTimedOut(_,l);const r=y===0?0:e.get(y-1,L),s=L===0?0:e.get(y,L-1);let a;_.getElement(y)===l.getElement(L)?(y===0||L===0?a=0:a=e.get(y-1,L-1),y>0&&L>0&&m.get(y-1,L-1)===3&&(a+=g.get(y-1,L-1)),a+=C?C(y,L):1):a=-1;const p=Math.max(r,s,a);if(p===a){const d=y>0&&L>0?g.get(y-1,L-1):0;g.set(y,L,d+1),m.set(y,L,3)}else p===r?(g.set(y,L,0),m.set(y,L,1)):p===s&&(g.set(y,L,0),m.set(y,L,2));e.set(y,L,p)}const u=[];let b=_.length,h=l.length;function S(y,L){(y+1!==b||L+1!==h)&&u.push(new A.SequenceDiff(new M.OffsetRange(y+1,b),new M.OffsetRange(L+1,h))),b=y,h=L}let v=_.length-1,N=l.length-1;for(;v>=0&&N>=0;)m.get(v,N)===3?(S(v,N),v--,N--):m.get(v,N)===1?v--:N--;return S(-1,-1),u.reverse(),new A.DiffAlgorithmResult(u,!1)}}n.DynamicProgrammingDiffing=c}),Y(X[30],J([0,1,11,3,4,2,15]),function(T,n,M,A,i,c,f){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.LinesSliceCharSequence=void 0;class _{constructor(g,u,b){this.lines=g,this.considerWhitespaceChanges=b,this.elements=[],this.firstCharOffsetByLine=[],this.additionalOffsetByLine=[];let h=!1;u.start>0&&u.endExclusive>=g.length&&(u=new A.OffsetRange(u.start-1,u.endExclusive),h=!0),this.lineRange=u,this.firstCharOffsetByLine[0]=0;for(let S=this.lineRange.start;S<this.lineRange.endExclusive;S++){let v=g[S],N=0;if(h)N=v.length,v="",h=!1;else if(!b){const y=v.trimStart();N=v.length-y.length,v=y.trimEnd()}this.additionalOffsetByLine.push(N);for(let y=0;y<v.length;y++)this.elements.push(v.charCodeAt(y));S<g.length-1&&(this.elements.push(`
`.charCodeAt(0)),this.firstCharOffsetByLine[S-this.lineRange.start+1]=this.elements.length)}this.additionalOffsetByLine.push(0)}toString(){return`Slice: "${this.text}"`}get text(){return this.getText(new A.OffsetRange(0,this.length))}getText(g){return this.elements.slice(g.start,g.endExclusive).map(u=>String.fromCharCode(u)).join("")}getElement(g){return this.elements[g]}get length(){return this.elements.length}getBoundaryScore(g){const u=e(g>0?this.elements[g-1]:-1),b=e(g<this.elements.length?this.elements[g]:-1);if(u===6&&b===7)return 0;let h=0;return u!==b&&(h+=10,b===1&&(h+=1)),h+=C(u),h+=C(b),h}translateOffset(g){if(this.lineRange.isEmpty)return new i.Position(this.lineRange.start+1,1);const u=(0,M.findLastIdxMonotonous)(this.firstCharOffsetByLine,b=>b<=g);return new i.Position(this.lineRange.start+u+1,g-this.firstCharOffsetByLine[u]+this.additionalOffsetByLine[u]+1)}translateRange(g){return c.Range.fromPositions(this.translateOffset(g.start),this.translateOffset(g.endExclusive))}findWordContaining(g){if(g<0||g>=this.elements.length||!l(this.elements[g]))return;let u=g;for(;u>0&&l(this.elements[u-1]);)u--;let b=g;for(;b<this.elements.length&&l(this.elements[b]);)b++;return new A.OffsetRange(u,b)}countLinesIn(g){return this.translateOffset(g.endExclusive).lineNumber-this.translateOffset(g.start).lineNumber}isStronglyEqual(g,u){return this.elements[g]===this.elements[u]}extendToFullLines(g){var u,b;const h=(u=(0,M.findLastMonotonous)(this.firstCharOffsetByLine,v=>v<=g.start))!==null&&u!==void 0?u:0,S=(b=(0,M.findFirstMonotonous)(this.firstCharOffsetByLine,v=>g.endExclusive<=v))!==null&&b!==void 0?b:this.elements.length;return new A.OffsetRange(h,S)}}n.LinesSliceCharSequence=_;function l(m){return m>=97&&m<=122||m>=65&&m<=90||m>=48&&m<=57}const o={[0]:0,[1]:0,[2]:0,[3]:10,[4]:2,[5]:3,[6]:10,[7]:10};function C(m){return o[m]}function e(m){return m===10?7:m===13?6:(0,f.isSpace)(m)?5:m>=97&&m<=122?0:m>=65&&m<=90?1:m>=48&&m<=57?2:m===-1?3:4}}),Y(X[31],J([0,1]),function(T,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.MovedText=n.LinesDiff=void 0;class M{constructor(c,f,_){this.changes=c,this.moves=f,this.hitTimeout=_}}n.LinesDiff=M;class A{constructor(c,f){this.lineRangeMapping=c,this.changes=f}}n.MovedText=A}),Y(X[16],J([0,1,10]),function(T,n,M){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.RangeMapping=n.DetailedLineRangeMapping=n.LineRangeMapping=void 0;class A{static inverse(_,l,o){const C=[];let e=1,m=1;for(const u of _){const b=new i(new M.LineRange(e,u.original.startLineNumber),new M.LineRange(m,u.modified.startLineNumber),void 0);b.modified.isEmpty||C.push(b),e=u.original.endLineNumberExclusive,m=u.modified.endLineNumberExclusive}const g=new i(new M.LineRange(e,l+1),new M.LineRange(m,o+1),void 0);return g.modified.isEmpty||C.push(g),C}constructor(_,l){this.original=_,this.modified=l}toString(){return`{${this.original.toString()}->${this.modified.toString()}}`}flip(){return new A(this.modified,this.original)}join(_){return new A(this.original.join(_.original),this.modified.join(_.modified))}}n.LineRangeMapping=A;class i extends A{constructor(_,l,o){super(_,l),this.innerChanges=o}flip(){var _;return new i(this.modified,this.original,(_=this.innerChanges)===null||_===void 0?void 0:_.map(l=>l.flip()))}}n.DetailedLineRangeMapping=i;class c{constructor(_,l){this.originalRange=_,this.modifiedRange=l}toString(){return`{${this.originalRange.toString()}->${this.modifiedRange.toString()}}`}flip(){return new c(this.modifiedRange,this.originalRange)}}n.RangeMapping=c}),Y(X[46],J([0,1,8,16,7,11,33,10,3,30,15,29]),function(T,n,M,A,i,c,f,_,l,o,C,e){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.computeMovedLines=void 0;function m(v,N,y,L,r,s){let{moves:a,excludedChanges:p}=g(v,N,y,s);if(!s.isValid())return[];const d=v.filter(E=>!p.has(E)),w=u(d,L,r,N,y,s);return(0,i.pushMany)(a,w),a=h(a),a=a.filter(E=>E.original.toOffsetRange().slice(N).map(D=>D.trim()).join(`
`).length>=10),a=S(v,a),a}n.computeMovedLines=m;function g(v,N,y,L){const r=[],s=v.filter(d=>d.modified.isEmpty&&d.original.length>=3).map(d=>new C.LineRangeFragment(d.original,N,d)),a=new Set(v.filter(d=>d.original.isEmpty&&d.modified.length>=3).map(d=>new C.LineRangeFragment(d.modified,y,d))),p=new Set;for(const d of s){let w=-1,E;for(const R of a){const D=d.computeSimilarity(R);D>w&&(w=D,E=R)}if(w>.9&&E&&(a.delete(E),r.push(new A.LineRangeMapping(d.range,E.range)),p.add(d.source),p.add(E.source)),!L.isValid())return{moves:r,excludedChanges:p}}return{moves:r,excludedChanges:p}}function u(v,N,y,L,r,s){const a=[],p=new f.SetMap;for(const D of v)for(let F=D.original.startLineNumber;F<D.original.endLineNumberExclusive-2;F++){const U=`${N[F-1]}:${N[F+1-1]}:${N[F+2-1]}`;p.add(U,{range:new _.LineRange(F,F+3)})}const d=[];v.sort((0,i.compareBy)(D=>D.modified.startLineNumber,i.numberComparator));for(const D of v){let F=[];for(let U=D.modified.startLineNumber;U<D.modified.endLineNumberExclusive-2;U++){const I=`${y[U-1]}:${y[U+1-1]}:${y[U+2-1]}`,B=new _.LineRange(U,U+3),z=[];p.forEach(I,({range:k})=>{for(const x of F)if(x.originalLineRange.endLineNumberExclusive+1===k.endLineNumberExclusive&&x.modifiedLineRange.endLineNumberExclusive+1===B.endLineNumberExclusive){x.originalLineRange=new _.LineRange(x.originalLineRange.startLineNumber,k.endLineNumberExclusive),x.modifiedLineRange=new _.LineRange(x.modifiedLineRange.startLineNumber,B.endLineNumberExclusive),z.push(x);return}const q={modifiedLineRange:B,originalLineRange:k};d.push(q),z.push(q)}),F=z}if(!s.isValid())return[]}d.sort((0,i.reverseOrder)((0,i.compareBy)(D=>D.modifiedLineRange.length,i.numberComparator)));const w=new _.LineRangeSet,E=new _.LineRangeSet;for(const D of d){const F=D.modifiedLineRange.startLineNumber-D.originalLineRange.startLineNumber,U=w.subtractFrom(D.modifiedLineRange),I=E.subtractFrom(D.originalLineRange).getWithDelta(F),B=U.getIntersection(I);for(const z of B.ranges){if(z.length<3)continue;const k=z,q=z.delta(-F);a.push(new A.LineRangeMapping(q,k)),w.addRange(k),E.addRange(q)}}a.sort((0,i.compareBy)(D=>D.original.startLineNumber,i.numberComparator));const R=new c.MonotonousArray(v);for(let D=0;D<a.length;D++){const F=a[D],U=R.findLastMonotonous(V=>V.original.startLineNumber<=F.original.startLineNumber),I=(0,c.findLastMonotonous)(v,V=>V.modified.startLineNumber<=F.modified.startLineNumber),B=Math.max(F.original.startLineNumber-U.original.startLineNumber,F.modified.startLineNumber-I.modified.startLineNumber),z=R.findLastMonotonous(V=>V.original.startLineNumber<F.original.endLineNumberExclusive),k=(0,c.findLastMonotonous)(v,V=>V.modified.startLineNumber<F.modified.endLineNumberExclusive),q=Math.max(z.original.endLineNumberExclusive-F.original.endLineNumberExclusive,k.modified.endLineNumberExclusive-F.modified.endLineNumberExclusive);let x;for(x=0;x<B;x++){const V=F.original.startLineNumber-x-1,t=F.modified.startLineNumber-x-1;if(V>L.length||t>r.length||w.contains(t)||E.contains(V)||!b(L[V-1],r[t-1],s))break}x>0&&(E.addRange(new _.LineRange(F.original.startLineNumber-x,F.original.startLineNumber)),w.addRange(new _.LineRange(F.modified.startLineNumber-x,F.modified.startLineNumber)));let H;for(H=0;H<q;H++){const V=F.original.endLineNumberExclusive+H,t=F.modified.endLineNumberExclusive+H;if(V>L.length||t>r.length||w.contains(t)||E.contains(V)||!b(L[V-1],r[t-1],s))break}H>0&&(E.addRange(new _.LineRange(F.original.endLineNumberExclusive,F.original.endLineNumberExclusive+H)),w.addRange(new _.LineRange(F.modified.endLineNumberExclusive,F.modified.endLineNumberExclusive+H))),(x>0||H>0)&&(a[D]=new A.LineRangeMapping(new _.LineRange(F.original.startLineNumber-x,F.original.endLineNumberExclusive+H),new _.LineRange(F.modified.startLineNumber-x,F.modified.endLineNumberExclusive+H)))}return a}function b(v,N,y){if(v.trim()===N.trim())return!0;if(v.length>300&&N.length>300)return!1;const r=new e.MyersDiffAlgorithm().compute(new o.LinesSliceCharSequence([v],new l.OffsetRange(0,1),!1),new o.LinesSliceCharSequence([N],new l.OffsetRange(0,1),!1),y);let s=0;const a=M.SequenceDiff.invert(r.diffs,v.length);for(const E of a)E.seq1Range.forEach(R=>{(0,C.isSpace)(v.charCodeAt(R))||s++});function p(E){let R=0;for(let D=0;D<v.length;D++)(0,C.isSpace)(E.charCodeAt(D))||R++;return R}const d=p(v.length>N.length?v:N);return s/d>.6&&d>10}function h(v){if(v.length===0)return v;v.sort((0,i.compareBy)(y=>y.original.startLineNumber,i.numberComparator));const N=[v[0]];for(let y=1;y<v.length;y++){const L=N[N.length-1],r=v[y],s=r.original.startLineNumber-L.original.endLineNumberExclusive,a=r.modified.startLineNumber-L.modified.endLineNumberExclusive;if(s>=0&&a>=0&&s+a<=2){N[N.length-1]=L.join(r);continue}N.push(r)}return N}function S(v,N){const y=new c.MonotonousArray(v);return N=N.filter(L=>{const r=y.findLastMonotonous(d=>d.original.endLineNumberExclusive<=L.original.startLineNumber)||new A.LineRangeMapping(new _.LineRange(1,1),new _.LineRange(1,1)),s=L.modified.startLineNumber-r.modified.endLineNumberExclusive,a=L.original.startLineNumber-r.original.endLineNumberExclusive;return s!==a}),N}}),Y(X[47],J([0,1,7,12,10,3,2,8,45,29,46,43,31,16,30,44]),function(T,n,M,A,i,c,f,_,l,o,C,e,m,g,u,b){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.getLineRangeMapping=n.lineRangeMappingFromRangeMappings=n.DefaultLinesDiffComputer=void 0;class h{constructor(){this.dynamicProgrammingDiffing=new l.DynamicProgrammingDiffing,this.myersDiffingAlgorithm=new o.MyersDiffAlgorithm}computeDiff(y,L,r){if(y.length<=1&&(0,M.equals)(y,L,(V,t)=>V===t))return new m.LinesDiff([],[],!1);if(y.length===1&&y[0].length===0||L.length===1&&L[0].length===0)return new m.LinesDiff([new g.DetailedLineRangeMapping(new i.LineRange(1,y.length+1),new i.LineRange(1,L.length+1),[new g.RangeMapping(new f.Range(1,1,y.length,y[0].length+1),new f.Range(1,1,L.length,L[0].length+1))])],[],!1);const s=r.maxComputationTimeMs===0?_.InfiniteTimeout.instance:new _.DateTimeout(r.maxComputationTimeMs),a=!r.ignoreTrimWhitespace,p=new Map;function d(V){let t=p.get(V);return t===void 0&&(t=p.size,p.set(V,t)),t}const w=y.map(V=>d(V.trim())),E=L.map(V=>d(V.trim())),R=new b.LineSequence(w,y),D=new b.LineSequence(E,L),F=(()=>R.length+D.length<1700?this.dynamicProgrammingDiffing.compute(R,D,s,(V,t)=>y[V]===L[t]?L[t].length===0?.1:1+Math.log(1+L[t].length):.99):this.myersDiffingAlgorithm.compute(R,D))();let U=F.diffs,I=F.hitTimeout;U=(0,e.optimizeSequenceDiffs)(R,D,U),U=(0,e.removeVeryShortMatchingLinesBetweenDiffs)(R,D,U);const B=[],z=V=>{if(a)for(let t=0;t<V;t++){const ne=k+t,re=q+t;if(y[ne]!==L[re]){const le=this.refineDiff(y,L,new _.SequenceDiff(new c.OffsetRange(ne,ne+1),new c.OffsetRange(re,re+1)),s,a);for(const me of le.mappings)B.push(me);le.hitTimeout&&(I=!0)}}};let k=0,q=0;for(const V of U){(0,A.assertFn)(()=>V.seq1Range.start-k===V.seq2Range.start-q);const t=V.seq1Range.start-k;z(t),k=V.seq1Range.endExclusive,q=V.seq2Range.endExclusive;const ne=this.refineDiff(y,L,V,s,a);ne.hitTimeout&&(I=!0);for(const re of ne.mappings)B.push(re)}z(y.length-k);const x=S(B,y,L);let H=[];return r.computeMoves&&(H=this.computeMoves(x,y,L,w,E,s,a)),(0,A.assertFn)(()=>{function V(ne,re){if(ne.lineNumber<1||ne.lineNumber>re.length)return!1;const le=re[ne.lineNumber-1];return!(ne.column<1||ne.column>le.length+1)}function t(ne,re){return!(ne.startLineNumber<1||ne.startLineNumber>re.length+1||ne.endLineNumberExclusive<1||ne.endLineNumberExclusive>re.length+1)}for(const ne of x){if(!ne.innerChanges)return!1;for(const re of ne.innerChanges)if(!(V(re.modifiedRange.getStartPosition(),L)&&V(re.modifiedRange.getEndPosition(),L)&&V(re.originalRange.getStartPosition(),y)&&V(re.originalRange.getEndPosition(),y)))return!1;if(!t(ne.modified,L)||!t(ne.original,y))return!1}return!0}),new m.LinesDiff(x,H,I)}computeMoves(y,L,r,s,a,p,d){return(0,C.computeMovedLines)(y,L,r,s,a,p).map(R=>{const D=this.refineDiff(L,r,new _.SequenceDiff(R.original.toOffsetRange(),R.modified.toOffsetRange()),p,d),F=S(D.mappings,L,r,!0);return new m.MovedText(R,F)})}refineDiff(y,L,r,s,a){const p=new u.LinesSliceCharSequence(y,r.seq1Range,a),d=new u.LinesSliceCharSequence(L,r.seq2Range,a),w=p.length+d.length<500?this.dynamicProgrammingDiffing.compute(p,d,s):this.myersDiffingAlgorithm.compute(p,d,s);let E=w.diffs;return E=(0,e.optimizeSequenceDiffs)(p,d,E),E=(0,e.extendDiffsToEntireWordIfAppropriate)(p,d,E),E=(0,e.removeShortMatches)(p,d,E),E=(0,e.removeVeryShortMatchingTextBetweenLongDiffs)(p,d,E),{mappings:E.map(D=>new g.RangeMapping(p.translateRange(D.seq1Range),d.translateRange(D.seq2Range))),hitTimeout:w.hitTimeout}}}n.DefaultLinesDiffComputer=h;function S(N,y,L,r=!1){const s=[];for(const a of(0,M.groupAdjacentBy)(N.map(p=>v(p,y,L)),(p,d)=>p.original.overlapOrTouch(d.original)||p.modified.overlapOrTouch(d.modified))){const p=a[0],d=a[a.length-1];s.push(new g.DetailedLineRangeMapping(p.original.join(d.original),p.modified.join(d.modified),a.map(w=>w.innerChanges[0])))}return(0,A.assertFn)(()=>!r&&s.length>0&&s[0].original.startLineNumber!==s[0].modified.startLineNumber?!1:(0,A.checkAdjacentItems)(s,(a,p)=>p.original.startLineNumber-a.original.endLineNumberExclusive===p.modified.startLineNumber-a.modified.endLineNumberExclusive&&a.original.endLineNumberExclusive<p.original.startLineNumber&&a.modified.endLineNumberExclusive<p.modified.startLineNumber)),s}n.lineRangeMappingFromRangeMappings=S;function v(N,y,L){let r=0,s=0;N.modifiedRange.endColumn===1&&N.originalRange.endColumn===1&&N.originalRange.startLineNumber+r<=N.originalRange.endLineNumber&&N.modifiedRange.startLineNumber+r<=N.modifiedRange.endLineNumber&&(s=-1),N.modifiedRange.startColumn-1>=L[N.modifiedRange.startLineNumber-1].length&&N.originalRange.startColumn-1>=y[N.originalRange.startLineNumber-1].length&&N.originalRange.startLineNumber<=N.originalRange.endLineNumber+s&&N.modifiedRange.startLineNumber<=N.modifiedRange.endLineNumber+s&&(r=1);const a=new i.LineRange(N.originalRange.startLineNumber+r,N.originalRange.endLineNumber+1+s),p=new i.LineRange(N.modifiedRange.startLineNumber+r,N.modifiedRange.endLineNumber+1+s);return new g.DetailedLineRangeMapping(a,p,[N])}n.getLineRangeMapping=v}),Y(X[48],J([0,1,24,31,16,6,2,12,10]),function(T,n,M,A,i,c,f,_,l){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.DiffComputer=n.LegacyLinesDiffComputer=void 0;const o=3;class C{computeDiff(r,s,a){var p;const w=new S(r,s,{maxComputationTime:a.maxComputationTimeMs,shouldIgnoreTrimWhitespace:a.ignoreTrimWhitespace,shouldComputeCharChanges:!0,shouldMakePrettyDiff:!0,shouldPostProcessCharChanges:!0}).computeDiff(),E=[];let R=null;for(const D of w.changes){let F;D.originalEndLineNumber===0?F=new l.LineRange(D.originalStartLineNumber+1,D.originalStartLineNumber+1):F=new l.LineRange(D.originalStartLineNumber,D.originalEndLineNumber+1);let U;D.modifiedEndLineNumber===0?U=new l.LineRange(D.modifiedStartLineNumber+1,D.modifiedStartLineNumber+1):U=new l.LineRange(D.modifiedStartLineNumber,D.modifiedEndLineNumber+1);let I=new i.DetailedLineRangeMapping(F,U,(p=D.charChanges)===null||p===void 0?void 0:p.map(B=>new i.RangeMapping(new f.Range(B.originalStartLineNumber,B.originalStartColumn,B.originalEndLineNumber,B.originalEndColumn),new f.Range(B.modifiedStartLineNumber,B.modifiedStartColumn,B.modifiedEndLineNumber,B.modifiedEndColumn))));R&&(R.modified.endLineNumberExclusive===I.modified.startLineNumber||R.original.endLineNumberExclusive===I.original.startLineNumber)&&(I=new i.DetailedLineRangeMapping(R.original.join(I.original),R.modified.join(I.modified),R.innerChanges&&I.innerChanges?R.innerChanges.concat(I.innerChanges):void 0),E.pop()),E.push(I),R=I}return(0,_.assertFn)(()=>(0,_.checkAdjacentItems)(E,(D,F)=>F.original.startLineNumber-D.original.endLineNumberExclusive===F.modified.startLineNumber-D.modified.endLineNumberExclusive&&D.original.endLineNumberExclusive<F.original.startLineNumber&&D.modified.endLineNumberExclusive<F.modified.startLineNumber)),new A.LinesDiff(E,[],w.quitEarly)}}n.LegacyLinesDiffComputer=C;function e(L,r,s,a){return new M.LcsDiff(L,r,s).ComputeDiff(a)}class m{constructor(r){const s=[],a=[];for(let p=0,d=r.length;p<d;p++)s[p]=v(r[p],1),a[p]=N(r[p],1);this.lines=r,this._startColumns=s,this._endColumns=a}getElements(){const r=[];for(let s=0,a=this.lines.length;s<a;s++)r[s]=this.lines[s].substring(this._startColumns[s]-1,this._endColumns[s]-1);return r}getStrictElement(r){return this.lines[r]}getStartLineNumber(r){return r+1}getEndLineNumber(r){return r+1}createCharSequence(r,s,a){const p=[],d=[],w=[];let E=0;for(let R=s;R<=a;R++){const D=this.lines[R],F=r?this._startColumns[R]:1,U=r?this._endColumns[R]:D.length+1;for(let I=F;I<U;I++)p[E]=D.charCodeAt(I-1),d[E]=R+1,w[E]=I,E++;!r&&R<a&&(p[E]=10,d[E]=R+1,w[E]=D.length+1,E++)}return new g(p,d,w)}}class g{constructor(r,s,a){this._charCodes=r,this._lineNumbers=s,this._columns=a}toString(){return"["+this._charCodes.map((r,s)=>(r===10?"\\n":String.fromCharCode(r))+`-(${this._lineNumbers[s]},${this._columns[s]})`).join(", ")+"]"}_assertIndex(r,s){if(r<0||r>=s.length)throw new Error("Illegal index")}getElements(){return this._charCodes}getStartLineNumber(r){return r>0&&r===this._lineNumbers.length?this.getEndLineNumber(r-1):(this._assertIndex(r,this._lineNumbers),this._lineNumbers[r])}getEndLineNumber(r){return r===-1?this.getStartLineNumber(r+1):(this._assertIndex(r,this._lineNumbers),this._charCodes[r]===10?this._lineNumbers[r]+1:this._lineNumbers[r])}getStartColumn(r){return r>0&&r===this._columns.length?this.getEndColumn(r-1):(this._assertIndex(r,this._columns),this._columns[r])}getEndColumn(r){return r===-1?this.getStartColumn(r+1):(this._assertIndex(r,this._columns),this._charCodes[r]===10?1:this._columns[r]+1)}}class u{constructor(r,s,a,p,d,w,E,R){this.originalStartLineNumber=r,this.originalStartColumn=s,this.originalEndLineNumber=a,this.originalEndColumn=p,this.modifiedStartLineNumber=d,this.modifiedStartColumn=w,this.modifiedEndLineNumber=E,this.modifiedEndColumn=R}static createFromDiffChange(r,s,a){const p=s.getStartLineNumber(r.originalStart),d=s.getStartColumn(r.originalStart),w=s.getEndLineNumber(r.originalStart+r.originalLength-1),E=s.getEndColumn(r.originalStart+r.originalLength-1),R=a.getStartLineNumber(r.modifiedStart),D=a.getStartColumn(r.modifiedStart),F=a.getEndLineNumber(r.modifiedStart+r.modifiedLength-1),U=a.getEndColumn(r.modifiedStart+r.modifiedLength-1);return new u(p,d,w,E,R,D,F,U)}}function b(L){if(L.length<=1)return L;const r=[L[0]];let s=r[0];for(let a=1,p=L.length;a<p;a++){const d=L[a],w=d.originalStart-(s.originalStart+s.originalLength),E=d.modifiedStart-(s.modifiedStart+s.modifiedLength);Math.min(w,E)<o?(s.originalLength=d.originalStart+d.originalLength-s.originalStart,s.modifiedLength=d.modifiedStart+d.modifiedLength-s.modifiedStart):(r.push(d),s=d)}return r}class h{constructor(r,s,a,p,d){this.originalStartLineNumber=r,this.originalEndLineNumber=s,this.modifiedStartLineNumber=a,this.modifiedEndLineNumber=p,this.charChanges=d}static createFromDiffResult(r,s,a,p,d,w,E){let R,D,F,U,I;if(s.originalLength===0?(R=a.getStartLineNumber(s.originalStart)-1,D=0):(R=a.getStartLineNumber(s.originalStart),D=a.getEndLineNumber(s.originalStart+s.originalLength-1)),s.modifiedLength===0?(F=p.getStartLineNumber(s.modifiedStart)-1,U=0):(F=p.getStartLineNumber(s.modifiedStart),U=p.getEndLineNumber(s.modifiedStart+s.modifiedLength-1)),w&&s.originalLength>0&&s.originalLength<20&&s.modifiedLength>0&&s.modifiedLength<20&&d()){const B=a.createCharSequence(r,s.originalStart,s.originalStart+s.originalLength-1),z=p.createCharSequence(r,s.modifiedStart,s.modifiedStart+s.modifiedLength-1);if(B.getElements().length>0&&z.getElements().length>0){let k=e(B,z,d,!0).changes;E&&(k=b(k)),I=[];for(let q=0,x=k.length;q<x;q++)I.push(u.createFromDiffChange(k[q],B,z))}}return new h(R,D,F,U,I)}}class S{constructor(r,s,a){this.shouldComputeCharChanges=a.shouldComputeCharChanges,this.shouldPostProcessCharChanges=a.shouldPostProcessCharChanges,this.shouldIgnoreTrimWhitespace=a.shouldIgnoreTrimWhitespace,this.shouldMakePrettyDiff=a.shouldMakePrettyDiff,this.originalLines=r,this.modifiedLines=s,this.original=new m(r),this.modified=new m(s),this.continueLineDiff=y(a.maxComputationTime),this.continueCharDiff=y(a.maxComputationTime===0?0:Math.min(a.maxComputationTime,5e3))}computeDiff(){if(this.original.lines.length===1&&this.original.lines[0].length===0)return this.modified.lines.length===1&&this.modified.lines[0].length===0?{quitEarly:!1,changes:[]}:{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:1,modifiedStartLineNumber:1,modifiedEndLineNumber:this.modified.lines.length,charChanges:void 0}]};if(this.modified.lines.length===1&&this.modified.lines[0].length===0)return{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:this.original.lines.length,modifiedStartLineNumber:1,modifiedEndLineNumber:1,charChanges:void 0}]};const r=e(this.original,this.modified,this.continueLineDiff,this.shouldMakePrettyDiff),s=r.changes,a=r.quitEarly;if(this.shouldIgnoreTrimWhitespace){const E=[];for(let R=0,D=s.length;R<D;R++)E.push(h.createFromDiffResult(this.shouldIgnoreTrimWhitespace,s[R],this.original,this.modified,this.continueCharDiff,this.shouldComputeCharChanges,this.shouldPostProcessCharChanges));return{quitEarly:a,changes:E}}const p=[];let d=0,w=0;for(let E=-1,R=s.length;E<R;E++){const D=E+1<R?s[E+1]:null,F=D?D.originalStart:this.originalLines.length,U=D?D.modifiedStart:this.modifiedLines.length;for(;d<F&&w<U;){const I=this.originalLines[d],B=this.modifiedLines[w];if(I!==B){{let z=v(I,1),k=v(B,1);for(;z>1&&k>1;){const q=I.charCodeAt(z-2),x=B.charCodeAt(k-2);if(q!==x)break;z--,k--}(z>1||k>1)&&this._pushTrimWhitespaceCharChange(p,d+1,1,z,w+1,1,k)}{let z=N(I,1),k=N(B,1);const q=I.length+1,x=B.length+1;for(;z<q&&k<x;){const H=I.charCodeAt(z-1),V=I.charCodeAt(k-1);if(H!==V)break;z++,k++}(z<q||k<x)&&this._pushTrimWhitespaceCharChange(p,d+1,z,q,w+1,k,x)}}d++,w++}D&&(p.push(h.createFromDiffResult(this.shouldIgnoreTrimWhitespace,D,this.original,this.modified,this.continueCharDiff,this.shouldComputeCharChanges,this.shouldPostProcessCharChanges)),d+=D.originalLength,w+=D.modifiedLength)}return{quitEarly:a,changes:p}}_pushTrimWhitespaceCharChange(r,s,a,p,d,w,E){if(this._mergeTrimWhitespaceCharChange(r,s,a,p,d,w,E))return;let R;this.shouldComputeCharChanges&&(R=[new u(s,a,s,p,d,w,d,E)]),r.push(new h(s,s,d,d,R))}_mergeTrimWhitespaceCharChange(r,s,a,p,d,w,E){const R=r.length;if(R===0)return!1;const D=r[R-1];return D.originalEndLineNumber===0||D.modifiedEndLineNumber===0?!1:D.originalEndLineNumber===s&&D.modifiedEndLineNumber===d?(this.shouldComputeCharChanges&&D.charChanges&&D.charChanges.push(new u(s,a,s,p,d,w,d,E)),!0):D.originalEndLineNumber+1===s&&D.modifiedEndLineNumber+1===d?(D.originalEndLineNumber=s,D.modifiedEndLineNumber=d,this.shouldComputeCharChanges&&D.charChanges&&D.charChanges.push(new u(s,a,s,p,d,w,d,E)),!0):!1}}n.DiffComputer=S;function v(L,r){const s=c.firstNonWhitespaceIndex(L);return s===-1?r:s+1}function N(L,r){const s=c.lastNonWhitespaceIndex(L);return s===-1?r:s+2}function y(L){if(L===0)return()=>!0;const r=Date.now();return()=>Date.now()-r<L}}),Y(X[49],J([0,1,48,47]),function(T,n,M,A){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.linesDiffComputers=void 0,n.linesDiffComputers={getLegacy:()=>new M.LegacyLinesDiffComputer,getDefault:()=>new A.DefaultLinesDiffComputer}}),Y(X[50],J([0,1,34]),function(T,n,M){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.computeDefaultDocumentColors=void 0;function A(m){const g=[];for(const u of m){const b=Number(u);(b||b===0&&u.replace(/\s/g,"")!=="")&&g.push(b)}return g}function i(m,g,u,b){return{red:m/255,blue:u/255,green:g/255,alpha:b}}function c(m,g){const u=g.index,b=g[0].length;if(!u)return;const h=m.positionAt(u);return{startLineNumber:h.lineNumber,startColumn:h.column,endLineNumber:h.lineNumber,endColumn:h.column+b}}function f(m,g){if(!m)return;const u=M.Color.Format.CSS.parseHex(g);if(u)return{range:m,color:i(u.rgba.r,u.rgba.g,u.rgba.b,u.rgba.a)}}function _(m,g,u){if(!m||g.length!==1)return;const h=g[0].values(),S=A(h);return{range:m,color:i(S[0],S[1],S[2],u?S[3]:1)}}function l(m,g,u){if(!m||g.length!==1)return;const h=g[0].values(),S=A(h),v=new M.Color(new M.HSLA(S[0],S[1]/100,S[2]/100,u?S[3]:1));return{range:m,color:i(v.rgba.r,v.rgba.g,v.rgba.b,v.rgba.a)}}function o(m,g){return typeof m=="string"?[...m.matchAll(g)]:m.findMatches(g)}function C(m){const g=[],b=o(m,/\b(rgb|rgba|hsl|hsla)(\([0-9\s,.\%]*\))|(#)([A-Fa-f0-9]{3})\b|(#)([A-Fa-f0-9]{4})\b|(#)([A-Fa-f0-9]{6})\b|(#)([A-Fa-f0-9]{8})\b/gm);if(b.length>0)for(const h of b){const S=h.filter(L=>L!==void 0),v=S[1],N=S[2];if(!N)continue;let y;if(v==="rgb"){const L=/^\(\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*\)$/gm;y=_(c(m,h),o(N,L),!1)}else if(v==="rgba"){const L=/^\(\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(0[.][0-9]+|[.][0-9]+|[01][.]|[01])\s*\)$/gm;y=_(c(m,h),o(N,L),!0)}else if(v==="hsl"){const L=/^\(\s*(36[0]|3[0-5][0-9]|[12][0-9][0-9]|[1-9]?[0-9])\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*\)$/gm;y=l(c(m,h),o(N,L),!1)}else if(v==="hsla"){const L=/^\(\s*(36[0]|3[0-5][0-9]|[12][0-9][0-9]|[1-9]?[0-9])\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(0[.][0-9]+|[.][0-9]+|[01][.]|[01])\s*\)$/gm;y=l(c(m,h),o(N,L),!0)}else v==="#"&&(y=f(c(m,h),v+N));y&&g.push(y)}return g}function e(m){return!m||typeof m.getValue!="function"||typeof m.positionAt!="function"?[]:C(m)}n.computeDefaultDocumentColors=e}),Y(X[51],J([0,1,27]),function(T,n,M){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.computeLinks=n.LinkComputer=n.StateMachine=void 0;class A{constructor(m,g,u){const b=new Uint8Array(m*g);for(let h=0,S=m*g;h<S;h++)b[h]=u;this._data=b,this.rows=m,this.cols=g}get(m,g){return this._data[m*this.cols+g]}set(m,g,u){this._data[m*this.cols+g]=u}}class i{constructor(m){let g=0,u=0;for(let h=0,S=m.length;h<S;h++){const[v,N,y]=m[h];N>g&&(g=N),v>u&&(u=v),y>u&&(u=y)}g++,u++;const b=new A(u,g,0);for(let h=0,S=m.length;h<S;h++){const[v,N,y]=m[h];b.set(v,N,y)}this._states=b,this._maxCharCode=g}nextState(m,g){return g<0||g>=this._maxCharCode?0:this._states.get(m,g)}}n.StateMachine=i;let c=null;function f(){return c===null&&(c=new i([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),c}let _=null;function l(){if(_===null){_=new M.CharacterClassifier(0);const e=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let g=0;g<e.length;g++)_.set(e.charCodeAt(g),1);const m=".,;:";for(let g=0;g<m.length;g++)_.set(m.charCodeAt(g),2)}return _}class o{static _createLink(m,g,u,b,h){let S=h-1;do{const v=g.charCodeAt(S);if(m.get(v)!==2)break;S--}while(S>b);if(b>0){const v=g.charCodeAt(b-1),N=g.charCodeAt(S);(v===40&&N===41||v===91&&N===93||v===123&&N===125)&&S--}return{range:{startLineNumber:u,startColumn:b+1,endLineNumber:u,endColumn:S+2},url:g.substring(b,S+1)}}static computeLinks(m,g=f()){const u=l(),b=[];for(let h=1,S=m.getLineCount();h<=S;h++){const v=m.getLineContent(h),N=v.length;let y=0,L=0,r=0,s=1,a=!1,p=!1,d=!1,w=!1;for(;y<N;){let E=!1;const R=v.charCodeAt(y);if(s===13){let D;switch(R){case 40:a=!0,D=0;break;case 41:D=a?0:1;break;case 91:d=!0,p=!0,D=0;break;case 93:d=!1,D=p?0:1;break;case 123:w=!0,D=0;break;case 125:D=w?0:1;break;case 39:case 34:case 96:r===R?D=1:r===39||r===34||r===96?D=0:D=1;break;case 42:D=r===42?1:0;break;case 124:D=r===124?1:0;break;case 32:D=d?0:1;break;default:D=u.get(R)}D===1&&(b.push(o._createLink(u,v,h,L,y)),E=!0)}else if(s===12){let D;R===91?(p=!0,D=0):D=u.get(R),D===1?E=!0:s=13}else s=g.nextState(s,R),s===0&&(E=!0);E&&(s=1,a=!1,p=!1,w=!1,L=y+1,r=R),y++}s===13&&b.push(o._createLink(u,v,h,L,N))}return b}}n.LinkComputer=o;function C(e){return!e||typeof e.getLineCount!="function"||typeof e.getLineContent!="function"?[]:o.computeLinks(e)}n.computeLinks=C}),Y(X[52],J([0,1]),function(T,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.BasicInplaceReplace=void 0;class M{constructor(){this._defaultValueSet=[["true","false"],["True","False"],["Private","Public","Friend","ReadOnly","Partial","Protected","WriteOnly"],["public","protected","private"]]}navigateValueSet(i,c,f,_,l){if(i&&c){const o=this.doNavigateValueSet(c,l);if(o)return{range:i,value:o}}if(f&&_){const o=this.doNavigateValueSet(_,l);if(o)return{range:f,value:o}}return null}doNavigateValueSet(i,c){const f=this.numberReplace(i,c);return f!==null?f:this.textReplace(i,c)}numberReplace(i,c){const f=Math.pow(10,i.length-(i.lastIndexOf(".")+1));let _=Number(i);const l=parseFloat(i);return!isNaN(_)&&!isNaN(l)&&_===l?_===0&&!c?null:(_=Math.floor(_*f),_+=c?f:-f,String(_/f)):null}textReplace(i,c){return this.valueSetsReplace(this._defaultValueSet,i,c)}valueSetsReplace(i,c,f){let _=null;for(let l=0,o=i.length;_===null&&l<o;l++)_=this.valueSetReplace(i[l],c,f);return _}valueSetReplace(i,c,f){let _=i.indexOf(c);return _>=0?(_+=f?1:-1,_<0?_=i.length-1:_%=i.length,i[_]):null}}n.BasicInplaceReplace=M,M.INSTANCE=new M}),Y(X[53],J([0,1,14]),function(T,n,M){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.shouldSynchronizeModel=n.ApplyEditsResult=n.SearchData=n.ValidAnnotatedEditOperation=n.isITextSnapshot=n.FindMatch=n.TextModelResolvedOptions=n.InjectedTextCursorStops=n.MinimapPosition=n.GlyphMarginLane=n.OverviewRulerLane=void 0;var A;(function(u){u[u.Left=1]="Left",u[u.Center=2]="Center",u[u.Right=4]="Right",u[u.Full=7]="Full"})(A||(n.OverviewRulerLane=A={}));var i;(function(u){u[u.Left=1]="Left",u[u.Right=2]="Right"})(i||(n.GlyphMarginLane=i={}));var c;(function(u){u[u.Inline=1]="Inline",u[u.Gutter=2]="Gutter"})(c||(n.MinimapPosition=c={}));var f;(function(u){u[u.Both=0]="Both",u[u.Right=1]="Right",u[u.Left=2]="Left",u[u.None=3]="None"})(f||(n.InjectedTextCursorStops=f={}));class _{get originalIndentSize(){return this._indentSizeIsTabSize?"tabSize":this.indentSize}constructor(b){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,b.tabSize|0),b.indentSize==="tabSize"?(this.indentSize=this.tabSize,this._indentSizeIsTabSize=!0):(this.indentSize=Math.max(1,b.indentSize|0),this._indentSizeIsTabSize=!1),this.insertSpaces=!!b.insertSpaces,this.defaultEOL=b.defaultEOL|0,this.trimAutoWhitespace=!!b.trimAutoWhitespace,this.bracketPairColorizationOptions=b.bracketPairColorizationOptions}equals(b){return this.tabSize===b.tabSize&&this._indentSizeIsTabSize===b._indentSizeIsTabSize&&this.indentSize===b.indentSize&&this.insertSpaces===b.insertSpaces&&this.defaultEOL===b.defaultEOL&&this.trimAutoWhitespace===b.trimAutoWhitespace&&(0,M.equals)(this.bracketPairColorizationOptions,b.bracketPairColorizationOptions)}createChangeEvent(b){return{tabSize:this.tabSize!==b.tabSize,indentSize:this.indentSize!==b.indentSize,insertSpaces:this.insertSpaces!==b.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==b.trimAutoWhitespace}}}n.TextModelResolvedOptions=_;class l{constructor(b,h){this._findMatchBrand=void 0,this.range=b,this.matches=h}}n.FindMatch=l;function o(u){return u&&typeof u.read=="function"}n.isITextSnapshot=o;class C{constructor(b,h,S,v,N,y){this.identifier=b,this.range=h,this.text=S,this.forceMoveMarkers=v,this.isAutoWhitespaceEdit=N,this._isTracked=y}}n.ValidAnnotatedEditOperation=C;class e{constructor(b,h,S){this.regex=b,this.wordSeparators=h,this.simpleSearch=S}}n.SearchData=e;class m{constructor(b,h,S){this.reverseEdits=b,this.changes=h,this.trimAutoWhitespaceLineNumbers=S}}n.ApplyEditsResult=m;function g(u){return!u.isTooLargeForSyncing()&&!u.isForSimpleWidget}n.shouldSynchronizeModel=g}),Y(X[54],J([0,1,7,26]),function(T,n,M,A){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.PrefixSumIndexOfResult=n.ConstantTimePrefixSumComputer=n.PrefixSumComputer=void 0;class i{constructor(l){this.values=l,this.prefixSum=new Uint32Array(l.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}insertValues(l,o){l=(0,A.toUint32)(l);const C=this.values,e=this.prefixSum,m=o.length;return m===0?!1:(this.values=new Uint32Array(C.length+m),this.values.set(C.subarray(0,l),0),this.values.set(C.subarray(l),l+m),this.values.set(o,l),l-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=l-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(e.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}setValue(l,o){return l=(0,A.toUint32)(l),o=(0,A.toUint32)(o),this.values[l]===o?!1:(this.values[l]=o,l-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=l-1),!0)}removeValues(l,o){l=(0,A.toUint32)(l),o=(0,A.toUint32)(o);const C=this.values,e=this.prefixSum;if(l>=C.length)return!1;const m=C.length-l;return o>=m&&(o=m),o===0?!1:(this.values=new Uint32Array(C.length-o),this.values.set(C.subarray(0,l),0),this.values.set(C.subarray(l+o),l),this.prefixSum=new Uint32Array(this.values.length),l-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=l-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(e.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalSum(){return this.values.length===0?0:this._getPrefixSum(this.values.length-1)}getPrefixSum(l){return l<0?0:(l=(0,A.toUint32)(l),this._getPrefixSum(l))}_getPrefixSum(l){if(l<=this.prefixSumValidIndex[0])return this.prefixSum[l];let o=this.prefixSumValidIndex[0]+1;o===0&&(this.prefixSum[0]=this.values[0],o++),l>=this.values.length&&(l=this.values.length-1);for(let C=o;C<=l;C++)this.prefixSum[C]=this.prefixSum[C-1]+this.values[C];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],l),this.prefixSum[l]}getIndexOf(l){l=Math.floor(l),this.getTotalSum();let o=0,C=this.values.length-1,e=0,m=0,g=0;for(;o<=C;)if(e=o+(C-o)/2|0,m=this.prefixSum[e],g=m-this.values[e],l<g)C=e-1;else if(l>=m)o=e+1;else break;return new f(e,l-g)}}n.PrefixSumComputer=i;class c{constructor(l){this._values=l,this._isValid=!1,this._validEndIndex=-1,this._prefixSum=[],this._indexBySum=[]}getTotalSum(){return this._ensureValid(),this._indexBySum.length}getPrefixSum(l){return this._ensureValid(),l===0?0:this._prefixSum[l-1]}getIndexOf(l){this._ensureValid();const o=this._indexBySum[l],C=o>0?this._prefixSum[o-1]:0;return new f(o,l-C)}removeValues(l,o){this._values.splice(l,o),this._invalidate(l)}insertValues(l,o){this._values=(0,M.arrayInsert)(this._values,l,o),this._invalidate(l)}_invalidate(l){this._isValid=!1,this._validEndIndex=Math.min(this._validEndIndex,l-1)}_ensureValid(){if(!this._isValid){for(let l=this._validEndIndex+1,o=this._values.length;l<o;l++){const C=this._values[l],e=l>0?this._prefixSum[l-1]:0;this._prefixSum[l]=e+C;for(let m=0;m<C;m++)this._indexBySum[e+m]=l}this._prefixSum.length=this._values.length,this._indexBySum.length=this._prefixSum[this._prefixSum.length-1],this._isValid=!0,this._validEndIndex=this._values.length-1}}setValue(l,o){this._values[l]!==o&&(this._values[l]=o,this._invalidate(l))}}n.ConstantTimePrefixSumComputer=c;class f{constructor(l,o){this.index=l,this.remainder=o,this._prefixSumIndexOfResultBrand=void 0,this.index=l,this.remainder=o}}n.PrefixSumIndexOfResult=f}),Y(X[55],J([0,1,6,4,54]),function(T,n,M,A,i){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.MirrorTextModel=void 0;class c{constructor(_,l,o,C){this._uri=_,this._lines=l,this._eol=o,this._versionId=C,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(_){_.eol&&_.eol!==this._eol&&(this._eol=_.eol,this._lineStarts=null);const l=_.changes;for(const o of l)this._acceptDeleteRange(o.range),this._acceptInsertText(new A.Position(o.range.startLineNumber,o.range.startColumn),o.text);this._versionId=_.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const _=this._eol.length,l=this._lines.length,o=new Uint32Array(l);for(let C=0;C<l;C++)o[C]=this._lines[C].length+_;this._lineStarts=new i.PrefixSumComputer(o)}}_setLineText(_,l){this._lines[_]=l,this._lineStarts&&this._lineStarts.setValue(_,this._lines[_].length+this._eol.length)}_acceptDeleteRange(_){if(_.startLineNumber===_.endLineNumber){if(_.startColumn===_.endColumn)return;this._setLineText(_.startLineNumber-1,this._lines[_.startLineNumber-1].substring(0,_.startColumn-1)+this._lines[_.startLineNumber-1].substring(_.endColumn-1));return}this._setLineText(_.startLineNumber-1,this._lines[_.startLineNumber-1].substring(0,_.startColumn-1)+this._lines[_.endLineNumber-1].substring(_.endColumn-1)),this._lines.splice(_.startLineNumber,_.endLineNumber-_.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(_.startLineNumber,_.endLineNumber-_.startLineNumber)}_acceptInsertText(_,l){if(l.length===0)return;const o=(0,M.splitLines)(l);if(o.length===1){this._setLineText(_.lineNumber-1,this._lines[_.lineNumber-1].substring(0,_.column-1)+o[0]+this._lines[_.lineNumber-1].substring(_.column-1));return}o[o.length-1]+=this._lines[_.lineNumber-1].substring(_.column-1),this._setLineText(_.lineNumber-1,this._lines[_.lineNumber-1].substring(0,_.column-1)+o[0]);const C=new Uint32Array(o.length-1);for(let e=1;e<o.length;e++)this._lines.splice(_.lineNumber+e-1,0,o[e]),C[e-1]=o[e].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(_.lineNumber,C)}}n.MirrorTextModel=c}),Y(X[56],J([0,1,6,42,4,2,53]),function(T,n,M,A,i,c,f){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Searcher=n.isValidMatch=n.TextModelSearch=n.createFindMatch=n.isMultilineRegexSource=n.SearchParams=void 0;const _=999;class l{constructor(v,N,y,L){this.searchString=v,this.isRegex=N,this.matchCase=y,this.wordSeparators=L}parseSearchRequest(){if(this.searchString==="")return null;let v;this.isRegex?v=o(this.searchString):v=this.searchString.indexOf(`
`)>=0;let N=null;try{N=M.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:v,global:!0,unicode:!0})}catch{return null}if(!N)return null;let y=!this.isRegex&&!v;return y&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(y=this.matchCase),new f.SearchData(N,this.wordSeparators?(0,A.getMapForWordSeparators)(this.wordSeparators):null,y?this.searchString:null)}}n.SearchParams=l;function o(S){if(!S||S.length===0)return!1;for(let v=0,N=S.length;v<N;v++){const y=S.charCodeAt(v);if(y===10)return!0;if(y===92){if(v++,v>=N)break;const L=S.charCodeAt(v);if(L===110||L===114||L===87)return!0}}return!1}n.isMultilineRegexSource=o;function C(S,v,N){if(!N)return new f.FindMatch(S,null);const y=[];for(let L=0,r=v.length;L<r;L++)y[L]=v[L];return new f.FindMatch(S,y)}n.createFindMatch=C;class e{constructor(v){const N=[];let y=0;for(let L=0,r=v.length;L<r;L++)v.charCodeAt(L)===10&&(N[y++]=L);this._lineFeedsOffsets=N}findLineFeedCountBeforeOffset(v){const N=this._lineFeedsOffsets;let y=0,L=N.length-1;if(L===-1||v<=N[0])return 0;for(;y<L;){const r=y+((L-y)/2>>0);N[r]>=v?L=r-1:N[r+1]>=v?(y=r,L=r):y=r+1}return y+1}}class m{static findMatches(v,N,y,L,r){const s=N.parseSearchRequest();return s?s.regex.multiline?this._doFindMatchesMultiline(v,y,new h(s.wordSeparators,s.regex),L,r):this._doFindMatchesLineByLine(v,y,s,L,r):[]}static _getMultilineMatchRange(v,N,y,L,r,s){let a,p=0;L?(p=L.findLineFeedCountBeforeOffset(r),a=N+r+p):a=N+r;let d;if(L){const D=L.findLineFeedCountBeforeOffset(r+s.length)-p;d=a+s.length+D}else d=a+s.length;const w=v.getPositionAt(a),E=v.getPositionAt(d);return new c.Range(w.lineNumber,w.column,E.lineNumber,E.column)}static _doFindMatchesMultiline(v,N,y,L,r){const s=v.getOffsetAt(N.getStartPosition()),a=v.getValueInRange(N,1),p=v.getEOL()===`\r
`?new e(a):null,d=[];let w=0,E;for(y.reset(0);E=y.next(a);)if(d[w++]=C(this._getMultilineMatchRange(v,s,a,p,E.index,E[0]),E,L),w>=r)return d;return d}static _doFindMatchesLineByLine(v,N,y,L,r){const s=[];let a=0;if(N.startLineNumber===N.endLineNumber){const d=v.getLineContent(N.startLineNumber).substring(N.startColumn-1,N.endColumn-1);return a=this._findMatchesInLine(y,d,N.startLineNumber,N.startColumn-1,a,s,L,r),s}const p=v.getLineContent(N.startLineNumber).substring(N.startColumn-1);a=this._findMatchesInLine(y,p,N.startLineNumber,N.startColumn-1,a,s,L,r);for(let d=N.startLineNumber+1;d<N.endLineNumber&&a<r;d++)a=this._findMatchesInLine(y,v.getLineContent(d),d,0,a,s,L,r);if(a<r){const d=v.getLineContent(N.endLineNumber).substring(0,N.endColumn-1);a=this._findMatchesInLine(y,d,N.endLineNumber,0,a,s,L,r)}return s}static _findMatchesInLine(v,N,y,L,r,s,a,p){const d=v.wordSeparators;if(!a&&v.simpleSearch){const R=v.simpleSearch,D=R.length,F=N.length;let U=-D;for(;(U=N.indexOf(R,U+D))!==-1;)if((!d||b(d,N,F,U,D))&&(s[r++]=new f.FindMatch(new c.Range(y,U+1+L,y,U+1+D+L),null),r>=p))return r;return r}const w=new h(v.wordSeparators,v.regex);let E;w.reset(0);do if(E=w.next(N),E&&(s[r++]=C(new c.Range(y,E.index+1+L,y,E.index+1+E[0].length+L),E,a),r>=p))return r;while(E);return r}static findNextMatch(v,N,y,L){const r=N.parseSearchRequest();if(!r)return null;const s=new h(r.wordSeparators,r.regex);return r.regex.multiline?this._doFindNextMatchMultiline(v,y,s,L):this._doFindNextMatchLineByLine(v,y,s,L)}static _doFindNextMatchMultiline(v,N,y,L){const r=new i.Position(N.lineNumber,1),s=v.getOffsetAt(r),a=v.getLineCount(),p=v.getValueInRange(new c.Range(r.lineNumber,r.column,a,v.getLineMaxColumn(a)),1),d=v.getEOL()===`\r
`?new e(p):null;y.reset(N.column-1);const w=y.next(p);return w?C(this._getMultilineMatchRange(v,s,p,d,w.index,w[0]),w,L):N.lineNumber!==1||N.column!==1?this._doFindNextMatchMultiline(v,new i.Position(1,1),y,L):null}static _doFindNextMatchLineByLine(v,N,y,L){const r=v.getLineCount(),s=N.lineNumber,a=v.getLineContent(s),p=this._findFirstMatchInLine(y,a,s,N.column,L);if(p)return p;for(let d=1;d<=r;d++){const w=(s+d-1)%r,E=v.getLineContent(w+1),R=this._findFirstMatchInLine(y,E,w+1,1,L);if(R)return R}return null}static _findFirstMatchInLine(v,N,y,L,r){v.reset(L-1);const s=v.next(N);return s?C(new c.Range(y,s.index+1,y,s.index+1+s[0].length),s,r):null}static findPreviousMatch(v,N,y,L){const r=N.parseSearchRequest();if(!r)return null;const s=new h(r.wordSeparators,r.regex);return r.regex.multiline?this._doFindPreviousMatchMultiline(v,y,s,L):this._doFindPreviousMatchLineByLine(v,y,s,L)}static _doFindPreviousMatchMultiline(v,N,y,L){const r=this._doFindMatchesMultiline(v,new c.Range(1,1,N.lineNumber,N.column),y,L,10*_);if(r.length>0)return r[r.length-1];const s=v.getLineCount();return N.lineNumber!==s||N.column!==v.getLineMaxColumn(s)?this._doFindPreviousMatchMultiline(v,new i.Position(s,v.getLineMaxColumn(s)),y,L):null}static _doFindPreviousMatchLineByLine(v,N,y,L){const r=v.getLineCount(),s=N.lineNumber,a=v.getLineContent(s).substring(0,N.column-1),p=this._findLastMatchInLine(y,a,s,L);if(p)return p;for(let d=1;d<=r;d++){const w=(r+s-d-1)%r,E=v.getLineContent(w+1),R=this._findLastMatchInLine(y,E,w+1,L);if(R)return R}return null}static _findLastMatchInLine(v,N,y,L){let r=null,s;for(v.reset(0);s=v.next(N);)r=C(new c.Range(y,s.index+1,y,s.index+1+s[0].length),s,L);return r}}n.TextModelSearch=m;function g(S,v,N,y,L){if(y===0)return!0;const r=v.charCodeAt(y-1);if(S.get(r)!==0||r===13||r===10)return!0;if(L>0){const s=v.charCodeAt(y);if(S.get(s)!==0)return!0}return!1}function u(S,v,N,y,L){if(y+L===N)return!0;const r=v.charCodeAt(y+L);if(S.get(r)!==0||r===13||r===10)return!0;if(L>0){const s=v.charCodeAt(y+L-1);if(S.get(s)!==0)return!0}return!1}function b(S,v,N,y,L){return g(S,v,N,y,L)&&u(S,v,N,y,L)}n.isValidMatch=b;class h{constructor(v,N){this._wordSeparators=v,this._searchRegex=N,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(v){this._searchRegex.lastIndex=v,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(v){const N=v.length;let y;do{if(this._prevMatchStartIndex+this._prevMatchLength===N||(y=this._searchRegex.exec(v),!y))return null;const L=y.index,r=y[0].length;if(L===this._prevMatchStartIndex&&r===this._prevMatchLength){if(r===0){M.getNextCodePoint(v,N,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=L,this._prevMatchLength=r,!this._wordSeparators||b(this._wordSeparators,v,N,L,r))return y}while(y);return null}}n.Searcher=h}),Y(X[57],J([0,1,2,56,6,12,28]),function(T,n,M,A,i,c,f){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.UnicodeTextModelHighlighter=void 0;class _{static computeUnicodeHighlights(m,g,u){const b=u?u.startLineNumber:1,h=u?u.endLineNumber:m.getLineCount(),S=new o(g),v=S.getCandidateCodePoints();let N;v==="allNonBasicAscii"?N=new RegExp("[^\\t\\n\\r\\x20-\\x7E]","g"):N=new RegExp(`${l(Array.from(v))}`,"g");const y=new A.Searcher(null,N),L=[];let r=!1,s,a=0,p=0,d=0;e:for(let w=b,E=h;w<=E;w++){const R=m.getLineContent(w),D=R.length;y.reset(0);do if(s=y.next(R),s){let F=s.index,U=s.index+s[0].length;if(F>0){const k=R.charCodeAt(F-1);i.isHighSurrogate(k)&&F--}if(U+1<D){const k=R.charCodeAt(U-1);i.isHighSurrogate(k)&&U++}const I=R.substring(F,U);let B=(0,f.getWordAtText)(F+1,f.DEFAULT_WORD_REGEXP,R,0);B&&B.endColumn<=F+1&&(B=null);const z=S.shouldHighlightNonBasicASCII(I,B?B.word:null);if(z!==0){z===3?a++:z===2?p++:z===1?d++:(0,c.assertNever)(z);const k=1e3;if(L.length>=k){r=!0;break e}L.push(new M.Range(w,F+1,w,U+1))}}while(s)}return{ranges:L,hasMore:r,ambiguousCharacterCount:a,invisibleCharacterCount:p,nonBasicAsciiCharacterCount:d}}static computeUnicodeHighlightReason(m,g){const u=new o(g);switch(u.shouldHighlightNonBasicASCII(m,null)){case 0:return null;case 2:return{kind:1};case 3:{const h=m.codePointAt(0),S=u.ambiguousCharacters.getPrimaryConfusable(h),v=i.AmbiguousCharacters.getLocales().filter(N=>!i.AmbiguousCharacters.getInstance(new Set([...g.allowedLocales,N])).isAmbiguous(h));return{kind:0,confusableWith:String.fromCodePoint(S),notAmbiguousInLocales:v}}case 1:return{kind:2}}}}n.UnicodeTextModelHighlighter=_;function l(e,m){return`[${i.escapeRegExpCharacters(e.map(u=>String.fromCodePoint(u)).join(""))}]`}class o{constructor(m){this.options=m,this.allowedCodePoints=new Set(m.allowedCodePoints),this.ambiguousCharacters=i.AmbiguousCharacters.getInstance(new Set(m.allowedLocales))}getCandidateCodePoints(){if(this.options.nonBasicASCII)return"allNonBasicAscii";const m=new Set;if(this.options.invisibleCharacters)for(const g of i.InvisibleCharacters.codePoints)C(String.fromCodePoint(g))||m.add(g);if(this.options.ambiguousCharacters)for(const g of this.ambiguousCharacters.getConfusableCodePoints())m.add(g);for(const g of this.allowedCodePoints)m.delete(g);return m}shouldHighlightNonBasicASCII(m,g){const u=m.codePointAt(0);if(this.allowedCodePoints.has(u))return 0;if(this.options.nonBasicASCII)return 1;let b=!1,h=!1;if(g)for(const S of g){const v=S.codePointAt(0),N=i.isBasicASCII(S);b=b||N,!N&&!this.ambiguousCharacters.isAmbiguous(v)&&!i.InvisibleCharacters.isInvisibleCharacter(v)&&(h=!0)}return!b&&h?0:this.options.invisibleCharacters&&!C(m)&&i.InvisibleCharacters.isInvisibleCharacter(u)?2:this.options.ambiguousCharacters&&this.ambiguousCharacters.isAmbiguous(u)?3:0}}function C(e){return e===" "||e===`
`||e==="	"}}),Y(X[58],J([0,1]),function(T,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.WrappingIndent=n.TrackedRangeStickiness=n.TextEditorCursorStyle=n.TextEditorCursorBlinkingStyle=n.SymbolTag=n.SymbolKind=n.SignatureHelpTriggerKind=n.SelectionDirection=n.ScrollbarVisibility=n.ScrollType=n.RenderMinimap=n.RenderLineNumbersType=n.PositionAffinity=n.OverviewRulerLane=n.OverlayWidgetPositionPreference=n.MouseTargetType=n.MinimapPosition=n.MarkerTag=n.MarkerSeverity=n.KeyCode=n.InlineCompletionTriggerKind=n.InlayHintKind=n.InjectedTextCursorStops=n.IndentAction=n.GlyphMarginLane=n.EndOfLineSequence=n.EndOfLinePreference=n.EditorOption=n.EditorAutoIndentStrategy=n.DocumentHighlightKind=n.DefaultEndOfLine=n.CursorChangeReason=n.ContentWidgetPositionPreference=n.CompletionTriggerKind=n.CompletionItemTag=n.CompletionItemKind=n.CompletionItemInsertTextRule=n.CodeActionTriggerType=n.AccessibilitySupport=void 0;var M;(function(t){t[t.Unknown=0]="Unknown",t[t.Disabled=1]="Disabled",t[t.Enabled=2]="Enabled"})(M||(n.AccessibilitySupport=M={}));var A;(function(t){t[t.Invoke=1]="Invoke",t[t.Auto=2]="Auto"})(A||(n.CodeActionTriggerType=A={}));var i;(function(t){t[t.None=0]="None",t[t.KeepWhitespace=1]="KeepWhitespace",t[t.InsertAsSnippet=4]="InsertAsSnippet"})(i||(n.CompletionItemInsertTextRule=i={}));var c;(function(t){t[t.Method=0]="Method",t[t.Function=1]="Function",t[t.Constructor=2]="Constructor",t[t.Field=3]="Field",t[t.Variable=4]="Variable",t[t.Class=5]="Class",t[t.Struct=6]="Struct",t[t.Interface=7]="Interface",t[t.Module=8]="Module",t[t.Property=9]="Property",t[t.Event=10]="Event",t[t.Operator=11]="Operator",t[t.Unit=12]="Unit",t[t.Value=13]="Value",t[t.Constant=14]="Constant",t[t.Enum=15]="Enum",t[t.EnumMember=16]="EnumMember",t[t.Keyword=17]="Keyword",t[t.Text=18]="Text",t[t.Color=19]="Color",t[t.File=20]="File",t[t.Reference=21]="Reference",t[t.Customcolor=22]="Customcolor",t[t.Folder=23]="Folder",t[t.TypeParameter=24]="TypeParameter",t[t.User=25]="User",t[t.Issue=26]="Issue",t[t.Snippet=27]="Snippet"})(c||(n.CompletionItemKind=c={}));var f;(function(t){t[t.Deprecated=1]="Deprecated"})(f||(n.CompletionItemTag=f={}));var _;(function(t){t[t.Invoke=0]="Invoke",t[t.TriggerCharacter=1]="TriggerCharacter",t[t.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(_||(n.CompletionTriggerKind=_={}));var l;(function(t){t[t.EXACT=0]="EXACT",t[t.ABOVE=1]="ABOVE",t[t.BELOW=2]="BELOW"})(l||(n.ContentWidgetPositionPreference=l={}));var o;(function(t){t[t.NotSet=0]="NotSet",t[t.ContentFlush=1]="ContentFlush",t[t.RecoverFromMarkers=2]="RecoverFromMarkers",t[t.Explicit=3]="Explicit",t[t.Paste=4]="Paste",t[t.Undo=5]="Undo",t[t.Redo=6]="Redo"})(o||(n.CursorChangeReason=o={}));var C;(function(t){t[t.LF=1]="LF",t[t.CRLF=2]="CRLF"})(C||(n.DefaultEndOfLine=C={}));var e;(function(t){t[t.Text=0]="Text",t[t.Read=1]="Read",t[t.Write=2]="Write"})(e||(n.DocumentHighlightKind=e={}));var m;(function(t){t[t.None=0]="None",t[t.Keep=1]="Keep",t[t.Brackets=2]="Brackets",t[t.Advanced=3]="Advanced",t[t.Full=4]="Full"})(m||(n.EditorAutoIndentStrategy=m={}));var g;(function(t){t[t.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",t[t.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",t[t.accessibilitySupport=2]="accessibilitySupport",t[t.accessibilityPageSize=3]="accessibilityPageSize",t[t.ariaLabel=4]="ariaLabel",t[t.ariaRequired=5]="ariaRequired",t[t.autoClosingBrackets=6]="autoClosingBrackets",t[t.autoClosingComments=7]="autoClosingComments",t[t.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",t[t.autoClosingDelete=9]="autoClosingDelete",t[t.autoClosingOvertype=10]="autoClosingOvertype",t[t.autoClosingQuotes=11]="autoClosingQuotes",t[t.autoIndent=12]="autoIndent",t[t.automaticLayout=13]="automaticLayout",t[t.autoSurround=14]="autoSurround",t[t.bracketPairColorization=15]="bracketPairColorization",t[t.guides=16]="guides",t[t.codeLens=17]="codeLens",t[t.codeLensFontFamily=18]="codeLensFontFamily",t[t.codeLensFontSize=19]="codeLensFontSize",t[t.colorDecorators=20]="colorDecorators",t[t.colorDecoratorsLimit=21]="colorDecoratorsLimit",t[t.columnSelection=22]="columnSelection",t[t.comments=23]="comments",t[t.contextmenu=24]="contextmenu",t[t.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",t[t.cursorBlinking=26]="cursorBlinking",t[t.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",t[t.cursorStyle=28]="cursorStyle",t[t.cursorSurroundingLines=29]="cursorSurroundingLines",t[t.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",t[t.cursorWidth=31]="cursorWidth",t[t.disableLayerHinting=32]="disableLayerHinting",t[t.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",t[t.domReadOnly=34]="domReadOnly",t[t.dragAndDrop=35]="dragAndDrop",t[t.dropIntoEditor=36]="dropIntoEditor",t[t.emptySelectionClipboard=37]="emptySelectionClipboard",t[t.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",t[t.extraEditorClassName=39]="extraEditorClassName",t[t.fastScrollSensitivity=40]="fastScrollSensitivity",t[t.find=41]="find",t[t.fixedOverflowWidgets=42]="fixedOverflowWidgets",t[t.folding=43]="folding",t[t.foldingStrategy=44]="foldingStrategy",t[t.foldingHighlight=45]="foldingHighlight",t[t.foldingImportsByDefault=46]="foldingImportsByDefault",t[t.foldingMaximumRegions=47]="foldingMaximumRegions",t[t.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",t[t.fontFamily=49]="fontFamily",t[t.fontInfo=50]="fontInfo",t[t.fontLigatures=51]="fontLigatures",t[t.fontSize=52]="fontSize",t[t.fontWeight=53]="fontWeight",t[t.fontVariations=54]="fontVariations",t[t.formatOnPaste=55]="formatOnPaste",t[t.formatOnType=56]="formatOnType",t[t.glyphMargin=57]="glyphMargin",t[t.gotoLocation=58]="gotoLocation",t[t.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",t[t.hover=60]="hover",t[t.inDiffEditor=61]="inDiffEditor",t[t.inlineSuggest=62]="inlineSuggest",t[t.letterSpacing=63]="letterSpacing",t[t.lightbulb=64]="lightbulb",t[t.lineDecorationsWidth=65]="lineDecorationsWidth",t[t.lineHeight=66]="lineHeight",t[t.lineNumbers=67]="lineNumbers",t[t.lineNumbersMinChars=68]="lineNumbersMinChars",t[t.linkedEditing=69]="linkedEditing",t[t.links=70]="links",t[t.matchBrackets=71]="matchBrackets",t[t.minimap=72]="minimap",t[t.mouseStyle=73]="mouseStyle",t[t.mouseWheelScrollSensitivity=74]="mouseWheelScrollSensitivity",t[t.mouseWheelZoom=75]="mouseWheelZoom",t[t.multiCursorMergeOverlapping=76]="multiCursorMergeOverlapping",t[t.multiCursorModifier=77]="multiCursorModifier",t[t.multiCursorPaste=78]="multiCursorPaste",t[t.multiCursorLimit=79]="multiCursorLimit",t[t.occurrencesHighlight=80]="occurrencesHighlight",t[t.overviewRulerBorder=81]="overviewRulerBorder",t[t.overviewRulerLanes=82]="overviewRulerLanes",t[t.padding=83]="padding",t[t.pasteAs=84]="pasteAs",t[t.parameterHints=85]="parameterHints",t[t.peekWidgetDefaultFocus=86]="peekWidgetDefaultFocus",t[t.definitionLinkOpensInPeek=87]="definitionLinkOpensInPeek",t[t.quickSuggestions=88]="quickSuggestions",t[t.quickSuggestionsDelay=89]="quickSuggestionsDelay",t[t.readOnly=90]="readOnly",t[t.readOnlyMessage=91]="readOnlyMessage",t[t.renameOnType=92]="renameOnType",t[t.renderControlCharacters=93]="renderControlCharacters",t[t.renderFinalNewline=94]="renderFinalNewline",t[t.renderLineHighlight=95]="renderLineHighlight",t[t.renderLineHighlightOnlyWhenFocus=96]="renderLineHighlightOnlyWhenFocus",t[t.renderValidationDecorations=97]="renderValidationDecorations",t[t.renderWhitespace=98]="renderWhitespace",t[t.revealHorizontalRightPadding=99]="revealHorizontalRightPadding",t[t.roundedSelection=100]="roundedSelection",t[t.rulers=101]="rulers",t[t.scrollbar=102]="scrollbar",t[t.scrollBeyondLastColumn=103]="scrollBeyondLastColumn",t[t.scrollBeyondLastLine=104]="scrollBeyondLastLine",t[t.scrollPredominantAxis=105]="scrollPredominantAxis",t[t.selectionClipboard=106]="selectionClipboard",t[t.selectionHighlight=107]="selectionHighlight",t[t.selectOnLineNumbers=108]="selectOnLineNumbers",t[t.showFoldingControls=109]="showFoldingControls",t[t.showUnused=110]="showUnused",t[t.snippetSuggestions=111]="snippetSuggestions",t[t.smartSelect=112]="smartSelect",t[t.smoothScrolling=113]="smoothScrolling",t[t.stickyScroll=114]="stickyScroll",t[t.stickyTabStops=115]="stickyTabStops",t[t.stopRenderingLineAfter=116]="stopRenderingLineAfter",t[t.suggest=117]="suggest",t[t.suggestFontSize=118]="suggestFontSize",t[t.suggestLineHeight=119]="suggestLineHeight",t[t.suggestOnTriggerCharacters=120]="suggestOnTriggerCharacters",t[t.suggestSelection=121]="suggestSelection",t[t.tabCompletion=122]="tabCompletion",t[t.tabIndex=123]="tabIndex",t[t.unicodeHighlighting=124]="unicodeHighlighting",t[t.unusualLineTerminators=125]="unusualLineTerminators",t[t.useShadowDOM=126]="useShadowDOM",t[t.useTabStops=127]="useTabStops",t[t.wordBreak=128]="wordBreak",t[t.wordSeparators=129]="wordSeparators",t[t.wordWrap=130]="wordWrap",t[t.wordWrapBreakAfterCharacters=131]="wordWrapBreakAfterCharacters",t[t.wordWrapBreakBeforeCharacters=132]="wordWrapBreakBeforeCharacters",t[t.wordWrapColumn=133]="wordWrapColumn",t[t.wordWrapOverride1=134]="wordWrapOverride1",t[t.wordWrapOverride2=135]="wordWrapOverride2",t[t.wrappingIndent=136]="wrappingIndent",t[t.wrappingStrategy=137]="wrappingStrategy",t[t.showDeprecated=138]="showDeprecated",t[t.inlayHints=139]="inlayHints",t[t.editorClassName=140]="editorClassName",t[t.pixelRatio=141]="pixelRatio",t[t.tabFocusMode=142]="tabFocusMode",t[t.layoutInfo=143]="layoutInfo",t[t.wrappingInfo=144]="wrappingInfo",t[t.defaultColorDecorators=145]="defaultColorDecorators",t[t.colorDecoratorsActivatedOn=146]="colorDecoratorsActivatedOn",t[t.inlineCompletionsAccessibilityVerbose=147]="inlineCompletionsAccessibilityVerbose"})(g||(n.EditorOption=g={}));var u;(function(t){t[t.TextDefined=0]="TextDefined",t[t.LF=1]="LF",t[t.CRLF=2]="CRLF"})(u||(n.EndOfLinePreference=u={}));var b;(function(t){t[t.LF=0]="LF",t[t.CRLF=1]="CRLF"})(b||(n.EndOfLineSequence=b={}));var h;(function(t){t[t.Left=1]="Left",t[t.Right=2]="Right"})(h||(n.GlyphMarginLane=h={}));var S;(function(t){t[t.None=0]="None",t[t.Indent=1]="Indent",t[t.IndentOutdent=2]="IndentOutdent",t[t.Outdent=3]="Outdent"})(S||(n.IndentAction=S={}));var v;(function(t){t[t.Both=0]="Both",t[t.Right=1]="Right",t[t.Left=2]="Left",t[t.None=3]="None"})(v||(n.InjectedTextCursorStops=v={}));var N;(function(t){t[t.Type=1]="Type",t[t.Parameter=2]="Parameter"})(N||(n.InlayHintKind=N={}));var y;(function(t){t[t.Automatic=0]="Automatic",t[t.Explicit=1]="Explicit"})(y||(n.InlineCompletionTriggerKind=y={}));var L;(function(t){t[t.DependsOnKbLayout=-1]="DependsOnKbLayout",t[t.Unknown=0]="Unknown",t[t.Backspace=1]="Backspace",t[t.Tab=2]="Tab",t[t.Enter=3]="Enter",t[t.Shift=4]="Shift",t[t.Ctrl=5]="Ctrl",t[t.Alt=6]="Alt",t[t.PauseBreak=7]="PauseBreak",t[t.CapsLock=8]="CapsLock",t[t.Escape=9]="Escape",t[t.Space=10]="Space",t[t.PageUp=11]="PageUp",t[t.PageDown=12]="PageDown",t[t.End=13]="End",t[t.Home=14]="Home",t[t.LeftArrow=15]="LeftArrow",t[t.UpArrow=16]="UpArrow",t[t.RightArrow=17]="RightArrow",t[t.DownArrow=18]="DownArrow",t[t.Insert=19]="Insert",t[t.Delete=20]="Delete",t[t.Digit0=21]="Digit0",t[t.Digit1=22]="Digit1",t[t.Digit2=23]="Digit2",t[t.Digit3=24]="Digit3",t[t.Digit4=25]="Digit4",t[t.Digit5=26]="Digit5",t[t.Digit6=27]="Digit6",t[t.Digit7=28]="Digit7",t[t.Digit8=29]="Digit8",t[t.Digit9=30]="Digit9",t[t.KeyA=31]="KeyA",t[t.KeyB=32]="KeyB",t[t.KeyC=33]="KeyC",t[t.KeyD=34]="KeyD",t[t.KeyE=35]="KeyE",t[t.KeyF=36]="KeyF",t[t.KeyG=37]="KeyG",t[t.KeyH=38]="KeyH",t[t.KeyI=39]="KeyI",t[t.KeyJ=40]="KeyJ",t[t.KeyK=41]="KeyK",t[t.KeyL=42]="KeyL",t[t.KeyM=43]="KeyM",t[t.KeyN=44]="KeyN",t[t.KeyO=45]="KeyO",t[t.KeyP=46]="KeyP",t[t.KeyQ=47]="KeyQ",t[t.KeyR=48]="KeyR",t[t.KeyS=49]="KeyS",t[t.KeyT=50]="KeyT",t[t.KeyU=51]="KeyU",t[t.KeyV=52]="KeyV",t[t.KeyW=53]="KeyW",t[t.KeyX=54]="KeyX",t[t.KeyY=55]="KeyY",t[t.KeyZ=56]="KeyZ",t[t.Meta=57]="Meta",t[t.ContextMenu=58]="ContextMenu",t[t.F1=59]="F1",t[t.F2=60]="F2",t[t.F3=61]="F3",t[t.F4=62]="F4",t[t.F5=63]="F5",t[t.F6=64]="F6",t[t.F7=65]="F7",t[t.F8=66]="F8",t[t.F9=67]="F9",t[t.F10=68]="F10",t[t.F11=69]="F11",t[t.F12=70]="F12",t[t.F13=71]="F13",t[t.F14=72]="F14",t[t.F15=73]="F15",t[t.F16=74]="F16",t[t.F17=75]="F17",t[t.F18=76]="F18",t[t.F19=77]="F19",t[t.F20=78]="F20",t[t.F21=79]="F21",t[t.F22=80]="F22",t[t.F23=81]="F23",t[t.F24=82]="F24",t[t.NumLock=83]="NumLock",t[t.ScrollLock=84]="ScrollLock",t[t.Semicolon=85]="Semicolon",t[t.Equal=86]="Equal",t[t.Comma=87]="Comma",t[t.Minus=88]="Minus",t[t.Period=89]="Period",t[t.Slash=90]="Slash",t[t.Backquote=91]="Backquote",t[t.BracketLeft=92]="BracketLeft",t[t.Backslash=93]="Backslash",t[t.BracketRight=94]="BracketRight",t[t.Quote=95]="Quote",t[t.OEM_8=96]="OEM_8",t[t.IntlBackslash=97]="IntlBackslash",t[t.Numpad0=98]="Numpad0",t[t.Numpad1=99]="Numpad1",t[t.Numpad2=100]="Numpad2",t[t.Numpad3=101]="Numpad3",t[t.Numpad4=102]="Numpad4",t[t.Numpad5=103]="Numpad5",t[t.Numpad6=104]="Numpad6",t[t.Numpad7=105]="Numpad7",t[t.Numpad8=106]="Numpad8",t[t.Numpad9=107]="Numpad9",t[t.NumpadMultiply=108]="NumpadMultiply",t[t.NumpadAdd=109]="NumpadAdd",t[t.NUMPAD_SEPARATOR=110]="NUMPAD_SEPARATOR",t[t.NumpadSubtract=111]="NumpadSubtract",t[t.NumpadDecimal=112]="NumpadDecimal",t[t.NumpadDivide=113]="NumpadDivide",t[t.KEY_IN_COMPOSITION=114]="KEY_IN_COMPOSITION",t[t.ABNT_C1=115]="ABNT_C1",t[t.ABNT_C2=116]="ABNT_C2",t[t.AudioVolumeMute=117]="AudioVolumeMute",t[t.AudioVolumeUp=118]="AudioVolumeUp",t[t.AudioVolumeDown=119]="AudioVolumeDown",t[t.BrowserSearch=120]="BrowserSearch",t[t.BrowserHome=121]="BrowserHome",t[t.BrowserBack=122]="BrowserBack",t[t.BrowserForward=123]="BrowserForward",t[t.MediaTrackNext=124]="MediaTrackNext",t[t.MediaTrackPrevious=125]="MediaTrackPrevious",t[t.MediaStop=126]="MediaStop",t[t.MediaPlayPause=127]="MediaPlayPause",t[t.LaunchMediaPlayer=128]="LaunchMediaPlayer",t[t.LaunchMail=129]="LaunchMail",t[t.LaunchApp2=130]="LaunchApp2",t[t.Clear=131]="Clear",t[t.MAX_VALUE=132]="MAX_VALUE"})(L||(n.KeyCode=L={}));var r;(function(t){t[t.Hint=1]="Hint",t[t.Info=2]="Info",t[t.Warning=4]="Warning",t[t.Error=8]="Error"})(r||(n.MarkerSeverity=r={}));var s;(function(t){t[t.Unnecessary=1]="Unnecessary",t[t.Deprecated=2]="Deprecated"})(s||(n.MarkerTag=s={}));var a;(function(t){t[t.Inline=1]="Inline",t[t.Gutter=2]="Gutter"})(a||(n.MinimapPosition=a={}));var p;(function(t){t[t.UNKNOWN=0]="UNKNOWN",t[t.TEXTAREA=1]="TEXTAREA",t[t.GUTTER_GLYPH_MARGIN=2]="GUTTER_GLYPH_MARGIN",t[t.GUTTER_LINE_NUMBERS=3]="GUTTER_LINE_NUMBERS",t[t.GUTTER_LINE_DECORATIONS=4]="GUTTER_LINE_DECORATIONS",t[t.GUTTER_VIEW_ZONE=5]="GUTTER_VIEW_ZONE",t[t.CONTENT_TEXT=6]="CONTENT_TEXT",t[t.CONTENT_EMPTY=7]="CONTENT_EMPTY",t[t.CONTENT_VIEW_ZONE=8]="CONTENT_VIEW_ZONE",t[t.CONTENT_WIDGET=9]="CONTENT_WIDGET",t[t.OVERVIEW_RULER=10]="OVERVIEW_RULER",t[t.SCROLLBAR=11]="SCROLLBAR",t[t.OVERLAY_WIDGET=12]="OVERLAY_WIDGET",t[t.OUTSIDE_EDITOR=13]="OUTSIDE_EDITOR"})(p||(n.MouseTargetType=p={}));var d;(function(t){t[t.TOP_RIGHT_CORNER=0]="TOP_RIGHT_CORNER",t[t.BOTTOM_RIGHT_CORNER=1]="BOTTOM_RIGHT_CORNER",t[t.TOP_CENTER=2]="TOP_CENTER"})(d||(n.OverlayWidgetPositionPreference=d={}));var w;(function(t){t[t.Left=1]="Left",t[t.Center=2]="Center",t[t.Right=4]="Right",t[t.Full=7]="Full"})(w||(n.OverviewRulerLane=w={}));var E;(function(t){t[t.Left=0]="Left",t[t.Right=1]="Right",t[t.None=2]="None",t[t.LeftOfInjectedText=3]="LeftOfInjectedText",t[t.RightOfInjectedText=4]="RightOfInjectedText"})(E||(n.PositionAffinity=E={}));var R;(function(t){t[t.Off=0]="Off",t[t.On=1]="On",t[t.Relative=2]="Relative",t[t.Interval=3]="Interval",t[t.Custom=4]="Custom"})(R||(n.RenderLineNumbersType=R={}));var D;(function(t){t[t.None=0]="None",t[t.Text=1]="Text",t[t.Blocks=2]="Blocks"})(D||(n.RenderMinimap=D={}));var F;(function(t){t[t.Smooth=0]="Smooth",t[t.Immediate=1]="Immediate"})(F||(n.ScrollType=F={}));var U;(function(t){t[t.Auto=1]="Auto",t[t.Hidden=2]="Hidden",t[t.Visible=3]="Visible"})(U||(n.ScrollbarVisibility=U={}));var I;(function(t){t[t.LTR=0]="LTR",t[t.RTL=1]="RTL"})(I||(n.SelectionDirection=I={}));var B;(function(t){t[t.Invoke=1]="Invoke",t[t.TriggerCharacter=2]="TriggerCharacter",t[t.ContentChange=3]="ContentChange"})(B||(n.SignatureHelpTriggerKind=B={}));var z;(function(t){t[t.File=0]="File",t[t.Module=1]="Module",t[t.Namespace=2]="Namespace",t[t.Package=3]="Package",t[t.Class=4]="Class",t[t.Method=5]="Method",t[t.Property=6]="Property",t[t.Field=7]="Field",t[t.Constructor=8]="Constructor",t[t.Enum=9]="Enum",t[t.Interface=10]="Interface",t[t.Function=11]="Function",t[t.Variable=12]="Variable",t[t.Constant=13]="Constant",t[t.String=14]="String",t[t.Number=15]="Number",t[t.Boolean=16]="Boolean",t[t.Array=17]="Array",t[t.Object=18]="Object",t[t.Key=19]="Key",t[t.Null=20]="Null",t[t.EnumMember=21]="EnumMember",t[t.Struct=22]="Struct",t[t.Event=23]="Event",t[t.Operator=24]="Operator",t[t.TypeParameter=25]="TypeParameter"})(z||(n.SymbolKind=z={}));var k;(function(t){t[t.Deprecated=1]="Deprecated"})(k||(n.SymbolTag=k={}));var q;(function(t){t[t.Hidden=0]="Hidden",t[t.Blink=1]="Blink",t[t.Smooth=2]="Smooth",t[t.Phase=3]="Phase",t[t.Expand=4]="Expand",t[t.Solid=5]="Solid"})(q||(n.TextEditorCursorBlinkingStyle=q={}));var x;(function(t){t[t.Line=1]="Line",t[t.Block=2]="Block",t[t.Underline=3]="Underline",t[t.LineThin=4]="LineThin",t[t.BlockOutline=5]="BlockOutline",t[t.UnderlineThin=6]="UnderlineThin"})(x||(n.TextEditorCursorStyle=x={}));var H;(function(t){t[t.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",t[t.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",t[t.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",t[t.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(H||(n.TrackedRangeStickiness=H={}));var V;(function(t){t[t.None=0]="None",t[t.Same=1]="Same",t[t.Indent=2]="Indent",t[t.DeepIndent=3]="DeepIndent"})(V||(n.WrappingIndent=V={}))}),Y(X[59],J([0,1,9,13]),function(T,n,M,A){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.TokenizationRegistry=void 0;class i{constructor(){this._tokenizationSupports=new Map,this._factories=new Map,this._onDidChange=new M.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}handleChange(_){this._onDidChange.fire({changedLanguages:_,changedColorMap:!1})}register(_,l){return this._tokenizationSupports.set(_,l),this.handleChange([_]),(0,A.toDisposable)(()=>{this._tokenizationSupports.get(_)===l&&(this._tokenizationSupports.delete(_),this.handleChange([_]))})}get(_){return this._tokenizationSupports.get(_)||null}registerFactory(_,l){var o;(o=this._factories.get(_))===null||o===void 0||o.dispose();const C=new c(this,_,l);return this._factories.set(_,C),(0,A.toDisposable)(()=>{const e=this._factories.get(_);!e||e!==C||(this._factories.delete(_),e.dispose())})}getOrCreate(_){return ue(this,void 0,void 0,function*(){const l=this.get(_);if(l)return l;const o=this._factories.get(_);return!o||o.isResolved?null:(yield o.resolve(),this.get(_))})}isResolved(_){if(this.get(_))return!0;const o=this._factories.get(_);return!!(!o||o.isResolved)}setColorMap(_){this._colorMap=_,this._onDidChange.fire({changedLanguages:Array.from(this._tokenizationSupports.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}n.TokenizationRegistry=i;class c extends A.Disposable{get isResolved(){return this._isResolved}constructor(_,l,o){super(),this._registry=_,this._languageId=l,this._factory=o,this._isDisposed=!1,this._resolvePromise=null,this._isResolved=!1}dispose(){this._isDisposed=!0,super.dispose()}resolve(){return ue(this,void 0,void 0,function*(){return this._resolvePromise||(this._resolvePromise=this._create()),this._resolvePromise})}_create(){return ue(this,void 0,void 0,function*(){const _=yield this._factory.tokenizationSupport;this._isResolved=!0,_&&!this._isDisposed&&this._register(this._registry.register(this._languageId,_))})}}}),Y(X[60],J([19,61]),function(T,n){return T.create("vs/base/common/platform",n)}),Y(X[17],J([0,1,60]),function(T,n,M){"use strict";var A;Object.defineProperty(n,"__esModule",{value:!0}),n.isAndroid=n.isEdge=n.isSafari=n.isFirefox=n.isChrome=n.isLittleEndian=n.OS=n.setTimeout0=n.setTimeout0IsFaster=n.language=n.userAgent=n.isMobile=n.isIOS=n.isWebWorker=n.isWeb=n.isNative=n.isLinux=n.isMacintosh=n.isWindows=n.globals=n.LANGUAGE_DEFAULT=void 0,n.LANGUAGE_DEFAULT="en";let i=!1,c=!1,f=!1,_=!1,l=!1,o=!1,C=!1,e=!1,m=!1,g=!1,u,b=n.LANGUAGE_DEFAULT,h=n.LANGUAGE_DEFAULT,S,v;n.globals=typeof self=="object"?self:typeof global=="object"?global:{};let N;typeof n.globals.vscode<"u"&&typeof n.globals.vscode.process<"u"?N=n.globals.vscode.process:typeof process<"u"&&(N=process);const y=typeof((A=N?.versions)===null||A===void 0?void 0:A.electron)=="string",L=y&&N?.type==="renderer";if(typeof navigator=="object"&&!L)v=navigator.userAgent,i=v.indexOf("Windows")>=0,c=v.indexOf("Macintosh")>=0,e=(v.indexOf("Macintosh")>=0||v.indexOf("iPad")>=0||v.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,f=v.indexOf("Linux")>=0,g=v?.indexOf("Mobi")>=0,o=!0,u=M.getConfiguredDefaultLocale(M.localize(0,null))||n.LANGUAGE_DEFAULT,b=u,h=navigator.language;else if(typeof N=="object"){i=N.platform==="win32",c=N.platform==="darwin",f=N.platform==="linux",_=f&&!!N.env.SNAP&&!!N.env.SNAP_REVISION,C=y,m=!!N.env.CI||!!N.env.BUILD_ARTIFACTSTAGINGDIRECTORY,u=n.LANGUAGE_DEFAULT,b=n.LANGUAGE_DEFAULT;const d=N.env.VSCODE_NLS_CONFIG;if(d)try{const w=JSON.parse(d),E=w.availableLanguages["*"];u=w.locale,h=w.osLocale,b=E||n.LANGUAGE_DEFAULT,S=w._translationsConfigFile}catch{}l=!0}else console.error("Unable to resolve platform.");let r=0;c?r=1:i?r=3:f&&(r=2),n.isWindows=i,n.isMacintosh=c,n.isLinux=f,n.isNative=l,n.isWeb=o,n.isWebWorker=o&&typeof n.globals.importScripts=="function",n.isIOS=e,n.isMobile=g,n.userAgent=v,n.language=b,n.setTimeout0IsFaster=typeof n.globals.postMessage=="function"&&!n.globals.importScripts,n.setTimeout0=(()=>{if(n.setTimeout0IsFaster){const d=[];n.globals.addEventListener("message",E=>{if(E.data&&E.data.vscodeScheduleAsyncWork)for(let R=0,D=d.length;R<D;R++){const F=d[R];if(F.id===E.data.vscodeScheduleAsyncWork){d.splice(R,1),F.callback();return}}});let w=0;return E=>{const R=++w;d.push({id:R,callback:E}),n.globals.postMessage({vscodeScheduleAsyncWork:R},"*")}}return d=>setTimeout(d)})(),n.OS=c||e?2:i?1:3;let s=!0,a=!1;function p(){if(!a){a=!0;const d=new Uint8Array(2);d[0]=1,d[1]=2,s=new Uint16Array(d.buffer)[0]===(2<<8)+1}return s}n.isLittleEndian=p,n.isChrome=!!(n.userAgent&&n.userAgent.indexOf("Chrome")>=0),n.isFirefox=!!(n.userAgent&&n.userAgent.indexOf("Firefox")>=0),n.isSafari=!!(!n.isChrome&&n.userAgent&&n.userAgent.indexOf("Safari")>=0),n.isEdge=!!(n.userAgent&&n.userAgent.indexOf("Edg/")>=0),n.isAndroid=!!(n.userAgent&&n.userAgent.indexOf("Android")>=0)}),Y(X[62],J([0,1,17]),function(T,n,M){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.platform=n.env=n.cwd=void 0;let A;if(typeof M.globals.vscode<"u"&&typeof M.globals.vscode.process<"u"){const i=M.globals.vscode.process;A={get platform(){return i.platform},get arch(){return i.arch},get env(){return i.env},cwd(){return i.cwd()}}}else typeof process<"u"?A={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:A={get platform(){return M.isWindows?"win32":M.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};n.cwd=A.cwd,n.env=A.env,n.platform=A.platform}),Y(X[63],J([0,1,62]),function(T,n,M){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.sep=n.extname=n.basename=n.dirname=n.relative=n.resolve=n.normalize=n.posix=n.win32=void 0;const A=65,i=97,c=90,f=122,_=46,l=47,o=92,C=58,e=63;class m extends Error{constructor(s,a,p){let d;typeof a=="string"&&a.indexOf("not ")===0?(d="must not be",a=a.replace(/^not /,"")):d="must be";const w=s.indexOf(".")!==-1?"property":"argument";let E=`The "${s}" ${w} ${d} of type ${a}`;E+=`. Received type ${typeof p}`,super(E),this.code="ERR_INVALID_ARG_TYPE"}}function g(r,s){if(r===null||typeof r!="object")throw new m(s,"Object",r)}function u(r,s){if(typeof r!="string")throw new m(s,"string",r)}const b=M.platform==="win32";function h(r){return r===l||r===o}function S(r){return r===l}function v(r){return r>=A&&r<=c||r>=i&&r<=f}function N(r,s,a,p){let d="",w=0,E=-1,R=0,D=0;for(let F=0;F<=r.length;++F){if(F<r.length)D=r.charCodeAt(F);else{if(p(D))break;D=l}if(p(D)){if(!(E===F-1||R===1))if(R===2){if(d.length<2||w!==2||d.charCodeAt(d.length-1)!==_||d.charCodeAt(d.length-2)!==_){if(d.length>2){const U=d.lastIndexOf(a);U===-1?(d="",w=0):(d=d.slice(0,U),w=d.length-1-d.lastIndexOf(a)),E=F,R=0;continue}else if(d.length!==0){d="",w=0,E=F,R=0;continue}}s&&(d+=d.length>0?`${a}..`:"..",w=2)}else d.length>0?d+=`${a}${r.slice(E+1,F)}`:d=r.slice(E+1,F),w=F-E-1;E=F,R=0}else D===_&&R!==-1?++R:R=-1}return d}function y(r,s){g(s,"pathObject");const a=s.dir||s.root,p=s.base||`${s.name||""}${s.ext||""}`;return a?a===s.root?`${a}${p}`:`${a}${r}${p}`:p}n.win32={resolve(...r){let s="",a="",p=!1;for(let d=r.length-1;d>=-1;d--){let w;if(d>=0){if(w=r[d],u(w,"path"),w.length===0)continue}else s.length===0?w=M.cwd():(w=M.env[`=${s}`]||M.cwd(),(w===void 0||w.slice(0,2).toLowerCase()!==s.toLowerCase()&&w.charCodeAt(2)===o)&&(w=`${s}\\`));const E=w.length;let R=0,D="",F=!1;const U=w.charCodeAt(0);if(E===1)h(U)&&(R=1,F=!0);else if(h(U))if(F=!0,h(w.charCodeAt(1))){let I=2,B=I;for(;I<E&&!h(w.charCodeAt(I));)I++;if(I<E&&I!==B){const z=w.slice(B,I);for(B=I;I<E&&h(w.charCodeAt(I));)I++;if(I<E&&I!==B){for(B=I;I<E&&!h(w.charCodeAt(I));)I++;(I===E||I!==B)&&(D=`\\\\${z}\\${w.slice(B,I)}`,R=I)}}}else R=1;else v(U)&&w.charCodeAt(1)===C&&(D=w.slice(0,2),R=2,E>2&&h(w.charCodeAt(2))&&(F=!0,R=3));if(D.length>0)if(s.length>0){if(D.toLowerCase()!==s.toLowerCase())continue}else s=D;if(p){if(s.length>0)break}else if(a=`${w.slice(R)}\\${a}`,p=F,F&&s.length>0)break}return a=N(a,!p,"\\",h),p?`${s}\\${a}`:`${s}${a}`||"."},normalize(r){u(r,"path");const s=r.length;if(s===0)return".";let a=0,p,d=!1;const w=r.charCodeAt(0);if(s===1)return S(w)?"\\":r;if(h(w))if(d=!0,h(r.charCodeAt(1))){let R=2,D=R;for(;R<s&&!h(r.charCodeAt(R));)R++;if(R<s&&R!==D){const F=r.slice(D,R);for(D=R;R<s&&h(r.charCodeAt(R));)R++;if(R<s&&R!==D){for(D=R;R<s&&!h(r.charCodeAt(R));)R++;if(R===s)return`\\\\${F}\\${r.slice(D)}\\`;R!==D&&(p=`\\\\${F}\\${r.slice(D,R)}`,a=R)}}}else a=1;else v(w)&&r.charCodeAt(1)===C&&(p=r.slice(0,2),a=2,s>2&&h(r.charCodeAt(2))&&(d=!0,a=3));let E=a<s?N(r.slice(a),!d,"\\",h):"";return E.length===0&&!d&&(E="."),E.length>0&&h(r.charCodeAt(s-1))&&(E+="\\"),p===void 0?d?`\\${E}`:E:d?`${p}\\${E}`:`${p}${E}`},isAbsolute(r){u(r,"path");const s=r.length;if(s===0)return!1;const a=r.charCodeAt(0);return h(a)||s>2&&v(a)&&r.charCodeAt(1)===C&&h(r.charCodeAt(2))},join(...r){if(r.length===0)return".";let s,a;for(let w=0;w<r.length;++w){const E=r[w];u(E,"path"),E.length>0&&(s===void 0?s=a=E:s+=`\\${E}`)}if(s===void 0)return".";let p=!0,d=0;if(typeof a=="string"&&h(a.charCodeAt(0))){++d;const w=a.length;w>1&&h(a.charCodeAt(1))&&(++d,w>2&&(h(a.charCodeAt(2))?++d:p=!1))}if(p){for(;d<s.length&&h(s.charCodeAt(d));)d++;d>=2&&(s=`\\${s.slice(d)}`)}return n.win32.normalize(s)},relative(r,s){if(u(r,"from"),u(s,"to"),r===s)return"";const a=n.win32.resolve(r),p=n.win32.resolve(s);if(a===p||(r=a.toLowerCase(),s=p.toLowerCase(),r===s))return"";let d=0;for(;d<r.length&&r.charCodeAt(d)===o;)d++;let w=r.length;for(;w-1>d&&r.charCodeAt(w-1)===o;)w--;const E=w-d;let R=0;for(;R<s.length&&s.charCodeAt(R)===o;)R++;let D=s.length;for(;D-1>R&&s.charCodeAt(D-1)===o;)D--;const F=D-R,U=E<F?E:F;let I=-1,B=0;for(;B<U;B++){const k=r.charCodeAt(d+B);if(k!==s.charCodeAt(R+B))break;k===o&&(I=B)}if(B!==U){if(I===-1)return p}else{if(F>U){if(s.charCodeAt(R+B)===o)return p.slice(R+B+1);if(B===2)return p.slice(R+B)}E>U&&(r.charCodeAt(d+B)===o?I=B:B===2&&(I=3)),I===-1&&(I=0)}let z="";for(B=d+I+1;B<=w;++B)(B===w||r.charCodeAt(B)===o)&&(z+=z.length===0?"..":"\\..");return R+=I,z.length>0?`${z}${p.slice(R,D)}`:(p.charCodeAt(R)===o&&++R,p.slice(R,D))},toNamespacedPath(r){if(typeof r!="string"||r.length===0)return r;const s=n.win32.resolve(r);if(s.length<=2)return r;if(s.charCodeAt(0)===o){if(s.charCodeAt(1)===o){const a=s.charCodeAt(2);if(a!==e&&a!==_)return`\\\\?\\UNC\\${s.slice(2)}`}}else if(v(s.charCodeAt(0))&&s.charCodeAt(1)===C&&s.charCodeAt(2)===o)return`\\\\?\\${s}`;return r},dirname(r){u(r,"path");const s=r.length;if(s===0)return".";let a=-1,p=0;const d=r.charCodeAt(0);if(s===1)return h(d)?r:".";if(h(d)){if(a=p=1,h(r.charCodeAt(1))){let R=2,D=R;for(;R<s&&!h(r.charCodeAt(R));)R++;if(R<s&&R!==D){for(D=R;R<s&&h(r.charCodeAt(R));)R++;if(R<s&&R!==D){for(D=R;R<s&&!h(r.charCodeAt(R));)R++;if(R===s)return r;R!==D&&(a=p=R+1)}}}}else v(d)&&r.charCodeAt(1)===C&&(a=s>2&&h(r.charCodeAt(2))?3:2,p=a);let w=-1,E=!0;for(let R=s-1;R>=p;--R)if(h(r.charCodeAt(R))){if(!E){w=R;break}}else E=!1;if(w===-1){if(a===-1)return".";w=a}return r.slice(0,w)},basename(r,s){s!==void 0&&u(s,"ext"),u(r,"path");let a=0,p=-1,d=!0,w;if(r.length>=2&&v(r.charCodeAt(0))&&r.charCodeAt(1)===C&&(a=2),s!==void 0&&s.length>0&&s.length<=r.length){if(s===r)return"";let E=s.length-1,R=-1;for(w=r.length-1;w>=a;--w){const D=r.charCodeAt(w);if(h(D)){if(!d){a=w+1;break}}else R===-1&&(d=!1,R=w+1),E>=0&&(D===s.charCodeAt(E)?--E===-1&&(p=w):(E=-1,p=R))}return a===p?p=R:p===-1&&(p=r.length),r.slice(a,p)}for(w=r.length-1;w>=a;--w)if(h(r.charCodeAt(w))){if(!d){a=w+1;break}}else p===-1&&(d=!1,p=w+1);return p===-1?"":r.slice(a,p)},extname(r){u(r,"path");let s=0,a=-1,p=0,d=-1,w=!0,E=0;r.length>=2&&r.charCodeAt(1)===C&&v(r.charCodeAt(0))&&(s=p=2);for(let R=r.length-1;R>=s;--R){const D=r.charCodeAt(R);if(h(D)){if(!w){p=R+1;break}continue}d===-1&&(w=!1,d=R+1),D===_?a===-1?a=R:E!==1&&(E=1):a!==-1&&(E=-1)}return a===-1||d===-1||E===0||E===1&&a===d-1&&a===p+1?"":r.slice(a,d)},format:y.bind(null,"\\"),parse(r){u(r,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(r.length===0)return s;const a=r.length;let p=0,d=r.charCodeAt(0);if(a===1)return h(d)?(s.root=s.dir=r,s):(s.base=s.name=r,s);if(h(d)){if(p=1,h(r.charCodeAt(1))){let I=2,B=I;for(;I<a&&!h(r.charCodeAt(I));)I++;if(I<a&&I!==B){for(B=I;I<a&&h(r.charCodeAt(I));)I++;if(I<a&&I!==B){for(B=I;I<a&&!h(r.charCodeAt(I));)I++;I===a?p=I:I!==B&&(p=I+1)}}}}else if(v(d)&&r.charCodeAt(1)===C){if(a<=2)return s.root=s.dir=r,s;if(p=2,h(r.charCodeAt(2))){if(a===3)return s.root=s.dir=r,s;p=3}}p>0&&(s.root=r.slice(0,p));let w=-1,E=p,R=-1,D=!0,F=r.length-1,U=0;for(;F>=p;--F){if(d=r.charCodeAt(F),h(d)){if(!D){E=F+1;break}continue}R===-1&&(D=!1,R=F+1),d===_?w===-1?w=F:U!==1&&(U=1):w!==-1&&(U=-1)}return R!==-1&&(w===-1||U===0||U===1&&w===R-1&&w===E+1?s.base=s.name=r.slice(E,R):(s.name=r.slice(E,w),s.base=r.slice(E,R),s.ext=r.slice(w,R))),E>0&&E!==p?s.dir=r.slice(0,E-1):s.dir=s.root,s},sep:"\\",delimiter:";",win32:null,posix:null};const L=(()=>{if(b){const r=/\\/g;return()=>{const s=M.cwd().replace(r,"/");return s.slice(s.indexOf("/"))}}return()=>M.cwd()})();n.posix={resolve(...r){let s="",a=!1;for(let p=r.length-1;p>=-1&&!a;p--){const d=p>=0?r[p]:L();u(d,"path"),d.length!==0&&(s=`${d}/${s}`,a=d.charCodeAt(0)===l)}return s=N(s,!a,"/",S),a?`/${s}`:s.length>0?s:"."},normalize(r){if(u(r,"path"),r.length===0)return".";const s=r.charCodeAt(0)===l,a=r.charCodeAt(r.length-1)===l;return r=N(r,!s,"/",S),r.length===0?s?"/":a?"./":".":(a&&(r+="/"),s?`/${r}`:r)},isAbsolute(r){return u(r,"path"),r.length>0&&r.charCodeAt(0)===l},join(...r){if(r.length===0)return".";let s;for(let a=0;a<r.length;++a){const p=r[a];u(p,"path"),p.length>0&&(s===void 0?s=p:s+=`/${p}`)}return s===void 0?".":n.posix.normalize(s)},relative(r,s){if(u(r,"from"),u(s,"to"),r===s||(r=n.posix.resolve(r),s=n.posix.resolve(s),r===s))return"";const a=1,p=r.length,d=p-a,w=1,E=s.length-w,R=d<E?d:E;let D=-1,F=0;for(;F<R;F++){const I=r.charCodeAt(a+F);if(I!==s.charCodeAt(w+F))break;I===l&&(D=F)}if(F===R)if(E>R){if(s.charCodeAt(w+F)===l)return s.slice(w+F+1);if(F===0)return s.slice(w+F)}else d>R&&(r.charCodeAt(a+F)===l?D=F:F===0&&(D=0));let U="";for(F=a+D+1;F<=p;++F)(F===p||r.charCodeAt(F)===l)&&(U+=U.length===0?"..":"/..");return`${U}${s.slice(w+D)}`},toNamespacedPath(r){return r},dirname(r){if(u(r,"path"),r.length===0)return".";const s=r.charCodeAt(0)===l;let a=-1,p=!0;for(let d=r.length-1;d>=1;--d)if(r.charCodeAt(d)===l){if(!p){a=d;break}}else p=!1;return a===-1?s?"/":".":s&&a===1?"//":r.slice(0,a)},basename(r,s){s!==void 0&&u(s,"ext"),u(r,"path");let a=0,p=-1,d=!0,w;if(s!==void 0&&s.length>0&&s.length<=r.length){if(s===r)return"";let E=s.length-1,R=-1;for(w=r.length-1;w>=0;--w){const D=r.charCodeAt(w);if(D===l){if(!d){a=w+1;break}}else R===-1&&(d=!1,R=w+1),E>=0&&(D===s.charCodeAt(E)?--E===-1&&(p=w):(E=-1,p=R))}return a===p?p=R:p===-1&&(p=r.length),r.slice(a,p)}for(w=r.length-1;w>=0;--w)if(r.charCodeAt(w)===l){if(!d){a=w+1;break}}else p===-1&&(d=!1,p=w+1);return p===-1?"":r.slice(a,p)},extname(r){u(r,"path");let s=-1,a=0,p=-1,d=!0,w=0;for(let E=r.length-1;E>=0;--E){const R=r.charCodeAt(E);if(R===l){if(!d){a=E+1;break}continue}p===-1&&(d=!1,p=E+1),R===_?s===-1?s=E:w!==1&&(w=1):s!==-1&&(w=-1)}return s===-1||p===-1||w===0||w===1&&s===p-1&&s===a+1?"":r.slice(s,p)},format:y.bind(null,"/"),parse(r){u(r,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(r.length===0)return s;const a=r.charCodeAt(0)===l;let p;a?(s.root="/",p=1):p=0;let d=-1,w=0,E=-1,R=!0,D=r.length-1,F=0;for(;D>=p;--D){const U=r.charCodeAt(D);if(U===l){if(!R){w=D+1;break}continue}E===-1&&(R=!1,E=D+1),U===_?d===-1?d=D:F!==1&&(F=1):d!==-1&&(F=-1)}if(E!==-1){const U=w===0&&a?1:w;d===-1||F===0||F===1&&d===E-1&&d===w+1?s.base=s.name=r.slice(U,E):(s.name=r.slice(U,d),s.base=r.slice(U,E),s.ext=r.slice(d,E))}return w>0?s.dir=r.slice(0,w-1):a&&(s.dir="/"),s},sep:"/",delimiter:":",win32:null,posix:null},n.posix.win32=n.win32.win32=n.win32,n.posix.posix=n.win32.posix=n.posix,n.normalize=b?n.win32.normalize:n.posix.normalize,n.resolve=b?n.win32.resolve:n.posix.resolve,n.relative=b?n.win32.relative:n.posix.relative,n.dirname=b?n.win32.dirname:n.posix.dirname,n.basename=b?n.win32.basename:n.posix.basename,n.extname=b?n.win32.extname:n.posix.extname,n.sep=b?n.win32.sep:n.posix.sep}),Y(X[18],J([0,1,63,17]),function(T,n,M,A){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.uriToFsPath=n.URI=void 0;const i=/^\w[\w\d+.-]*$/,c=/^\//,f=/^\/\//;function _(a,p){if(!a.scheme&&p)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${a.authority}", path: "${a.path}", query: "${a.query}", fragment: "${a.fragment}"}`);if(a.scheme&&!i.test(a.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(a.path){if(a.authority){if(!c.test(a.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(f.test(a.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function l(a,p){return!a&&!p?"file":a}function o(a,p){switch(a){case"https":case"http":case"file":p?p[0]!==e&&(p=e+p):p=e;break}return p}const C="",e="/",m=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class g{static isUri(p){return p instanceof g?!0:p?typeof p.authority=="string"&&typeof p.fragment=="string"&&typeof p.path=="string"&&typeof p.query=="string"&&typeof p.scheme=="string"&&typeof p.fsPath=="string"&&typeof p.with=="function"&&typeof p.toString=="function":!1}constructor(p,d,w,E,R,D=!1){typeof p=="object"?(this.scheme=p.scheme||C,this.authority=p.authority||C,this.path=p.path||C,this.query=p.query||C,this.fragment=p.fragment||C):(this.scheme=l(p,D),this.authority=d||C,this.path=o(this.scheme,w||C),this.query=E||C,this.fragment=R||C,_(this,D))}get fsPath(){return N(this,!1)}with(p){if(!p)return this;let{scheme:d,authority:w,path:E,query:R,fragment:D}=p;return d===void 0?d=this.scheme:d===null&&(d=C),w===void 0?w=this.authority:w===null&&(w=C),E===void 0?E=this.path:E===null&&(E=C),R===void 0?R=this.query:R===null&&(R=C),D===void 0?D=this.fragment:D===null&&(D=C),d===this.scheme&&w===this.authority&&E===this.path&&R===this.query&&D===this.fragment?this:new b(d,w,E,R,D)}static parse(p,d=!1){const w=m.exec(p);return w?new b(w[2]||C,s(w[4]||C),s(w[5]||C),s(w[7]||C),s(w[9]||C),d):new b(C,C,C,C,C)}static file(p){let d=C;if(A.isWindows&&(p=p.replace(/\\/g,e)),p[0]===e&&p[1]===e){const w=p.indexOf(e,2);w===-1?(d=p.substring(2),p=e):(d=p.substring(2,w),p=p.substring(w)||e)}return new b("file",d,p,C,C)}static from(p,d){return new b(p.scheme,p.authority,p.path,p.query,p.fragment,d)}static joinPath(p,...d){if(!p.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let w;return A.isWindows&&p.scheme==="file"?w=g.file(M.win32.join(N(p,!0),...d)).path:w=M.posix.join(p.path,...d),p.with({path:w})}toString(p=!1){return y(this,p)}toJSON(){return this}static revive(p){var d,w;if(p){if(p instanceof g)return p;{const E=new b(p);return E._formatted=(d=p.external)!==null&&d!==void 0?d:null,E._fsPath=p._sep===u&&(w=p.fsPath)!==null&&w!==void 0?w:null,E}}else return p}}n.URI=g;const u=A.isWindows?1:void 0;class b extends g{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=N(this,!1)),this._fsPath}toString(p=!1){return p?y(this,!0):(this._formatted||(this._formatted=y(this,!1)),this._formatted)}toJSON(){const p={$mid:1};return this._fsPath&&(p.fsPath=this._fsPath,p._sep=u),this._formatted&&(p.external=this._formatted),this.path&&(p.path=this.path),this.scheme&&(p.scheme=this.scheme),this.authority&&(p.authority=this.authority),this.query&&(p.query=this.query),this.fragment&&(p.fragment=this.fragment),p}}const h={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function S(a,p,d){let w,E=-1;for(let R=0;R<a.length;R++){const D=a.charCodeAt(R);if(D>=97&&D<=122||D>=65&&D<=90||D>=48&&D<=57||D===45||D===46||D===95||D===126||p&&D===47||d&&D===91||d&&D===93||d&&D===58)E!==-1&&(w+=encodeURIComponent(a.substring(E,R)),E=-1),w!==void 0&&(w+=a.charAt(R));else{w===void 0&&(w=a.substr(0,R));const F=h[D];F!==void 0?(E!==-1&&(w+=encodeURIComponent(a.substring(E,R)),E=-1),w+=F):E===-1&&(E=R)}}return E!==-1&&(w+=encodeURIComponent(a.substring(E))),w!==void 0?w:a}function v(a){let p;for(let d=0;d<a.length;d++){const w=a.charCodeAt(d);w===35||w===63?(p===void 0&&(p=a.substr(0,d)),p+=h[w]):p!==void 0&&(p+=a[d])}return p!==void 0?p:a}function N(a,p){let d;return a.authority&&a.path.length>1&&a.scheme==="file"?d=`//${a.authority}${a.path}`:a.path.charCodeAt(0)===47&&(a.path.charCodeAt(1)>=65&&a.path.charCodeAt(1)<=90||a.path.charCodeAt(1)>=97&&a.path.charCodeAt(1)<=122)&&a.path.charCodeAt(2)===58?p?d=a.path.substr(1):d=a.path[1].toLowerCase()+a.path.substr(2):d=a.path,A.isWindows&&(d=d.replace(/\//g,"\\")),d}n.uriToFsPath=N;function y(a,p){const d=p?v:S;let w="",{scheme:E,authority:R,path:D,query:F,fragment:U}=a;if(E&&(w+=E,w+=":"),(R||E==="file")&&(w+=e,w+=e),R){let I=R.indexOf("@");if(I!==-1){const B=R.substr(0,I);R=R.substr(I+1),I=B.lastIndexOf(":"),I===-1?w+=d(B,!1,!1):(w+=d(B.substr(0,I),!1,!1),w+=":",w+=d(B.substr(I+1),!1,!0)),w+="@"}R=R.toLowerCase(),I=R.lastIndexOf(":"),I===-1?w+=d(R,!1,!0):(w+=d(R.substr(0,I),!1,!0),w+=R.substr(I))}if(D){if(D.length>=3&&D.charCodeAt(0)===47&&D.charCodeAt(2)===58){const I=D.charCodeAt(1);I>=65&&I<=90&&(D=`/${String.fromCharCode(I+32)}:${D.substr(3)}`)}else if(D.length>=2&&D.charCodeAt(1)===58){const I=D.charCodeAt(0);I>=65&&I<=90&&(D=`${String.fromCharCode(I+32)}:${D.substr(2)}`)}w+=d(D,!0,!1)}return F&&(w+="?",w+=d(F,!1,!1)),U&&(w+="#",w+=p?U:S(U,!1,!1)),w}function L(a){try{return decodeURIComponent(a)}catch{return a.length>3?a.substr(0,3)+L(a.substr(3)):a}}const r=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function s(a){return a.match(r)?a.replace(r,p=>L(p)):a}}),Y(X[67],J([0,1,5,9,13,14,17,6]),function(T,n,M,A,i,c,f,_){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.create=n.SimpleWorkerServer=n.SimpleWorkerClient=n.logOnceWebWorkerWarning=void 0;const l="$initialize";let o=!1;function C(s){f.isWeb&&(o||(o=!0,console.warn("Could not create web worker(s). Falling back to loading web worker code in main thread, which might cause UI freezes. Please see https://github.com/microsoft/monaco-editor#faq")),console.warn(s.message))}n.logOnceWebWorkerWarning=C;class e{constructor(a,p,d,w){this.vsWorker=a,this.req=p,this.method=d,this.args=w,this.type=0}}class m{constructor(a,p,d,w){this.vsWorker=a,this.seq=p,this.res=d,this.err=w,this.type=1}}class g{constructor(a,p,d,w){this.vsWorker=a,this.req=p,this.eventName=d,this.arg=w,this.type=2}}class u{constructor(a,p,d){this.vsWorker=a,this.req=p,this.event=d,this.type=3}}class b{constructor(a,p){this.vsWorker=a,this.req=p,this.type=4}}class h{constructor(a){this._workerId=-1,this._handler=a,this._lastSentReq=0,this._pendingReplies=Object.create(null),this._pendingEmitters=new Map,this._pendingEvents=new Map}setWorkerId(a){this._workerId=a}sendMessage(a,p){const d=String(++this._lastSentReq);return new Promise((w,E)=>{this._pendingReplies[d]={resolve:w,reject:E},this._send(new e(this._workerId,d,a,p))})}listen(a,p){let d=null;const w=new A.Emitter({onWillAddFirstListener:()=>{d=String(++this._lastSentReq),this._pendingEmitters.set(d,w),this._send(new g(this._workerId,d,a,p))},onDidRemoveLastListener:()=>{this._pendingEmitters.delete(d),this._send(new b(this._workerId,d)),d=null}});return w.event}handleMessage(a){!a||!a.vsWorker||this._workerId!==-1&&a.vsWorker!==this._workerId||this._handleMessage(a)}_handleMessage(a){switch(a.type){case 1:return this._handleReplyMessage(a);case 0:return this._handleRequestMessage(a);case 2:return this._handleSubscribeEventMessage(a);case 3:return this._handleEventMessage(a);case 4:return this._handleUnsubscribeEventMessage(a)}}_handleReplyMessage(a){if(!this._pendingReplies[a.seq]){console.warn("Got reply to unknown seq");return}const p=this._pendingReplies[a.seq];if(delete this._pendingReplies[a.seq],a.err){let d=a.err;a.err.$isError&&(d=new Error,d.name=a.err.name,d.message=a.err.message,d.stack=a.err.stack),p.reject(d);return}p.resolve(a.res)}_handleRequestMessage(a){const p=a.req;this._handler.handleMessage(a.method,a.args).then(w=>{this._send(new m(this._workerId,p,w,void 0))},w=>{w.detail instanceof Error&&(w.detail=(0,M.transformErrorForSerialization)(w.detail)),this._send(new m(this._workerId,p,void 0,(0,M.transformErrorForSerialization)(w)))})}_handleSubscribeEventMessage(a){const p=a.req,d=this._handler.handleEvent(a.eventName,a.arg)(w=>{this._send(new u(this._workerId,p,w))});this._pendingEvents.set(p,d)}_handleEventMessage(a){if(!this._pendingEmitters.has(a.req)){console.warn("Got event for unknown req");return}this._pendingEmitters.get(a.req).fire(a.event)}_handleUnsubscribeEventMessage(a){if(!this._pendingEvents.has(a.req)){console.warn("Got unsubscribe for unknown req");return}this._pendingEvents.get(a.req).dispose(),this._pendingEvents.delete(a.req)}_send(a){const p=[];if(a.type===0)for(let d=0;d<a.args.length;d++)a.args[d]instanceof ArrayBuffer&&p.push(a.args[d]);else a.type===1&&a.res instanceof ArrayBuffer&&p.push(a.res);this._handler.sendMessage(a,p)}}class S extends i.Disposable{constructor(a,p,d){super();let w=null;this._worker=this._register(a.create("vs/base/common/worker/simpleWorker",I=>{this._protocol.handleMessage(I)},I=>{w?.(I)})),this._protocol=new h({sendMessage:(I,B)=>{this._worker.postMessage(I,B)},handleMessage:(I,B)=>{if(typeof d[I]!="function")return Promise.reject(new Error("Missing method "+I+" on main thread host."));try{return Promise.resolve(d[I].apply(d,B))}catch(z){return Promise.reject(z)}},handleEvent:(I,B)=>{if(N(I)){const z=d[I].call(d,B);if(typeof z!="function")throw new Error(`Missing dynamic event ${I} on main thread host.`);return z}if(v(I)){const z=d[I];if(typeof z!="function")throw new Error(`Missing event ${I} on main thread host.`);return z}throw new Error(`Malformed event name ${I}`)}}),this._protocol.setWorkerId(this._worker.getId());let E=null;const R=globalThis.require;typeof R<"u"&&typeof R.getConfig=="function"?E=R.getConfig():typeof globalThis.requirejs<"u"&&(E=globalThis.requirejs.s.contexts._.config);const D=(0,c.getAllMethodNames)(d);this._onModuleLoaded=this._protocol.sendMessage(l,[this._worker.getId(),JSON.parse(JSON.stringify(E)),p,D]);const F=(I,B)=>this._request(I,B),U=(I,B)=>this._protocol.listen(I,B);this._lazyProxy=new Promise((I,B)=>{w=B,this._onModuleLoaded.then(z=>{I(y(z,F,U))},z=>{B(z),this._onError("Worker failed to load "+p,z)})})}getProxyObject(){return this._lazyProxy}_request(a,p){return new Promise((d,w)=>{this._onModuleLoaded.then(()=>{this._protocol.sendMessage(a,p).then(d,w)},w)})}_onError(a,p){console.error(a),console.info(p)}}n.SimpleWorkerClient=S;function v(s){return s[0]==="o"&&s[1]==="n"&&_.isUpperAsciiLetter(s.charCodeAt(2))}function N(s){return/^onDynamic/.test(s)&&_.isUpperAsciiLetter(s.charCodeAt(9))}function y(s,a,p){const d=R=>function(){const D=Array.prototype.slice.call(arguments,0);return a(R,D)},w=R=>function(D){return p(R,D)},E={};for(const R of s){if(N(R)){E[R]=w(R);continue}if(v(R)){E[R]=p(R,void 0);continue}E[R]=d(R)}return E}class L{constructor(a,p){this._requestHandlerFactory=p,this._requestHandler=null,this._protocol=new h({sendMessage:(d,w)=>{a(d,w)},handleMessage:(d,w)=>this._handleMessage(d,w),handleEvent:(d,w)=>this._handleEvent(d,w)})}onmessage(a){this._protocol.handleMessage(a)}_handleMessage(a,p){if(a===l)return this.initialize(p[0],p[1],p[2],p[3]);if(!this._requestHandler||typeof this._requestHandler[a]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+a));try{return Promise.resolve(this._requestHandler[a].apply(this._requestHandler,p))}catch(d){return Promise.reject(d)}}_handleEvent(a,p){if(!this._requestHandler)throw new Error("Missing requestHandler");if(N(a)){const d=this._requestHandler[a].call(this._requestHandler,p);if(typeof d!="function")throw new Error(`Missing dynamic event ${a} on request handler.`);return d}if(v(a)){const d=this._requestHandler[a];if(typeof d!="function")throw new Error(`Missing event ${a} on request handler.`);return d}throw new Error(`Malformed event name ${a}`)}initialize(a,p,d,w){this._protocol.setWorkerId(a);const D=y(w,(F,U)=>this._protocol.sendMessage(F,U),(F,U)=>this._protocol.listen(F,U));return this._requestHandlerFactory?(this._requestHandler=this._requestHandlerFactory(D),Promise.resolve((0,c.getAllMethodNames)(this._requestHandler))):(p&&(typeof p.baseUrl<"u"&&delete p.baseUrl,typeof p.paths<"u"&&typeof p.paths.vs<"u"&&delete p.paths.vs,typeof p.trustedTypesPolicy!==void 0&&delete p.trustedTypesPolicy,p.catchError=!0,globalThis.require.config(p)),new Promise((F,U)=>{(globalThis.require||T)([d],B=>{if(this._requestHandler=B.create(D),!this._requestHandler){U(new Error("No RequestHandler!"));return}F((0,c.getAllMethodNames)(this._requestHandler))},U)}))}}n.SimpleWorkerServer=L;function r(s){return new L(s,null)}n.create=r}),Y(X[64],J([19,61]),function(T,n){return T.create("vs/editor/common/languages",n)}),Y(X[65],J([0,1,40,18,2,59,64]),function(T,n,M,A,i,c,f){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.TokenizationRegistry=n.LazyTokenizationSupport=n.InlayHintKind=n.Command=n.FoldingRangeKind=n.TextEdit=n.SymbolKinds=n.getAriaLabelForSymbol=n.symbolKindNames=n.isLocationLink=n.DocumentHighlightKind=n.SignatureHelpTriggerKind=n.SelectedSuggestionInfo=n.InlineCompletionTriggerKind=n.CompletionItemKinds=n.EncodedTokenizationResult=n.TokenizationResult=n.Token=void 0;class _{constructor(a,p,d){this.offset=a,this.type=p,this.language=d,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}n.Token=_;class l{constructor(a,p){this.tokens=a,this.endState=p,this._tokenizationResultBrand=void 0}}n.TokenizationResult=l;class o{constructor(a,p){this.tokens=a,this.endState=p,this._encodedTokenizationResultBrand=void 0}}n.EncodedTokenizationResult=o;var C;(function(s){const a=new Map;a.set(0,M.Codicon.symbolMethod),a.set(1,M.Codicon.symbolFunction),a.set(2,M.Codicon.symbolConstructor),a.set(3,M.Codicon.symbolField),a.set(4,M.Codicon.symbolVariable),a.set(5,M.Codicon.symbolClass),a.set(6,M.Codicon.symbolStruct),a.set(7,M.Codicon.symbolInterface),a.set(8,M.Codicon.symbolModule),a.set(9,M.Codicon.symbolProperty),a.set(10,M.Codicon.symbolEvent),a.set(11,M.Codicon.symbolOperator),a.set(12,M.Codicon.symbolUnit),a.set(13,M.Codicon.symbolValue),a.set(15,M.Codicon.symbolEnum),a.set(14,M.Codicon.symbolConstant),a.set(15,M.Codicon.symbolEnum),a.set(16,M.Codicon.symbolEnumMember),a.set(17,M.Codicon.symbolKeyword),a.set(27,M.Codicon.symbolSnippet),a.set(18,M.Codicon.symbolText),a.set(19,M.Codicon.symbolColor),a.set(20,M.Codicon.symbolFile),a.set(21,M.Codicon.symbolReference),a.set(22,M.Codicon.symbolCustomColor),a.set(23,M.Codicon.symbolFolder),a.set(24,M.Codicon.symbolTypeParameter),a.set(25,M.Codicon.account),a.set(26,M.Codicon.issues);function p(E){let R=a.get(E);return R||(console.info("No codicon found for CompletionItemKind "+E),R=M.Codicon.symbolProperty),R}s.toIcon=p;const d=new Map;d.set("method",0),d.set("function",1),d.set("constructor",2),d.set("field",3),d.set("variable",4),d.set("class",5),d.set("struct",6),d.set("interface",7),d.set("module",8),d.set("property",9),d.set("event",10),d.set("operator",11),d.set("unit",12),d.set("value",13),d.set("constant",14),d.set("enum",15),d.set("enum-member",16),d.set("enumMember",16),d.set("keyword",17),d.set("snippet",27),d.set("text",18),d.set("color",19),d.set("file",20),d.set("reference",21),d.set("customcolor",22),d.set("folder",23),d.set("type-parameter",24),d.set("typeParameter",24),d.set("account",25),d.set("issue",26);function w(E,R){let D=d.get(E);return typeof D>"u"&&!R&&(D=9),D}s.fromString=w})(C||(n.CompletionItemKinds=C={}));var e;(function(s){s[s.Automatic=0]="Automatic",s[s.Explicit=1]="Explicit"})(e||(n.InlineCompletionTriggerKind=e={}));class m{constructor(a,p,d,w){this.range=a,this.text=p,this.completionKind=d,this.isSnippetText=w}equals(a){return i.Range.lift(this.range).equalsRange(a.range)&&this.text===a.text&&this.completionKind===a.completionKind&&this.isSnippetText===a.isSnippetText}}n.SelectedSuggestionInfo=m;var g;(function(s){s[s.Invoke=1]="Invoke",s[s.TriggerCharacter=2]="TriggerCharacter",s[s.ContentChange=3]="ContentChange"})(g||(n.SignatureHelpTriggerKind=g={}));var u;(function(s){s[s.Text=0]="Text",s[s.Read=1]="Read",s[s.Write=2]="Write"})(u||(n.DocumentHighlightKind=u={}));function b(s){return s&&A.URI.isUri(s.uri)&&i.Range.isIRange(s.range)&&(i.Range.isIRange(s.originSelectionRange)||i.Range.isIRange(s.targetSelectionRange))}n.isLocationLink=b,n.symbolKindNames={[17]:(0,f.localize)(0,null),[16]:(0,f.localize)(1,null),[4]:(0,f.localize)(2,null),[13]:(0,f.localize)(3,null),[8]:(0,f.localize)(4,null),[9]:(0,f.localize)(5,null),[21]:(0,f.localize)(6,null),[23]:(0,f.localize)(7,null),[7]:(0,f.localize)(8,null),[0]:(0,f.localize)(9,null),[11]:(0,f.localize)(10,null),[10]:(0,f.localize)(11,null),[19]:(0,f.localize)(12,null),[5]:(0,f.localize)(13,null),[1]:(0,f.localize)(14,null),[2]:(0,f.localize)(15,null),[20]:(0,f.localize)(16,null),[15]:(0,f.localize)(17,null),[18]:(0,f.localize)(18,null),[24]:(0,f.localize)(19,null),[3]:(0,f.localize)(20,null),[6]:(0,f.localize)(21,null),[14]:(0,f.localize)(22,null),[22]:(0,f.localize)(23,null),[25]:(0,f.localize)(24,null),[12]:(0,f.localize)(25,null)};function h(s,a){return(0,f.localize)(26,null,s,n.symbolKindNames[a])}n.getAriaLabelForSymbol=h;var S;(function(s){const a=new Map;a.set(0,M.Codicon.symbolFile),a.set(1,M.Codicon.symbolModule),a.set(2,M.Codicon.symbolNamespace),a.set(3,M.Codicon.symbolPackage),a.set(4,M.Codicon.symbolClass),a.set(5,M.Codicon.symbolMethod),a.set(6,M.Codicon.symbolProperty),a.set(7,M.Codicon.symbolField),a.set(8,M.Codicon.symbolConstructor),a.set(9,M.Codicon.symbolEnum),a.set(10,M.Codicon.symbolInterface),a.set(11,M.Codicon.symbolFunction),a.set(12,M.Codicon.symbolVariable),a.set(13,M.Codicon.symbolConstant),a.set(14,M.Codicon.symbolString),a.set(15,M.Codicon.symbolNumber),a.set(16,M.Codicon.symbolBoolean),a.set(17,M.Codicon.symbolArray),a.set(18,M.Codicon.symbolObject),a.set(19,M.Codicon.symbolKey),a.set(20,M.Codicon.symbolNull),a.set(21,M.Codicon.symbolEnumMember),a.set(22,M.Codicon.symbolStruct),a.set(23,M.Codicon.symbolEvent),a.set(24,M.Codicon.symbolOperator),a.set(25,M.Codicon.symbolTypeParameter);function p(d){let w=a.get(d);return w||(console.info("No codicon found for SymbolKind "+d),w=M.Codicon.symbolProperty),w}s.toIcon=p})(S||(n.SymbolKinds=S={}));class v{}n.TextEdit=v;class N{static fromValue(a){switch(a){case"comment":return N.Comment;case"imports":return N.Imports;case"region":return N.Region}return new N(a)}constructor(a){this.value=a}}n.FoldingRangeKind=N,N.Comment=new N("comment"),N.Imports=new N("imports"),N.Region=new N("region");var y;(function(s){function a(p){return!p||typeof p!="object"?!1:typeof p.id=="string"&&typeof p.title=="string"}s.is=a})(y||(n.Command=y={}));var L;(function(s){s[s.Type=1]="Type",s[s.Parameter=2]="Parameter"})(L||(n.InlayHintKind=L={}));class r{constructor(a){this.createSupport=a,this._tokenizationSupport=null}dispose(){this._tokenizationSupport&&this._tokenizationSupport.then(a=>{a&&a.dispose()})}get tokenizationSupport(){return this._tokenizationSupport||(this._tokenizationSupport=this.createSupport()),this._tokenizationSupport}}n.LazyTokenizationSupport=r,n.TokenizationRegistry=new c.TokenizationRegistry}),Y(X[66],J([0,1,38,9,36,18,4,2,41,65,58]),function(T,n,M,A,i,c,f,_,l,o,C){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.createMonacoBaseAPI=n.KeyMod=void 0;class e{static chord(u,b){return(0,i.KeyChord)(u,b)}}n.KeyMod=e,e.CtrlCmd=2048,e.Shift=1024,e.Alt=512,e.WinCtrl=256;function m(){return{editor:void 0,languages:void 0,CancellationTokenSource:M.CancellationTokenSource,Emitter:A.Emitter,KeyCode:C.KeyCode,KeyMod:e,Position:f.Position,Range:_.Range,Selection:l.Selection,SelectionDirection:C.SelectionDirection,MarkerSeverity:C.MarkerSeverity,MarkerTag:C.MarkerTag,Uri:c.URI,Token:o.Token}}n.createMonacoBaseAPI=m}),Y(X[68],J([0,1,24,18,4,2,55,28,51,52,66,23,57,49,14,50]),function(T,n,M,A,i,c,f,_,l,o,C,e,m,g,u,b){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.create=n.EditorSimpleWorker=void 0;class h extends f.MirrorTextModel{get uri(){return this._uri}get eol(){return this._eol}getValue(){return this.getText()}findMatches(y){const L=[];for(let r=0;r<this._lines.length;r++){const s=this._lines[r],a=this.offsetAt(new i.Position(r+1,1)),p=s.matchAll(y);for(const d of p)(d.index||d.index===0)&&(d.index=d.index+a),L.push(d)}return L}getLinesContent(){return this._lines.slice(0)}getLineCount(){return this._lines.length}getLineContent(y){return this._lines[y-1]}getWordAtPosition(y,L){const r=(0,_.getWordAtText)(y.column,(0,_.ensureValidWordDefinition)(L),this._lines[y.lineNumber-1],0);return r?new c.Range(y.lineNumber,r.startColumn,y.lineNumber,r.endColumn):null}words(y){const L=this._lines,r=this._wordenize.bind(this);let s=0,a="",p=0,d=[];return{*[Symbol.iterator](){for(;;)if(p<d.length){const w=a.substring(d[p].start,d[p].end);p+=1,yield w}else if(s<L.length)a=L[s],d=r(a,y),p=0,s+=1;else break}}}getLineWords(y,L){const r=this._lines[y-1],s=this._wordenize(r,L),a=[];for(const p of s)a.push({word:r.substring(p.start,p.end),startColumn:p.start+1,endColumn:p.end+1});return a}_wordenize(y,L){const r=[];let s;for(L.lastIndex=0;(s=L.exec(y))&&s[0].length!==0;)r.push({start:s.index,end:s.index+s[0].length});return r}getValueInRange(y){if(y=this._validateRange(y),y.startLineNumber===y.endLineNumber)return this._lines[y.startLineNumber-1].substring(y.startColumn-1,y.endColumn-1);const L=this._eol,r=y.startLineNumber-1,s=y.endLineNumber-1,a=[];a.push(this._lines[r].substring(y.startColumn-1));for(let p=r+1;p<s;p++)a.push(this._lines[p]);return a.push(this._lines[s].substring(0,y.endColumn-1)),a.join(L)}offsetAt(y){return y=this._validatePosition(y),this._ensureLineStarts(),this._lineStarts.getPrefixSum(y.lineNumber-2)+(y.column-1)}positionAt(y){y=Math.floor(y),y=Math.max(0,y),this._ensureLineStarts();const L=this._lineStarts.getIndexOf(y),r=this._lines[L.index].length;return{lineNumber:1+L.index,column:1+Math.min(L.remainder,r)}}_validateRange(y){const L=this._validatePosition({lineNumber:y.startLineNumber,column:y.startColumn}),r=this._validatePosition({lineNumber:y.endLineNumber,column:y.endColumn});return L.lineNumber!==y.startLineNumber||L.column!==y.startColumn||r.lineNumber!==y.endLineNumber||r.column!==y.endColumn?{startLineNumber:L.lineNumber,startColumn:L.column,endLineNumber:r.lineNumber,endColumn:r.column}:y}_validatePosition(y){if(!i.Position.isIPosition(y))throw new Error("bad position");let{lineNumber:L,column:r}=y,s=!1;if(L<1)L=1,r=1,s=!0;else if(L>this._lines.length)L=this._lines.length,r=this._lines[L-1].length+1,s=!0;else{const a=this._lines[L-1].length+1;r<1?(r=1,s=!0):r>a&&(r=a,s=!0)}return s?{lineNumber:L,column:r}:y}}class S{constructor(y,L){this._host=y,this._models=Object.create(null),this._foreignModuleFactory=L,this._foreignModule=null}dispose(){this._models=Object.create(null)}_getModel(y){return this._models[y]}_getModels(){const y=[];return Object.keys(this._models).forEach(L=>y.push(this._models[L])),y}acceptNewModel(y){this._models[y.url]=new h(A.URI.parse(y.url),y.lines,y.EOL,y.versionId)}acceptModelChanged(y,L){if(!this._models[y])return;this._models[y].onEvents(L)}acceptRemovedModel(y){this._models[y]&&delete this._models[y]}computeUnicodeHighlights(y,L,r){return ue(this,void 0,void 0,function*(){const s=this._getModel(y);return s?m.UnicodeTextModelHighlighter.computeUnicodeHighlights(s,L,r):{ranges:[],hasMore:!1,ambiguousCharacterCount:0,invisibleCharacterCount:0,nonBasicAsciiCharacterCount:0}})}computeDiff(y,L,r,s){return ue(this,void 0,void 0,function*(){const a=this._getModel(y),p=this._getModel(L);return!a||!p?null:S.computeDiff(a,p,r,s)})}static computeDiff(y,L,r,s){const a=s==="advanced"?g.linesDiffComputers.getDefault():g.linesDiffComputers.getLegacy(),p=y.getLinesContent(),d=L.getLinesContent(),w=a.computeDiff(p,d,r),E=w.changes.length>0?!1:this._modelsAreIdentical(y,L);function R(D){return D.map(F=>{var U;return[F.original.startLineNumber,F.original.endLineNumberExclusive,F.modified.startLineNumber,F.modified.endLineNumberExclusive,(U=F.innerChanges)===null||U===void 0?void 0:U.map(I=>[I.originalRange.startLineNumber,I.originalRange.startColumn,I.originalRange.endLineNumber,I.originalRange.endColumn,I.modifiedRange.startLineNumber,I.modifiedRange.startColumn,I.modifiedRange.endLineNumber,I.modifiedRange.endColumn])]})}return{identical:E,quitEarly:w.hitTimeout,changes:R(w.changes),moves:w.moves.map(D=>[D.lineRangeMapping.original.startLineNumber,D.lineRangeMapping.original.endLineNumberExclusive,D.lineRangeMapping.modified.startLineNumber,D.lineRangeMapping.modified.endLineNumberExclusive,R(D.changes)])}}static _modelsAreIdentical(y,L){const r=y.getLineCount(),s=L.getLineCount();if(r!==s)return!1;for(let a=1;a<=r;a++){const p=y.getLineContent(a),d=L.getLineContent(a);if(p!==d)return!1}return!0}computeMoreMinimalEdits(y,L,r){return ue(this,void 0,void 0,function*(){const s=this._getModel(y);if(!s)return L;const a=[];let p;L=L.slice(0).sort((w,E)=>{if(w.range&&E.range)return c.Range.compareRangesUsingStarts(w.range,E.range);const R=w.range?0:1,D=E.range?0:1;return R-D});let d=0;for(let w=1;w<L.length;w++)c.Range.getEndPosition(L[d].range).equals(c.Range.getStartPosition(L[w].range))?(L[d].range=c.Range.fromPositions(c.Range.getStartPosition(L[d].range),c.Range.getEndPosition(L[w].range)),L[d].text+=L[w].text):(d++,L[d]=L[w]);L.length=d+1;for(let{range:w,text:E,eol:R}of L){if(typeof R=="number"&&(p=R),c.Range.isEmpty(w)&&!E)continue;const D=s.getValueInRange(w);if(E=E.replace(/\r\n|\n|\r/g,s.eol),D===E)continue;if(Math.max(E.length,D.length)>S._diffLimit){a.push({range:w,text:E});continue}const F=(0,M.stringDiff)(D,E,r),U=s.offsetAt(c.Range.lift(w).getStartPosition());for(const I of F){const B=s.positionAt(U+I.originalStart),z=s.positionAt(U+I.originalStart+I.originalLength),k={text:E.substr(I.modifiedStart,I.modifiedLength),range:{startLineNumber:B.lineNumber,startColumn:B.column,endLineNumber:z.lineNumber,endColumn:z.column}};s.getValueInRange(k.range)!==k.text&&a.push(k)}}return typeof p=="number"&&a.push({eol:p,text:"",range:{startLineNumber:0,startColumn:0,endLineNumber:0,endColumn:0}}),a})}computeLinks(y){return ue(this,void 0,void 0,function*(){const L=this._getModel(y);return L?(0,l.computeLinks)(L):null})}computeDefaultDocumentColors(y){return ue(this,void 0,void 0,function*(){const L=this._getModel(y);return L?(0,b.computeDefaultDocumentColors)(L):null})}textualSuggest(y,L,r,s){return ue(this,void 0,void 0,function*(){const a=new e.StopWatch,p=new RegExp(r,s),d=new Set;e:for(const w of y){const E=this._getModel(w);if(E){for(const R of E.words(p))if(!(R===L||!isNaN(Number(R)))&&(d.add(R),d.size>S._suggestionsLimit))break e}}return{words:Array.from(d),duration:a.elapsed()}})}computeWordRanges(y,L,r,s){return ue(this,void 0,void 0,function*(){const a=this._getModel(y);if(!a)return Object.create(null);const p=new RegExp(r,s),d=Object.create(null);for(let w=L.startLineNumber;w<L.endLineNumber;w++){const E=a.getLineWords(w,p);for(const R of E){if(!isNaN(Number(R.word)))continue;let D=d[R.word];D||(D=[],d[R.word]=D),D.push({startLineNumber:w,startColumn:R.startColumn,endLineNumber:w,endColumn:R.endColumn})}}return d})}navigateValueSet(y,L,r,s,a){return ue(this,void 0,void 0,function*(){const p=this._getModel(y);if(!p)return null;const d=new RegExp(s,a);L.startColumn===L.endColumn&&(L={startLineNumber:L.startLineNumber,startColumn:L.startColumn,endLineNumber:L.endLineNumber,endColumn:L.endColumn+1});const w=p.getValueInRange(L),E=p.getWordAtPosition({lineNumber:L.startLineNumber,column:L.startColumn},d);if(!E)return null;const R=p.getValueInRange(E);return o.BasicInplaceReplace.INSTANCE.navigateValueSet(L,w,E,R,r)})}loadForeignModule(y,L,r){const s=(d,w)=>this._host.fhr(d,w),p={host:(0,u.createProxyObject)(r,s),getMirrorModels:()=>this._getModels()};return this._foreignModuleFactory?(this._foreignModule=this._foreignModuleFactory(p,L),Promise.resolve((0,u.getAllMethodNames)(this._foreignModule))):new Promise((d,w)=>{T([y],E=>{this._foreignModule=E.create(p,L),d((0,u.getAllMethodNames)(this._foreignModule))},w)})}fmr(y,L){if(!this._foreignModule||typeof this._foreignModule[y]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+y));try{return Promise.resolve(this._foreignModule[y].apply(this._foreignModule,L))}catch(r){return Promise.reject(r)}}}n.EditorSimpleWorker=S,S._diffLimit=1e5,S._suggestionsLimit=1e4;function v(N){return new S(N,null)}n.create=v,typeof importScripts=="function"&&(globalThis.monaco=(0,C.createMonacoBaseAPI)())})}).call(this);

//# sourceMappingURL=../../../../min-maps/vs/base/worker/workerMain.js.map